/* Generated by: FreeCC 0.9.3. FTLLexer.java */
package ftl;

/** Token Manager */
@SuppressWarnings("unused")
public class FTLLexer implements FTLConstants {
    boolean syntaxEstablished,olderSyntax;
    boolean noWhitespaceInExpression,rightAfterHeader;
    int parenthesisNesting,bracketNesting,braceNesting;
    int lastMatchedTokenType;
    void CommonTokenAction(Token tok) {
        if (tok.kind==EOF) return;
        if (noWhitespaceInExpression&&parenthesisNesting==0&&braceNesting==0&&tok.specialToken!=null) {
            if (tok.specialToken.image.trim().length()==0) {
                Token copy=cloneToken(tok);
                copy.specialToken=null;
                copyFieldsOfToken(tok.specialToken,tok);
                tok.kind=BLANK;
                tok.next=copy;
                noWhitespaceInExpression=false;
                lastMatchedTokenType=tok.kind;
                return;
            }
        }
        char firstChar=tok.image.charAt(0);
        char lastChar=tok.image.charAt(tok.image.length()-1);
        boolean hasPointyDelimiter=firstChar=='<'||lastChar=='>';
        if (rightAfterHeader) {
            // chop off the newline after a <#ftl ...> header
            rightAfterHeader=false;
            if (tok.kind==WHITESPACE) {
                String img=tok.image;
                int idx=img.indexOf('\n');
                if (idx<0) idx=img.indexOf('\r');
                if (idx>=0) {
                    tok.image=img.substring(++idx);
                    tok.beginLine++;
                    tok.beginColumn=1;
                }
            }
        }
        switch(tok.kind) {
            case USER_DIRECTIVE_OPEN:
            case FTL_DIRECTIVE_OPEN:
            if (syntaxEstablished) {
                if (hasPointyDelimiter!=olderSyntax) {
                    tok.kind=PRINTABLE_CHARS;
                }
                else {
                    if (tok.kind==FTL_DIRECTIVE_OPEN) SwitchTo(FTL_DIRECTIVE);
                    else {
                        noWhitespaceInExpression=true;
                        SwitchTo(FTL_EXPRESSION);
                    }
                }
            }
            else {
                olderSyntax=(firstChar=='<');
                syntaxEstablished=true;
            }
            break;
            case CLOSE_TAG:
            case CLOSE_EMPTY_TAG:
            if (olderSyntax!=hasPointyDelimiter) tok.kind=PRINTABLE_CHARS;
            else SwitchTo(TEMPLATE_TEXT);
            break;
            case END_DIRECTIVE:
            if (olderSyntax!=hasPointyDelimiter) tok.kind=PRINTABLE_CHARS;
            else SwitchTo(TEMPLATE_TEXT);
            break;
            case END_USER_DIRECTIVE:
            if (hasPointyDelimiter!=olderSyntax) tok.kind=PRINTABLE_CHARS;
            break;
            case GT:
            case GTE:
            if (parenthesisNesting==0&&olderSyntax) {
                tok.kind=CLOSE_TAG;
                if (tok.kind==GTE) {
                    tok.image=">";
                    tok.endColumn--;
                    input_stream.backup(1);
                }
                SwitchTo(TEMPLATE_TEXT);
            }
            break;
            case OPEN_PAREN:
            parenthesisNesting++;
            break;
            case CLOSE_PAREN:
            parenthesisNesting--;
            break;
            case OPEN_BRACKET:
            bracketNesting++;
            break;
            case CLOSE_BRACKET:
            if (bracketNesting>0) {
                --bracketNesting;
            }
            else if (!olderSyntax) {
                tok.kind=CLOSE_TAG;
                SwitchTo(TEMPLATE_TEXT);
            }
            break;
            case OPEN_BRACE:
            braceNesting++;
            break;
            case CLOSE_BRACE:
            if (braceNesting>0) braceNesting--;
            else SwitchTo(TEMPLATE_TEXT);
            break;
            case END_COMMENT:
            if (hasPointyDelimiter!=olderSyntax) tok.kind=PRINTABLE_CHARS;
            else SwitchTo(TEMPLATE_TEXT);
            break;
            default:
            if (lastMatchedTokenType==DOT&&possibleIdentifier(tok.image)) {
                tok.kind=IDENTIFIER;
            }
        }
        lastMatchedTokenType=tok.kind;
    }

    private boolean possibleIdentifier(String s) {
        for(char c : s.toCharArray()) {
            if (c<'a'||c>'z') return false;
        }
        return true;
    }

    private void copyFieldsOfToken(Token src,Token dest) {
        dest.kind=src.kind;
        dest.image=src.image;
        dest.specialToken=src.specialToken;
        dest.next=src.next;
        dest.beginLine=src.beginLine;
        dest.beginColumn=src.beginColumn;
        dest.endLine=src.endLine;
        dest.endColumn=src.endColumn;
        dest.setInputSource(src.getInputSource());
    }

    private Token cloneToken(Token t) {
        Token result=Token.newToken(t.kind,t.image);
        copyFieldsOfToken(t,result);
        return result;
    }

    /** Debug output. */
    java.io.PrintStream debugStream=System.out;
    /** Set debug output. */
    public void setDebugStream(java.io.PrintStream ds) {
        debugStream=ds;
    }

    int[] jjemptyLineNo=new int[6];
    int[] jjemptyColNo=new int[6];
    boolean[] jjbeenHere=new boolean[6];
    int curLexState;
    int jjnewStateCnt;
    int jjround;
    int jjmatchedPos;
    int jjmatchedKind;
    private String inputSource="input";
    public String getInputSource() {
        return inputSource;
    }

    public void setInputSource(String inputSource) {
        this.inputSource=inputSource;
    }

    static final String[] lexStateNames={"TEMPLATE_TEXT","FTL_EXPRESSION","EXPRESSION_COMMENT","FTL_DIRECTIVE","IN_COMMENT","NO_PARSE",};
    /** Lex State array. */
    public static final int[] jjnewLexState={-1,-1,2,2,2,-1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,3,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,4,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,0,0,-1,-1,-1,0,};
    // Bit vector for TOKEN
    static final long[] jjtoToken={0xffcfffffffffff01L,0x57ffffffffffe1L,};
    // Bit vector for SKIP
    static final long[] jjtoSkip={0xc2L,0x0L,};
    // Bit vector for SPECIAL
    static final long[] jjtoSpecial={0xc0L,0x0L,};
    // Bit vector for MORE
    static final long[] jjtoMore={0x3cL,0x28000000000000L,};
    SimpleCharStream input_stream;
    private final int[] jjrounds=new int[37];
    private final int[] jjstateSet=new int[74];
    private final StringBuffer jjimage=new StringBuffer();
    private StringBuffer image=jjimage;
    private int jjimageLen;
    char curChar;
    /** Constructor. */
    public FTLLexer(SimpleCharStream stream) {
        input_stream=stream;
    }

    /** Constructor. */
    public FTLLexer(SimpleCharStream stream,int lexState) {
        this(stream);
        SwitchTo(lexState);
    }

    // Method to reinitialize the jjrounds array.
    private void ReInitRounds() {
        int i;
        jjround=0x80000001;
        for(i=37; 
        i-->0; 
        ) jjrounds[i]=0x80000000; 
    }

    /** Switch to specified lex state. */
    public void SwitchTo(int lexState) {
        if (lexState>=6||lexState<0) throw new LexicalException("Error: Ignoring invalid lexical state : "+lexState+". State unchanged.",LexicalException.INVALID_LEXICAL_STATE);
        else curLexState=lexState;
    }

    /** Get the next Token. */
    public Token getNextToken() {
        Token specialToken=null;
        Token matchedToken;
        int curPos=0;
        EOFLoop:
        while (true) {
            try {
                curChar=input_stream.BeginToken();
            }
            catch(java.io.IOException e) {
                jjmatchedKind=0;
                matchedToken=jjFillToken();
                CommonTokenAction(matchedToken);
                matchedToken.specialToken=specialToken;
                return matchedToken;
            }
            image=jjimage;
            image.setLength(0);
            jjimageLen=0;
            while (true) {
                switch(curLexState) {
                    case 0:
                    jjmatchedKind=0x7FFFFFFF;
                    jjmatchedPos=0;
                    curPos=jjMoveStringLiteralDfa0_TEMPLATE_TEXT();
                    break;
                    case 1:
                    jjmatchedKind=0x7FFFFFFF;
                    jjmatchedPos=0;
                    curPos=jjMoveStringLiteralDfa0_FTL_EXPRESSION();
                    break;
                    case 2:
                    jjmatchedKind=0x7FFFFFFF;
                    jjmatchedPos=0;
                    curPos=jjMoveStringLiteralDfa0_EXPRESSION_COMMENT();
                    break;
                    case 3:
                    jjmatchedKind=0x7FFFFFFF;
                    jjmatchedPos=0;
                    curPos=jjMoveStringLiteralDfa0_FTL_DIRECTIVE();
                    break;
                    case 4:
                    jjmatchedKind=0x7FFFFFFF;
                    jjmatchedPos=0;
                    curPos=jjMoveStringLiteralDfa0_IN_COMMENT();
                    break;
                    case 5:
                    jjmatchedKind=0x7FFFFFFF;
                    jjmatchedPos=0;
                    curPos=jjMoveStringLiteralDfa0_NO_PARSE();
                    break;
                }
                if (jjmatchedKind!=0x7FFFFFFF) {
                    if (jjmatchedPos+1<curPos) input_stream.backup(curPos-jjmatchedPos-1);
                    if ((jjtoToken[jjmatchedKind>>6]&(1L<<(jjmatchedKind&077)))!=0L) {
                        matchedToken=jjFillToken();
                        matchedToken.specialToken=specialToken;
                        TokenLexicalActions(matchedToken);
                        CommonTokenAction(matchedToken);
                        jjmatchedKind=matchedToken.kind;
                        if (jjnewLexState[jjmatchedKind]!=-1) {
                            curLexState=jjnewLexState[jjmatchedKind];
                        }
                        return matchedToken;
                    }
                    else if ((jjtoSkip[jjmatchedKind>>6]&(1L<<(jjmatchedKind&077)))!=0L) {
                        if ((jjtoSpecial[jjmatchedKind>>6]&(1L<<(jjmatchedKind&077)))!=0L) {
                            matchedToken=jjFillToken();
                            matchedToken.setUnparsed(true);
                            if (specialToken==null) {
                                specialToken=matchedToken;
                            }
                            else {
                                matchedToken.specialToken=specialToken;
                                specialToken=(specialToken.next=matchedToken);
                            }
                            TokenLexicalActions(matchedToken);
                        }
                        else TokenLexicalActions(null);
                        if (jjnewLexState[jjmatchedKind]!=-1) curLexState=jjnewLexState[jjmatchedKind];
                        continue EOFLoop;
                    }
                    jjimageLen+=jjmatchedPos+1;
                    if (jjnewLexState[jjmatchedKind]!=-1) curLexState=jjnewLexState[jjmatchedKind];
                    curPos=0;
                    jjmatchedKind=0x7FFFFFFF;
                    try {
                        curChar=input_stream.readChar();
                        continue;
                    }
                    catch(java.io.IOException e1) {
                    }
                }
                int error_line=input_stream.getEndLine();
                int error_column=input_stream.getEndColumn();
                String error_after=null;
                boolean EOFSeen=false;
                try {
                    input_stream.readChar();
                    input_stream.backup(1);
                }
                catch(java.io.IOException e1) {
                    EOFSeen=true;
                    error_after=curPos<=1?"":
                    input_stream.GetImage();
                    if (curChar=='\n'||curChar=='\r') {
                        error_line++;
                        error_column=0;
                    }
                    else error_column++;
                }
                if (!EOFSeen) {
                    input_stream.backup(1);
                    error_after=curPos<=1?"":
                    input_stream.GetImage();
                }
                throw new LexicalException(EOFSeen,curLexState,error_line,error_column,error_after,curChar,inputSource,LexicalException.LEXICAL_ERROR);
            }
        }
    }

    void TokenLexicalActions(Token matchedToken) {
        switch(jjmatchedKind) {
            default:
            break;
        }
    }

    Token jjFillToken() {
        final Token t;
        final String curTokenImage;
        final int beginLine;
        final int endLine;
        final int beginColumn;
        final int endColumn;
        curTokenImage=input_stream.GetImage();
        beginLine=input_stream.getBeginLine();
        beginColumn=input_stream.getBeginColumn();
        endLine=input_stream.getEndLine();
        endColumn=input_stream.getEndColumn();
        t=Token.newToken(jjmatchedKind,curTokenImage);
        t.beginLine=beginLine;
        t.endLine=endLine;
        t.beginColumn=beginColumn;
        t.endColumn=endColumn;
        t.setInputSource(this.inputSource);
        return t;
    }

    private void jjCheckNAdd(int state) {
        if (jjrounds[state]!=jjround) {
            jjstateSet[jjnewStateCnt++]=state;
            jjrounds[state]=jjround;
        }
    }

    private void jjAddStates(int start,int end) {
        do {
            jjstateSet[jjnewStateCnt++]=jjnextStates[start];
        }
        while (start++!=end);
    }

    private void jjCheckNAddTwoStates(int state1,int state2) {
        jjCheckNAdd(state1);
        jjCheckNAdd(state2);
    }

    private void jjCheckNAddStates(int start,int end) {
        do {
            jjCheckNAdd(jjnextStates[start]);
        }
        while (start++!=end);
    }

    private void jjCheckNAddStates(int start) {
        jjCheckNAdd(jjnextStates[start]);
        jjCheckNAdd(jjnextStates[start+1]);
    }

    private static boolean jjCanMove_0(int hiByte,int i1,int i2,long l1,long l2) {
        switch(hiByte) {
            case 0:
            return(jjbitVec2[i2]&l2)!=0L;
            default:
            if ((jjbitVec0[i1]&l1)!=0L) {
                return(jjbitVec1[i2]&l2)!=0L;
            }
            return false;
        }
    }

    private static boolean jjCanMove_1(int hiByte,int i1,int i2,long l1,long l2) {
        switch(hiByte) {
            case 0:
            return(jjbitVec4[i2]&l2)!=0L;
            case 48:
            return(jjbitVec5[i2]&l2)!=0L;
            case 49:
            return(jjbitVec6[i2]&l2)!=0L;
            case 51:
            return(jjbitVec7[i2]&l2)!=0L;
            case 61:
            return(jjbitVec8[i2]&l2)!=0L;
            default:
            if ((jjbitVec3[i1]&l1)!=0L) {
                return(jjbitVec1[i2]&l2)!=0L;
            }
            return false;
        }
    }

    private int jjStopAtPos(int pos,int kind) {
        jjmatchedKind=kind;
        jjmatchedPos=pos;
        return pos+1;
    }

    static final long[] jjbitVec0={0xfffffffffffffffeL,0xffffffffffffffffL,0xffffffffffffffffL,0xffffffffffffffffL};
    static final long[] jjbitVec1={0xffffffffffffffffL,0xffffffffffffffffL,0xffffffffffffffffL,0xffffffffffffffffL};
    static final long[] jjbitVec2={0x0L,0x0L,0xffffffffffffffffL,0xffffffffffffffffL};
    static final long[] jjbitVec3={0x1ff00000fffffffeL,0xffffffffffffc000L,0xffffffffL,0x600000000000000L};
    static final long[] jjbitVec4={0x0L,0x0L,0x0L,0xff7fffffff7fffffL};
    static final long[] jjbitVec5={0x0L,0xffffffffffffffffL,0xffffffffffffffffL,0xffffffffffffffffL};
    static final long[] jjbitVec6={0xffffffffffffffffL,0xffffffffffffffffL,0xffffL,0x0L};
    static final long[] jjbitVec7={0xffffffffffffffffL,0xffffffffffffffffL,0x0L,0x0L};
    static final long[] jjbitVec8={0x3fffffffffffL,0x0L,0x0L,0x0L};
    private int jjStartNfa_TEMPLATE_TEXT(int pos,long active0) {
        return jjMoveNfa_TEMPLATE_TEXT(jjStopStringLiteralDfa_TEMPLATE_TEXT(pos,active0),pos+1);
    }

    private final int jjStopStringLiteralDfa_TEMPLATE_TEXT(int pos,long active0) {
        switch(pos) {
            case 0:
            if ((active0&0x800000000000000L)!=0L) {
                jjmatchedKind=62;
                return 2;
            }
            if ((active0&0x400000000000000L)!=0L) {
                jjmatchedKind=61;
                return-1;
            }
            return-1;
            case 1:
            if ((active0&0x800000000000000L)!=0L) return 2;
            if ((active0&0x400000000000000L)!=0L) {
                if (jjmatchedPos==0) {
                    jjmatchedKind=61;
                    jjmatchedPos=0;
                }
                return-1;
            }
            return-1;
            default:
            return-1;
        }
    }

    private int jjStartNfaWithStates_TEMPLATE_TEXT(int pos,int kind,int state) {
        jjmatchedKind=kind;
        jjmatchedPos=pos;
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            return pos+1;
        }
        return jjMoveNfa_TEMPLATE_TEXT(state,pos+1);
    }

    private int jjMoveStringLiteralDfa0_TEMPLATE_TEXT() {
        switch(curChar) {
            case 35:
            return jjMoveStringLiteralDfa1_TEMPLATE_TEXT(0x800000000000000L);
            case 36:
            return jjMoveStringLiteralDfa1_TEMPLATE_TEXT(0x400000000000000L);
            default:
            return jjMoveNfa_TEMPLATE_TEXT(1,0);
        }
    }

    private int jjMoveStringLiteralDfa1_TEMPLATE_TEXT(long active0) {
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_TEMPLATE_TEXT(0,active0);
            return 1;
        }
        switch(curChar) {
            case 123:
            if ((active0&0x400000000000000L)!=0L) return jjStopAtPos(1,58);
            else if ((active0&0x800000000000000L)!=0L) return jjStartNfaWithStates_TEMPLATE_TEXT(1,59,2);
            break;
            default:
            break;
        }
        return jjStartNfa_TEMPLATE_TEXT(0,active0);
    }

    private int jjMoveNfa_TEMPLATE_TEXT(int startState,int curPos) {
        int startsAt=0;
        jjnewStateCnt=37;
        int i=1;
        jjstateSet[0]=startState;
        int kind=0x7fffffff;
        while (true) {
            if (++jjround==0x7fffffff) {
                ReInitRounds();
            }
            if (curChar<64) {
                long l=1L<<curChar;
                do {
                    switch(jjstateSet[--i]) {
                        case 1:
                        if ((0xefffffeeffffd9ffL&l)!=0L) {
                            if (kind>62) kind=62;
                            jjCheckNAdd(2);
                        }
                        else if ((0x100002600L&l)!=0L) {
                            if (kind>60) kind=60;
                            jjCheckNAdd(0);
                        }
                        else if ((0x1000001000000000L&l)!=0L) {
                            if (kind>61) kind=61;
                        }
                        if (curChar==60) jjAddStates(0,3);
                        break;
                        case 0:
                        if ((0x100002600L&l)==0L) break;
                        if (kind>60) kind=60;
                        jjCheckNAdd(0);
                        break;
                        case 2:
                        if ((0xefffffeeffffd9ffL&l)==0L) break;
                        if (kind>62) kind=62;
                        jjCheckNAdd(2);
                        break;
                        case 3:
                        if (curChar==60) jjCheckNAddStates(0,3);
                        break;
                        case 4:
                        if (curChar==35&&kind>56) kind=56;
                        break;
                        case 6:
                        if (curChar==35) jjCheckNAddStates(4,6);
                        break;
                        case 7:
                        if (curChar==36) jjCheckNAddStates(7,9);
                        break;
                        case 8:
                        if ((0x3ff001000000000L&l)!=0L) jjCheckNAddStates(7,9);
                        break;
                        case 9:
                        if ((0x100002600L&l)!=0L) jjCheckNAddTwoStates(9,10);
                        break;
                        case 10:
                        if (curChar==62&&kind>63) kind=63;
                        break;
                        case 11:
                        if (curChar==47) jjstateSet[jjnewStateCnt++]=6;
                        break;
                        case 13:
                        if (curChar==36) jjCheckNAddStates(10,13);
                        break;
                        case 14:
                        if ((0x3ff001000000000L&l)!=0L) jjCheckNAddStates(10,13);
                        break;
                        case 15:
                        if (curChar==46) jjstateSet[jjnewStateCnt++]=16;
                        break;
                        case 16:
                        if (curChar==36) jjCheckNAddStates(14,17);
                        break;
                        case 17:
                        if ((0x3ff001000000000L&l)!=0L) jjCheckNAddStates(14,17);
                        break;
                        case 18:
                        if ((0x100002600L&l)!=0L) jjCheckNAddTwoStates(18,19);
                        break;
                        case 19:
                        if (curChar==62&&kind>64) kind=64;
                        break;
                        case 20:
                        if (curChar==47) jjstateSet[jjnewStateCnt++]=12;
                        break;
                        case 22:
                        if (curChar==35) jjCheckNAddStates(18,20);
                        break;
                        case 23:
                        if (curChar==36) jjCheckNAddStates(21,23);
                        break;
                        case 24:
                        if ((0x3ff001000000000L&l)!=0L) jjCheckNAddStates(21,23);
                        break;
                        case 25:
                        if ((0x100002600L&l)!=0L) jjCheckNAddTwoStates(25,26);
                        break;
                        case 27:
                        if (curChar==47) jjstateSet[jjnewStateCnt++]=22;
                        break;
                        case 29:
                        if (curChar==36) jjCheckNAddStates(24,27);
                        break;
                        case 30:
                        if ((0x3ff001000000000L&l)!=0L) jjCheckNAddStates(24,27);
                        break;
                        case 31:
                        if (curChar==46) jjstateSet[jjnewStateCnt++]=32;
                        break;
                        case 32:
                        if (curChar==36) jjCheckNAddStates(28,31);
                        break;
                        case 33:
                        if ((0x3ff001000000000L&l)!=0L) jjCheckNAddStates(28,31);
                        break;
                        case 34:
                        if ((0x100002600L&l)!=0L) jjCheckNAddTwoStates(34,35);
                        break;
                        case 36:
                        if (curChar==47) jjstateSet[jjnewStateCnt++]=28;
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            else if (curChar<128) {
                long l=1L<<(curChar&077);
                do {
                    switch(jjstateSet[--i]) {
                        case 1:
                        if ((0xfffffffff7ffffffL&l)!=0L) {
                            if (kind>62) kind=62;
                            jjCheckNAdd(2);
                        }
                        else if (curChar==91) jjAddStates(32,35);
                        if (curChar==91) {
                            if (kind>61) kind=61;
                        }
                        break;
                        case 2:
                        if ((0xfffffffff7ffffffL&l)==0L) break;
                        if (kind>62) kind=62;
                        jjCheckNAdd(2);
                        break;
                        case 5:
                        if (curChar==64&&kind>57) kind=57;
                        break;
                        case 7:
                        if ((0x7fffffe87ffffffL&l)!=0L) jjCheckNAddStates(7,9);
                        break;
                        case 8:
                        if ((0x7fffffe87ffffffL&l)!=0L) jjCheckNAddStates(7,9);
                        break;
                        case 12:
                        if (curChar==64) jjCheckNAddStates(36,38);
                        break;
                        case 13:
                        if ((0x7fffffe87ffffffL&l)!=0L) jjCheckNAddStates(10,13);
                        break;
                        case 14:
                        if ((0x7fffffe87ffffffL&l)!=0L) jjCheckNAddStates(10,13);
                        break;
                        case 16:
                        if ((0x7fffffe87ffffffL&l)!=0L) jjCheckNAddStates(14,17);
                        break;
                        case 17:
                        if ((0x7fffffe87ffffffL&l)!=0L) jjCheckNAddStates(14,17);
                        break;
                        case 21:
                        if (curChar==91) jjCheckNAddStates(32,35);
                        break;
                        case 23:
                        if ((0x7fffffe87ffffffL&l)!=0L) jjCheckNAddStates(21,23);
                        break;
                        case 24:
                        if ((0x7fffffe87ffffffL&l)!=0L) jjCheckNAddStates(21,23);
                        break;
                        case 26:
                        if (curChar==93&&kind>63) kind=63;
                        break;
                        case 28:
                        if (curChar==64) jjCheckNAddStates(39,41);
                        break;
                        case 29:
                        if ((0x7fffffe87ffffffL&l)!=0L) jjCheckNAddStates(24,27);
                        break;
                        case 30:
                        if ((0x7fffffe87ffffffL&l)!=0L) jjCheckNAddStates(24,27);
                        break;
                        case 32:
                        if ((0x7fffffe87ffffffL&l)!=0L) jjCheckNAddStates(28,31);
                        break;
                        case 33:
                        if ((0x7fffffe87ffffffL&l)!=0L) jjCheckNAddStates(28,31);
                        break;
                        case 35:
                        if (curChar==93&&kind>64) kind=64;
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            else {
                int hiByte=(int)(curChar>>8);
                int i1=hiByte>>6;
                long l1=1L<<(hiByte&077);
                int i2=(curChar&0xff)>>6;
                long l2=1L<<(curChar&077);
                do {
                    switch(jjstateSet[--i]) {
                        case 1:
                        case 2:
                        if (!jjCanMove_0(hiByte,i1,i2,l1,l2)) break;
                        if (kind>62) kind=62;
                        jjCheckNAdd(2);
                        break;
                        case 7:
                        case 8:
                        if (jjCanMove_1(hiByte,i1,i2,l1,l2)) jjCheckNAddStates(7,9);
                        break;
                        case 13:
                        case 14:
                        if (jjCanMove_1(hiByte,i1,i2,l1,l2)) jjCheckNAddStates(10,13);
                        break;
                        case 16:
                        case 17:
                        if (jjCanMove_1(hiByte,i1,i2,l1,l2)) jjCheckNAddStates(14,17);
                        break;
                        case 23:
                        case 24:
                        if (jjCanMove_1(hiByte,i1,i2,l1,l2)) jjCheckNAddStates(21,23);
                        break;
                        case 29:
                        case 30:
                        if (jjCanMove_1(hiByte,i1,i2,l1,l2)) jjCheckNAddStates(24,27);
                        break;
                        case 32:
                        case 33:
                        if (jjCanMove_1(hiByte,i1,i2,l1,l2)) jjCheckNAddStates(28,31);
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            if (kind!=0x7fffffff) {
                jjmatchedKind=kind;
                jjmatchedPos=curPos;
                kind=0x7fffffff;
            }
            ++curPos;
            if ((i=jjnewStateCnt)==(startsAt=37-(jjnewStateCnt=startsAt))) return curPos;
            try {
                curChar=input_stream.readChar();
            }
            catch(java.io.IOException e) {
                return curPos;
            }
        }
    }

    private int jjStartNfa_FTL_EXPRESSION(int pos,long active0) {
        return jjMoveNfa_FTL_EXPRESSION(jjStopStringLiteralDfa_FTL_EXPRESSION(pos,active0),pos+1);
    }

    private final int jjStopStringLiteralDfa_FTL_EXPRESSION(int pos,long active0) {
        switch(pos) {
            case 0:
            if ((active0&0x1efc000000000L)!=0L) {
                jjmatchedKind=51;
                return 1;
            }
            if ((active0&0x80000L)!=0L) return 20;
            return-1;
            case 1:
            if ((active0&0xfc000000000L)!=0L) return 1;
            if ((active0&0x1e00000000000L)!=0L) {
                if (jjmatchedPos!=1) {
                    jjmatchedKind=51;
                    jjmatchedPos=1;
                }
                return 1;
            }
            return-1;
            case 2:
            if ((active0&0xc0000000000L)!=0L) return 1;
            if ((active0&0x1e00000000000L)!=0L) {
                jjmatchedKind=51;
                jjmatchedPos=2;
                return 1;
            }
            return-1;
            case 3:
            if ((active0&0x1800000000000L)!=0L) {
                jjmatchedKind=51;
                jjmatchedPos=3;
                return 1;
            }
            if ((active0&0x600000000000L)!=0L) return 1;
            return-1;
            case 4:
            if ((active0&0x1800000000000L)!=0L) return 1;
            return-1;
            default:
            return-1;
        }
    }

    private int jjStartNfaWithStates_FTL_EXPRESSION(int pos,int kind,int state) {
        jjmatchedKind=kind;
        jjmatchedPos=pos;
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            return pos+1;
        }
        return jjMoveNfa_FTL_EXPRESSION(state,pos+1);
    }

    private int jjMoveStringLiteralDfa0_FTL_EXPRESSION() {
        switch(curChar) {
            case 33:
            jjmatchedKind=28;
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x80000000L);
            case 37:
            return jjStopAtPos(0,20);
            case 38:
            jjmatchedKind=22;
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x1000000000L);
            case 40:
            return jjStopAtPos(0,8);
            case 41:
            return jjStopAtPos(0,9);
            case 42:
            return jjStopAtPos(0,18);
            case 43:
            return jjStopAtPos(0,16);
            case 44:
            return jjStopAtPos(0,25);
            case 45:
            return jjStopAtPos(0,17);
            case 46:
            jjmatchedKind=15;
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x102000000000L);
            case 47:
            return jjStartNfaWithStates_FTL_EXPRESSION(0,19,20);
            case 58:
            return jjStopAtPos(0,26);
            case 59:
            return jjStopAtPos(0,27);
            case 60:
            jjmatchedKind=23;
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x20000000cL);
            case 61:
            jjmatchedKind=14;
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x40000000L);
            case 62:
            jjmatchedKind=24;
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x400000000L);
            case 63:
            jjmatchedKind=29;
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x100000000L);
            case 91:
            jjmatchedKind=10;
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x10L);
            case 93:
            return jjStopAtPos(0,11);
            case 97:
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x10000000000L);
            case 102:
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x800000000000L);
            case 103:
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x44000000000L);
            case 105:
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x20000000000L);
            case 108:
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x88000000000L);
            case 110:
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x200000000000L);
            case 116:
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x400000000000L);
            case 117:
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x1000000000000L);
            case 123:
            return jjStopAtPos(0,12);
            case 124:
            jjmatchedKind=21;
            return jjMoveStringLiteralDfa1_FTL_EXPRESSION(0x800000000L);
            case 125:
            return jjStopAtPos(0,13);
            default:
            return jjMoveNfa_FTL_EXPRESSION(0,0);
        }
    }

    private int jjMoveStringLiteralDfa1_FTL_EXPRESSION(long active0) {
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_FTL_EXPRESSION(0,active0);
            return 1;
        }
        switch(curChar) {
            case 33:
            return jjMoveStringLiteralDfa2_FTL_EXPRESSION(active0,0x8L);
            case 35:
            return jjMoveStringLiteralDfa2_FTL_EXPRESSION(active0,0x14L);
            case 38:
            if ((active0&0x1000000000L)!=0L) return jjStopAtPos(1,36);
            break;
            case 46:
            if ((active0&0x2000000000L)!=0L) {
                jjmatchedKind=37;
                jjmatchedPos=1;
            }
            return jjMoveStringLiteralDfa2_FTL_EXPRESSION(active0,0x100000000000L);
            case 61:
            if ((active0&0x40000000L)!=0L) return jjStopAtPos(1,30);
            else if ((active0&0x80000000L)!=0L) return jjStopAtPos(1,31);
            else if ((active0&0x200000000L)!=0L) return jjStopAtPos(1,33);
            else if ((active0&0x400000000L)!=0L) return jjStopAtPos(1,34);
            break;
            case 63:
            if ((active0&0x100000000L)!=0L) return jjStopAtPos(1,32);
            break;
            case 97:
            return jjMoveStringLiteralDfa2_FTL_EXPRESSION(active0,0x800000000000L);
            case 110:
            if ((active0&0x20000000000L)!=0L) return jjStartNfaWithStates_FTL_EXPRESSION(1,41,1);
            break;
            case 114:
            return jjMoveStringLiteralDfa2_FTL_EXPRESSION(active0,0x400000000000L);
            case 115:
            if ((active0&0x10000000000L)!=0L) return jjStartNfaWithStates_FTL_EXPRESSION(1,40,1);
            return jjMoveStringLiteralDfa2_FTL_EXPRESSION(active0,0x1000000000000L);
            case 116:
            if ((active0&0x4000000000L)!=0L) {
                jjmatchedKind=38;
                jjmatchedPos=1;
            }
            else if ((active0&0x8000000000L)!=0L) {
                jjmatchedKind=39;
                jjmatchedPos=1;
            }
            return jjMoveStringLiteralDfa2_FTL_EXPRESSION(active0,0xc0000000000L);
            case 117:
            return jjMoveStringLiteralDfa2_FTL_EXPRESSION(active0,0x200000000000L);
            case 124:
            if ((active0&0x800000000L)!=0L) return jjStopAtPos(1,35);
            break;
            default:
            break;
        }
        return jjStartNfa_FTL_EXPRESSION(0,active0);
    }

    private int jjMoveStringLiteralDfa2_FTL_EXPRESSION(long old0,long active0) {
        active0=active0&old0;
        if ((active0)==0L) return jjStartNfa_FTL_EXPRESSION(0,old0);
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_FTL_EXPRESSION(1,active0);
            return 2;
        }
        switch(curChar) {
            case 45:
            return jjMoveStringLiteralDfa3_FTL_EXPRESSION(active0,0x1cL);
            case 46:
            if ((active0&0x100000000000L)!=0L) return jjStopAtPos(2,44);
            break;
            case 101:
            if ((active0&0x40000000000L)!=0L) return jjStartNfaWithStates_FTL_EXPRESSION(2,42,1);
            else if ((active0&0x80000000000L)!=0L) return jjStartNfaWithStates_FTL_EXPRESSION(2,43,1);
            break;
            case 105:
            return jjMoveStringLiteralDfa3_FTL_EXPRESSION(active0,0x1000000000000L);
            case 108:
            return jjMoveStringLiteralDfa3_FTL_EXPRESSION(active0,0xa00000000000L);
            case 117:
            return jjMoveStringLiteralDfa3_FTL_EXPRESSION(active0,0x400000000000L);
            default:
            break;
        }
        return jjStartNfa_FTL_EXPRESSION(1,active0);
    }

    private int jjMoveStringLiteralDfa3_FTL_EXPRESSION(long old0,long active0) {
        active0=active0&old0;
        if ((active0)==0L) return jjStartNfa_FTL_EXPRESSION(1,old0);
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_FTL_EXPRESSION(2,active0);
            return 3;
        }
        switch(curChar) {
            case 45:
            if ((active0&0x4L)!=0L) return jjStopAtPos(3,2);
            else if ((active0&0x8L)!=0L) return jjStopAtPos(3,3);
            else if ((active0&0x10L)!=0L) return jjStopAtPos(3,4);
            break;
            case 101:
            if ((active0&0x400000000000L)!=0L) return jjStartNfaWithStates_FTL_EXPRESSION(3,46,1);
            break;
            case 108:
            if ((active0&0x200000000000L)!=0L) return jjStartNfaWithStates_FTL_EXPRESSION(3,45,1);
            break;
            case 110:
            return jjMoveStringLiteralDfa4_FTL_EXPRESSION(active0,0x1000000000000L);
            case 115:
            return jjMoveStringLiteralDfa4_FTL_EXPRESSION(active0,0x800000000000L);
            default:
            break;
        }
        return jjStartNfa_FTL_EXPRESSION(2,active0);
    }

    private int jjMoveStringLiteralDfa4_FTL_EXPRESSION(long old0,long active0) {
        active0=active0&old0;
        if ((active0)==0L) return jjStartNfa_FTL_EXPRESSION(2,old0);
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_FTL_EXPRESSION(3,active0);
            return 4;
        }
        switch(curChar) {
            case 101:
            if ((active0&0x800000000000L)!=0L) return jjStartNfaWithStates_FTL_EXPRESSION(4,47,1);
            break;
            case 103:
            if ((active0&0x1000000000000L)!=0L) return jjStartNfaWithStates_FTL_EXPRESSION(4,48,1);
            break;
            default:
            break;
        }
        return jjStartNfa_FTL_EXPRESSION(3,active0);
    }

    private int jjMoveNfa_FTL_EXPRESSION(int startState,int curPos) {
        int startsAt=0;
        jjnewStateCnt=29;
        int i=1;
        jjstateSet[0]=startState;
        int kind=0x7fffffff;
        while (true) {
            if (++jjround==0x7fffffff) {
                ReInitRounds();
            }
            if (curChar<64) {
                long l=1L<<curChar;
                do {
                    switch(jjstateSet[--i]) {
                        case 0:
                        if ((0x3ff000000000000L&l)!=0L) {
                            if (kind>49) kind=49;
                            jjAddStates(42,44);
                        }
                        else if ((0x100002600L&l)!=0L) {
                            if (kind>1) kind=1;
                            jjAddStates(45,47);
                        }
                        else if (curChar==47) jjstateSet[jjnewStateCnt++]=20;
                        else if (curChar==39) jjCheckNAddStates(48,50);
                        else if (curChar==34) jjCheckNAddStates(51,53);
                        else if (curChar==36) {
                            if (kind>51) kind=51;
                            jjCheckNAdd(1);
                        }
                        break;
                        case 1:
                        if ((0x3ff001000000000L&l)==0L) break;
                        if (kind>51) kind=51;
                        jjCheckNAdd(1);
                        break;
                        case 2:
                        if (curChar==34) jjCheckNAddStates(51,53);
                        break;
                        case 4:
                        jjCheckNAddStates(51,53);
                        break;
                        case 5:
                        if ((0xfffffffbffffffffL&l)!=0L) jjCheckNAddStates(51,53);
                        break;
                        case 6:
                        if (curChar==34&&kind>54) kind=54;
                        break;
                        case 7:
                        if (curChar==39) jjCheckNAddStates(48,50);
                        break;
                        case 9:
                        jjCheckNAddStates(48,50);
                        break;
                        case 10:
                        if ((0xffffff7fffffffffL&l)!=0L) jjCheckNAddStates(48,50);
                        break;
                        case 11:
                        if (curChar==39&&kind>54) kind=54;
                        break;
                        case 13:
                        if (curChar==34) jjCheckNAddTwoStates(14,15);
                        break;
                        case 14:
                        if ((0xfffffffbffffffffL&l)!=0L) jjCheckNAddTwoStates(14,15);
                        break;
                        case 15:
                        if (curChar==34&&kind>55) kind=55;
                        break;
                        case 16:
                        if (curChar==39) jjCheckNAddTwoStates(17,18);
                        break;
                        case 17:
                        if ((0xffffff7fffffffffL&l)!=0L) jjCheckNAddTwoStates(17,18);
                        break;
                        case 18:
                        if (curChar==39&&kind>55) kind=55;
                        break;
                        case 19:
                        if (curChar==47) jjCheckNAdd(20);
                        break;
                        case 20:
                        if (curChar==62&&kind>114) kind=114;
                        break;
                        case 21:
                        if ((0x100002600L&l)==0L) break;
                        if (kind>1) kind=1;
                        jjCheckNAddStates(45,47);
                        break;
                        case 22:
                        if ((0x100002600L&l)==0L) break;
                        if (kind>1) kind=1;
                        jjCheckNAdd(22);
                        break;
                        case 23:
                        if ((0x100002600L&l)!=0L) jjCheckNAddTwoStates(23,19);
                        break;
                        case 24:
                        if ((0x3ff000000000000L&l)==0L) break;
                        if (kind>49) kind=49;
                        jjCheckNAddStates(42,44);
                        break;
                        case 25:
                        if ((0x3ff000000000000L&l)==0L) break;
                        if (kind>49) kind=49;
                        jjCheckNAdd(25);
                        break;
                        case 26:
                        if ((0x3ff000000000000L&l)!=0L) jjCheckNAddTwoStates(26,27);
                        break;
                        case 27:
                        if (curChar==46) jjstateSet[jjnewStateCnt++]=28;
                        break;
                        case 28:
                        if ((0x3ff000000000000L&l)==0L) break;
                        if (kind>50) kind=50;
                        jjCheckNAdd(28);
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            else if (curChar<128) {
                long l=1L<<(curChar&077);
                do {
                    switch(jjstateSet[--i]) {
                        case 0:
                        if ((0x7fffffe87ffffffL&l)!=0L) {
                            if (kind>51) kind=51;
                            jjCheckNAdd(1);
                        }
                        if (curChar==114) jjAddStates(54,55);
                        break;
                        case 1:
                        if ((0x7fffffe87ffffffL&l)==0L) break;
                        if (kind>51) kind=51;
                        jjCheckNAdd(1);
                        break;
                        case 3:
                        if (curChar==92) jjstateSet[jjnewStateCnt++]=4;
                        break;
                        case 4:
                        jjCheckNAddStates(51,53);
                        break;
                        case 5:
                        if ((0xffffffffefffffffL&l)!=0L) jjCheckNAddStates(51,53);
                        break;
                        case 8:
                        if (curChar==92) jjstateSet[jjnewStateCnt++]=9;
                        break;
                        case 9:
                        jjCheckNAddStates(48,50);
                        break;
                        case 10:
                        if ((0xffffffffefffffffL&l)!=0L) jjCheckNAddStates(48,50);
                        break;
                        case 12:
                        if (curChar==114) jjCheckNAddTwoStates(13,16);
                        break;
                        case 14:
                        jjCheckNAddTwoStates(14,15);
                        break;
                        case 17:
                        jjCheckNAddTwoStates(17,18);
                        break;
                        case 20:
                        if (curChar==93&&kind>114) kind=114;
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            else {
                int hiByte=(int)(curChar>>8);
                int i1=hiByte>>6;
                long l1=1L<<(hiByte&077);
                int i2=(curChar&0xff)>>6;
                long l2=1L<<(curChar&077);
                do {
                    switch(jjstateSet[--i]) {
                        case 0:
                        case 1:
                        if (!jjCanMove_1(hiByte,i1,i2,l1,l2)) break;
                        if (kind>51) kind=51;
                        jjCheckNAdd(1);
                        break;
                        case 4:
                        case 5:
                        if (jjCanMove_0(hiByte,i1,i2,l1,l2)) jjCheckNAddStates(51,53);
                        break;
                        case 9:
                        case 10:
                        if (jjCanMove_0(hiByte,i1,i2,l1,l2)) jjCheckNAddStates(48,50);
                        break;
                        case 14:
                        if (jjCanMove_0(hiByte,i1,i2,l1,l2)) jjCheckNAddTwoStates(14,15);
                        break;
                        case 17:
                        if (jjCanMove_0(hiByte,i1,i2,l1,l2)) jjCheckNAddTwoStates(17,18);
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            if (kind!=0x7fffffff) {
                jjmatchedKind=kind;
                jjmatchedPos=curPos;
                kind=0x7fffffff;
            }
            ++curPos;
            if ((i=jjnewStateCnt)==(startsAt=29-(jjnewStateCnt=startsAt))) return curPos;
            try {
                curChar=input_stream.readChar();
            }
            catch(java.io.IOException e) {
                return curPos;
            }
        }
    }

    private int jjStartNfa_EXPRESSION_COMMENT(int pos,long active0) {
        return jjMoveNfa_EXPRESSION_COMMENT(jjStopStringLiteralDfa_EXPRESSION_COMMENT(pos,active0),pos+1);
    }

    private final int jjStopStringLiteralDfa_EXPRESSION_COMMENT(int pos,long active0) {
        switch(pos) {
            case 0:
            if ((active0&0xc0L)!=0L) {
                jjmatchedKind=5;
                return-1;
            }
            return-1;
            case 1:
            if ((active0&0xc0L)!=0L) {
                if (jjmatchedPos==0) {
                    jjmatchedKind=5;
                    jjmatchedPos=0;
                }
                return-1;
            }
            return-1;
            case 2:
            if ((active0&0xc0L)!=0L) {
                if (jjmatchedPos==0) {
                    jjmatchedKind=5;
                    jjmatchedPos=0;
                }
                return-1;
            }
            return-1;
            default:
            return-1;
        }
    }

    private int jjStartNfaWithStates_EXPRESSION_COMMENT(int pos,int kind,int state) {
        jjmatchedKind=kind;
        jjmatchedPos=pos;
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            return pos+1;
        }
        return jjMoveNfa_EXPRESSION_COMMENT(state,pos+1);
    }

    private int jjMoveStringLiteralDfa0_EXPRESSION_COMMENT() {
        switch(curChar) {
            case 45:
            return jjMoveStringLiteralDfa1_EXPRESSION_COMMENT(0xc0L);
            default:
            return jjMoveNfa_EXPRESSION_COMMENT(0,0);
        }
    }

    private int jjMoveStringLiteralDfa1_EXPRESSION_COMMENT(long active0) {
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_EXPRESSION_COMMENT(0,active0);
            return 1;
        }
        switch(curChar) {
            case 45:
            return jjMoveStringLiteralDfa2_EXPRESSION_COMMENT(active0,0xc0L);
            default:
            break;
        }
        return jjStartNfa_EXPRESSION_COMMENT(0,active0);
    }

    private int jjMoveStringLiteralDfa2_EXPRESSION_COMMENT(long old0,long active0) {
        active0=active0&old0;
        if ((active0)==0L) return jjStartNfa_EXPRESSION_COMMENT(0,old0);
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_EXPRESSION_COMMENT(1,active0);
            return 2;
        }
        switch(curChar) {
            case 62:
            if ((active0&0x40L)!=0L) return jjStopAtPos(2,6);
            break;
            case 93:
            if ((active0&0x80L)!=0L) return jjStopAtPos(2,7);
            break;
            default:
            break;
        }
        return jjStartNfa_EXPRESSION_COMMENT(1,active0);
    }

    private int jjMoveNfa_EXPRESSION_COMMENT(int startState,int curPos) {
        int startsAt=0;
        jjnewStateCnt=1;
        int i=1;
        jjstateSet[0]=startState;
        int kind=0x7fffffff;
        while (true) {
            if (++jjround==0x7fffffff) {
                ReInitRounds();
            }
            if (curChar<64) {
                long l=1L<<curChar;
                do {
                    switch(jjstateSet[--i]) {
                        case 0:
                        kind=5;
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            else if (curChar<128) {
                long l=1L<<(curChar&077);
                do {
                    switch(jjstateSet[--i]) {
                        case 0:
                        kind=5;
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            else {
                int hiByte=(int)(curChar>>8);
                int i1=hiByte>>6;
                long l1=1L<<(hiByte&077);
                int i2=(curChar&0xff)>>6;
                long l2=1L<<(curChar&077);
                do {
                    switch(jjstateSet[--i]) {
                        case 0:
                        if (jjCanMove_0(hiByte,i1,i2,l1,l2)&&kind>5) kind=5;
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            if (kind!=0x7fffffff) {
                jjmatchedKind=kind;
                jjmatchedPos=curPos;
                kind=0x7fffffff;
            }
            ++curPos;
            if ((i=jjnewStateCnt)==(startsAt=1-(jjnewStateCnt=startsAt))) return curPos;
            try {
                curChar=input_stream.readChar();
            }
            catch(java.io.IOException e) {
                return curPos;
            }
        }
    }

    private int jjStartNfa_FTL_DIRECTIVE(int pos,long active0,long active1) {
        return jjMoveNfa_FTL_DIRECTIVE(jjStopStringLiteralDfa_FTL_DIRECTIVE(pos,active0,active1),pos+1);
    }

    private final int jjStopStringLiteralDfa_FTL_DIRECTIVE(int pos,long active0,long active1) {
        switch(pos) {
            default:
            return-1;
        }
    }

    private int jjStartNfaWithStates_FTL_DIRECTIVE(int pos,int kind,int state) {
        jjmatchedKind=kind;
        jjmatchedPos=pos;
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            return pos+1;
        }
        return jjMoveNfa_FTL_DIRECTIVE(state,pos+1);
    }

    private int jjMoveStringLiteralDfa0_FTL_DIRECTIVE() {
        switch(curChar) {
            case 45:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x40L);
            case 97:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x10040000000L);
            case 98:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x200000L);
            case 99:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x80000020000L);
            case 100:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x8000000L);
            case 101:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x180408000L);
            case 102:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x20c00100800L);
            case 103:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x20000000L);
            case 105:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x8004000400L);
            case 108:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x200000084080L);
            case 109:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x40000L);
            case 110:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x805000800200L);
            case 114:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x440210000100L);
            case 115:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x2002011000L);
            case 116:
            jjmatchedKind=69;
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x100000000000L);
            case 118:
            return jjMoveStringLiteralDfa1_FTL_DIRECTIVE(0x1002000L);
            default:
            return jjMoveNfa_FTL_DIRECTIVE(3,0);
        }
    }

    private int jjMoveStringLiteralDfa1_FTL_DIRECTIVE(long active1) {
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_FTL_DIRECTIVE(0,0L,active1);
            return 1;
        }
        switch(curChar) {
            case 45:
            if ((active1&0x40L)!=0L) return jjStopAtPos(1,70);
            break;
            case 95:
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0x100000000000L);
            case 97:
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0x800062000L);
            case 101:
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0x42218801000L);
            case 102:
            if ((active1&0x400L)!=0L) return jjStopAtPos(1,74);
            break;
            case 105:
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0x1004000L);
            case 108:
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0xa0108000L);
            case 109:
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0x4400000L);
            case 110:
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0x8000000000L);
            case 111:
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0xa5000080000L);
            case 114:
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0x200000L);
            case 115:
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0x140000000L);
            case 116:
            if ((active1&0x80L)!=0L) {
                jjmatchedKind=71;
                jjmatchedPos=1;
            }
            else if ((active1&0x100L)!=0L) {
                jjmatchedKind=72;
                jjmatchedPos=1;
            }
            else if ((active1&0x200L)!=0L) {
                jjmatchedKind=73;
                jjmatchedPos=1;
            }
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0xe10000010800L);
            case 117:
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0x400000000L);
            case 119:
            return jjMoveStringLiteralDfa2_FTL_DIRECTIVE(active1,0x2000000L);
            default:
            break;
        }
        return jjStartNfa_FTL_DIRECTIVE(0,0L,active1);
    }

    private int jjMoveStringLiteralDfa2_FTL_DIRECTIVE(long old1,long active1) {
        active1=active1&old1;
        if ((active1)==0L) return jjStartNfa_FTL_DIRECTIVE(0,0L,old1);
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_FTL_DIRECTIVE(1,0L,active1);
            return 2;
        }
        switch(curChar) {
            case 95:
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0xe00000000000L);
            case 98:
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x400000L);
            case 99:
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x483000c0000L);
            case 101:
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x1000200000L);
            case 102:
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x8000000L);
            case 105:
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x2000000L);
            case 108:
            if ((active1&0x800L)!=0L) return jjStopAtPos(2,75);
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x100800000000L);
            case 109:
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x80000000000L);
            case 110:
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x400000000L);
            case 111:
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x20010000L);
            case 112:
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x4004000000L);
            case 114:
            if ((active1&0x2000L)!=0L) return jjStopAtPos(2,77);
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x20000000000L);
            case 115:
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0xc182c000L);
            case 116:
            if ((active1&0x1000L)!=0L) {
                jjmatchedKind=76;
                jjmatchedPos=2;
            }
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x12010000000L);
            case 117:
            return jjMoveStringLiteralDfa3_FTL_DIRECTIVE(active1,0x100000L);
            default:
            break;
        }
        return jjStartNfa_FTL_DIRECTIVE(1,0L,active1);
    }

    private int jjMoveStringLiteralDfa3_FTL_DIRECTIVE(long old1,long active1) {
        active1=active1&old1;
        if ((active1)==0L) return jjStartNfa_FTL_DIRECTIVE(1,0L,old1);
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_FTL_DIRECTIVE(2,0L,active1);
            return 3;
        }
        switch(curChar) {
            case 97:
            return jjMoveStringLiteralDfa4_FTL_DIRECTIVE(active1,0x4108280000L);
            case 98:
            return jjMoveStringLiteralDfa4_FTL_DIRECTIVE(active1,0x20000000L);
            case 99:
            return jjMoveStringLiteralDfa4_FTL_DIRECTIVE(active1,0x400000000L);
            case 101:
            if ((active1&0x8000L)!=0L) {
                jjmatchedKind=79;
                jjmatchedPos=3;
            }
            else if ((active1&0x20000L)!=0L) return jjStopAtPos(3,81);
            return jjMoveStringLiteralDfa4_FTL_DIRECTIVE(active1,0x30080400000L);
            case 105:
            return jjMoveStringLiteralDfa4_FTL_DIRECTIVE(active1,0x100041000000L);
            case 108:
            return jjMoveStringLiteralDfa4_FTL_DIRECTIVE(active1,0xe08800000000L);
            case 111:
            return jjMoveStringLiteralDfa4_FTL_DIRECTIVE(active1,0x40004000000L);
            case 112:
            if ((active1&0x10000L)!=0L) return jjStopAtPos(3,80);
            return jjMoveStringLiteralDfa4_FTL_DIRECTIVE(active1,0x80000000000L);
            case 114:
            return jjMoveStringLiteralDfa4_FTL_DIRECTIVE(active1,0x40000L);
            case 115:
            return jjMoveStringLiteralDfa4_FTL_DIRECTIVE(active1,0x1000100000L);
            case 116:
            if ((active1&0x4000L)!=0L) return jjStopAtPos(3,78);
            return jjMoveStringLiteralDfa4_FTL_DIRECTIVE(active1,0x2002800000L);
            case 117:
            return jjMoveStringLiteralDfa4_FTL_DIRECTIVE(active1,0x210000000L);
            default:
            break;
        }
        return jjStartNfa_FTL_DIRECTIVE(2,0L,active1);
    }

    private int jjMoveStringLiteralDfa4_FTL_DIRECTIVE(long old1,long active1) {
        active1=active1&old1;
        if ((active1)==0L) return jjStartNfa_FTL_DIRECTIVE(2,0L,old1);
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_FTL_DIRECTIVE(3,0L,active1);
            return 4;
        }
        switch(curChar) {
            case 97:
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0x20020000000L);
            case 98:
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0x800000000L);
            case 99:
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0x1002000000L);
            case 100:
            if ((active1&0x400000L)!=0L) return jjStopAtPos(4,86);
            break;
            case 101:
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0x800000L);
            case 103:
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0x40000000L);
            case 104:
            if ((active1&0x100000L)!=0L) return jjStopAtPos(4,84);
            break;
            case 105:
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0xe02080000000L);
            case 107:
            if ((active1&0x200000L)!=0L) return jjStopAtPos(4,85);
            break;
            case 108:
            if ((active1&0x80000L)!=0L) return jjStopAtPos(4,83);
            break;
            case 109:
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0x10000000000L);
            case 110:
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0x100000000000L);
            case 111:
            if ((active1&0x40000L)!=0L) return jjStopAtPos(4,82);
            break;
            case 112:
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0x100000000L);
            case 114:
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0x84214000000L);
            case 116:
            if ((active1&0x1000000L)!=0L) return jjStopAtPos(4,88);
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0x400000000L);
            case 117:
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0x8008000000L);
            case 118:
            return jjMoveStringLiteralDfa5_FTL_DIRECTIVE(active1,0x40000000000L);
            default:
            break;
        }
        return jjStartNfa_FTL_DIRECTIVE(3,0L,active1);
    }

    private int jjMoveStringLiteralDfa5_FTL_DIRECTIVE(long old1,long active1) {
        active1=active1&old1;
        if ((active1)==0L) return jjStartNfa_FTL_DIRECTIVE(3,0L,old1);
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_FTL_DIRECTIVE(4,0L,active1);
            return 5;
        }
        switch(curChar) {
            case 97:
            return jjMoveStringLiteralDfa6_FTL_DIRECTIVE(active1,0x1800000000L);
            case 99:
            return jjMoveStringLiteralDfa6_FTL_DIRECTIVE(active1,0x20000000000L);
            case 100:
            if ((active1&0x800000L)!=0L) return jjStopAtPos(5,87);
            return jjMoveStringLiteralDfa6_FTL_DIRECTIVE(active1,0x8000000000L);
            case 101:
            if ((active1&0x100000000L)!=0L) return jjStopAtPos(5,96);
            return jjMoveStringLiteralDfa6_FTL_DIRECTIVE(active1,0x1c0000000000L);
            case 102:
            if ((active1&0x80000000L)!=0L) return jjStopAtPos(5,95);
            break;
            case 104:
            if ((active1&0x2000000L)!=0L) return jjStopAtPos(5,89);
            break;
            case 105:
            return jjMoveStringLiteralDfa6_FTL_DIRECTIVE(active1,0x400000000L);
            case 108:
            if ((active1&0x20000000L)!=0L) return jjStopAtPos(5,93);
            return jjMoveStringLiteralDfa6_FTL_DIRECTIVE(active1,0x8000000L);
            case 110:
            if ((active1&0x10000000L)!=0L) return jjStopAtPos(5,92);
            else if ((active1&0x40000000L)!=0L) return jjStopAtPos(5,94);
            return jjMoveStringLiteralDfa6_FTL_DIRECTIVE(active1,0xe02000000000L);
            case 112:
            return jjMoveStringLiteralDfa6_FTL_DIRECTIVE(active1,0x10000000000L);
            case 115:
            return jjMoveStringLiteralDfa6_FTL_DIRECTIVE(active1,0x4200000000L);
            case 116:
            if ((active1&0x4000000L)!=0L) return jjStopAtPos(5,90);
            break;
            default:
            break;
        }
        return jjStartNfa_FTL_DIRECTIVE(4,0L,active1);
    }

    private int jjMoveStringLiteralDfa6_FTL_DIRECTIVE(long old1,long active1) {
        active1=active1&old1;
        if ((active1)==0L) return jjStartNfa_FTL_DIRECTIVE(4,0L,old1);
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_FTL_DIRECTIVE(5,0L,active1);
            return 6;
        }
        switch(curChar) {
            case 99:
            return jjMoveStringLiteralDfa7_FTL_DIRECTIVE(active1,0x800000000L);
            case 101:
            if ((active1&0x200000000L)!=0L) return jjStopAtPos(6,97);
            else if ((active1&0x4000000000L)!=0L) return jjStopAtPos(6,102);
            else if ((active1&0x8000000000L)!=0L) return jjStopAtPos(6,103);
            return jjMoveStringLiteralDfa7_FTL_DIRECTIVE(active1,0xe00000000000L);
            case 103:
            if ((active1&0x2000000000L)!=0L) return jjStopAtPos(6,101);
            break;
            case 104:
            if ((active1&0x20000000000L)!=0L) return jjStopAtPos(6,105);
            break;
            case 111:
            return jjMoveStringLiteralDfa7_FTL_DIRECTIVE(active1,0x400000000L);
            case 112:
            return jjMoveStringLiteralDfa7_FTL_DIRECTIVE(active1,0x1000000000L);
            case 114:
            if ((active1&0x40000000000L)!=0L) return jjStopAtPos(6,106);
            break;
            case 115:
            if ((active1&0x100000000000L)!=0L) return jjStopAtPos(6,108);
            return jjMoveStringLiteralDfa7_FTL_DIRECTIVE(active1,0x80000000000L);
            case 116:
            if ((active1&0x8000000L)!=0L) return jjStopAtPos(6,91);
            else if ((active1&0x10000000000L)!=0L) return jjStopAtPos(6,104);
            break;
            default:
            break;
        }
        return jjStartNfa_FTL_DIRECTIVE(5,0L,active1);
    }

    private int jjMoveStringLiteralDfa7_FTL_DIRECTIVE(long old1,long active1) {
        active1=active1&old1;
        if ((active1)==0L) return jjStartNfa_FTL_DIRECTIVE(5,0L,old1);
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            jjStopStringLiteralDfa_FTL_DIRECTIVE(6,0L,active1);
            return 7;
        }
        switch(curChar) {
            case 101:
            if ((active1&0x1000000000L)!=0L) return jjStopAtPos(7,100);
            break;
            case 107:
            if ((active1&0x800000000L)!=0L) return jjStopAtPos(7,99);
            break;
            case 110:
            if ((active1&0x400000000L)!=0L) return jjStopAtPos(7,98);
            break;
            case 115:
            if ((active1&0x80000000000L)!=0L) return jjStopAtPos(7,107);
            else if ((active1&0x200000000000L)!=0L) return jjStopAtPos(7,109);
            else if ((active1&0x400000000000L)!=0L) return jjStopAtPos(7,110);
            else if ((active1&0x800000000000L)!=0L) return jjStopAtPos(7,111);
            break;
            default:
            break;
        }
        return jjStartNfa_FTL_DIRECTIVE(6,0L,active1);
    }

    private int jjMoveNfa_FTL_DIRECTIVE(int startState,int curPos) {
        int startsAt=0;
        jjnewStateCnt=6;
        int i=1;
        jjstateSet[0]=startState;
        int kind=0x7fffffff;
        while (true) {
            if (++jjround==0x7fffffff) {
                ReInitRounds();
            }
            if (curChar<64) {
                long l=1L<<curChar;
                do {
                    switch(jjstateSet[--i]) {
                        case 3:
                        if ((0x100002600L&l)!=0L) {
                            if (kind>112) kind=112;
                            jjAddStates(56,59);
                        }
                        else if (curChar==47) jjstateSet[jjnewStateCnt++]=2;
                        else if (curChar==62) {
                            if (kind>113) kind=113;
                        }
                        break;
                        case 0:
                        if (curChar==62&&kind>113) kind=113;
                        break;
                        case 1:
                        if (curChar==47) jjCheckNAdd(2);
                        break;
                        case 2:
                        if (curChar==62&&kind>114) kind=114;
                        break;
                        case 4:
                        if ((0x100002600L&l)!=0L) jjCheckNAddTwoStates(4,0);
                        break;
                        case 5:
                        if ((0x100002600L&l)!=0L) jjCheckNAddTwoStates(5,1);
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            else if (curChar<128) {
                long l=1L<<(curChar&077);
                do {
                    switch(jjstateSet[--i]) {
                        case 3:
                        case 0:
                        if (curChar==93&&kind>113) kind=113;
                        break;
                        case 2:
                        if (curChar==93&&kind>114) kind=114;
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            else {
                int hiByte=(int)(curChar>>8);
                int i1=hiByte>>6;
                long l1=1L<<(hiByte&077);
                int i2=(curChar&0xff)>>6;
                long l2=1L<<(curChar&077);
                do {
                    switch(jjstateSet[--i]) {
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            if (kind!=0x7fffffff) {
                jjmatchedKind=kind;
                jjmatchedPos=curPos;
                kind=0x7fffffff;
            }
            ++curPos;
            if ((i=jjnewStateCnt)==(startsAt=6-(jjnewStateCnt=startsAt))) return curPos;
            try {
                curChar=input_stream.readChar();
            }
            catch(java.io.IOException e) {
                return curPos;
            }
        }
    }

    private int jjStartNfaWithStates_IN_COMMENT(int pos,int kind,int state) {
        jjmatchedKind=kind;
        jjmatchedPos=pos;
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            return pos+1;
        }
        return jjMoveNfa_IN_COMMENT(state,pos+1);
    }

    private int jjMoveStringLiteralDfa0_IN_COMMENT() {
        return jjMoveNfa_IN_COMMENT(0,0);
    }

    private int jjMoveNfa_IN_COMMENT(int startState,int curPos) {
        int startsAt=0;
        jjnewStateCnt=6;
        int i=1;
        jjstateSet[0]=startState;
        int kind=0x7fffffff;
        while (true) {
            if (++jjround==0x7fffffff) {
                ReInitRounds();
            }
            if (curChar<64) {
                long l=1L<<curChar;
                do {
                    switch(jjstateSet[--i]) {
                        case 0:
                         {
                            if (kind>115) kind=115;
                        }
                        if (curChar==45) jjAddStates(60,61);
                        break;
                        case 1:
                        if (curChar==45) jjCheckNAddTwoStates(3,5);
                        break;
                        case 2:
                        if (curChar==62&&kind>116) kind=116;
                        break;
                        case 3:
                        if (curChar==45) jjstateSet[jjnewStateCnt++]=2;
                        break;
                        case 5:
                        if (curChar==45) jjstateSet[jjnewStateCnt++]=4;
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            else if (curChar<128) {
                long l=1L<<(curChar&077);
                do {
                    switch(jjstateSet[--i]) {
                        case 0:
                        if (kind>115) kind=115;
                        break;
                        case 4:
                        if (curChar==93&&kind>116) kind=116;
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            else {
                int hiByte=(int)(curChar>>8);
                int i1=hiByte>>6;
                long l1=1L<<(hiByte&077);
                int i2=(curChar&0xff)>>6;
                long l2=1L<<(curChar&077);
                do {
                    switch(jjstateSet[--i]) {
                        case 0:
                        if (jjCanMove_0(hiByte,i1,i2,l1,l2)&&kind>115) kind=115;
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            if (kind!=0x7fffffff) {
                jjmatchedKind=kind;
                jjmatchedPos=curPos;
                kind=0x7fffffff;
            }
            ++curPos;
            if ((i=jjnewStateCnt)==(startsAt=6-(jjnewStateCnt=startsAt))) return curPos;
            try {
                curChar=input_stream.readChar();
            }
            catch(java.io.IOException e) {
                return curPos;
            }
        }
    }

    private int jjStartNfaWithStates_NO_PARSE(int pos,int kind,int state) {
        jjmatchedKind=kind;
        jjmatchedPos=pos;
        try {
            curChar=input_stream.readChar();
        }
        catch(java.io.IOException e) {
            return pos+1;
        }
        return jjMoveNfa_NO_PARSE(state,pos+1);
    }

    private int jjMoveStringLiteralDfa0_NO_PARSE() {
        return jjMoveNfa_NO_PARSE(0,0);
    }

    private int jjMoveNfa_NO_PARSE(int startState,int curPos) {
        int startsAt=0;
        jjnewStateCnt=25;
        int i=1;
        jjstateSet[0]=startState;
        int kind=0x7fffffff;
        while (true) {
            if (++jjround==0x7fffffff) {
                ReInitRounds();
            }
            if (curChar<64) {
                long l=1L<<curChar;
                do {
                    switch(jjstateSet[--i]) {
                        case 0:
                         {
                            if (kind>117) kind=117;
                        }
                        if (curChar==60) jjstateSet[jjnewStateCnt++]=11;
                        break;
                        case 2:
                        if ((0x100002600L&l)!=0L) jjCheckNAddTwoStates(2,3);
                        break;
                        case 3:
                        if (curChar==62&&kind>118) kind=118;
                        break;
                        case 10:
                        if (curChar==35) jjstateSet[jjnewStateCnt++]=9;
                        break;
                        case 11:
                        if (curChar==47) jjstateSet[jjnewStateCnt++]=10;
                        break;
                        case 12:
                        if (curChar==60) jjCheckNAdd(11);
                        break;
                        case 14:
                        if ((0x100002600L&l)!=0L) jjCheckNAddTwoStates(14,15);
                        break;
                        case 22:
                        if (curChar==35) jjstateSet[jjnewStateCnt++]=21;
                        break;
                        case 23:
                        if (curChar==47) jjstateSet[jjnewStateCnt++]=22;
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            else if (curChar<128) {
                long l=1L<<(curChar&077);
                do {
                    switch(jjstateSet[--i]) {
                        case 0:
                         {
                            if (kind>117) kind=117;
                        }
                        if (curChar==91) jjstateSet[jjnewStateCnt++]=23;
                        break;
                        case 1:
                        if (curChar==101) jjAddStates(62,63);
                        break;
                        case 4:
                        if (curChar==115) jjstateSet[jjnewStateCnt++]=1;
                        break;
                        case 5:
                        if (curChar==114) jjstateSet[jjnewStateCnt++]=4;
                        break;
                        case 6:
                        if (curChar==97) jjstateSet[jjnewStateCnt++]=5;
                        break;
                        case 7:
                        if (curChar==112) jjstateSet[jjnewStateCnt++]=6;
                        break;
                        case 8:
                        if (curChar==111) jjstateSet[jjnewStateCnt++]=7;
                        break;
                        case 9:
                        if (curChar==110) jjstateSet[jjnewStateCnt++]=8;
                        break;
                        case 13:
                        if (curChar==101) jjAddStates(64,65);
                        break;
                        case 15:
                        if (curChar==93&&kind>118) kind=118;
                        break;
                        case 16:
                        if (curChar==115) jjstateSet[jjnewStateCnt++]=13;
                        break;
                        case 17:
                        if (curChar==114) jjstateSet[jjnewStateCnt++]=16;
                        break;
                        case 18:
                        if (curChar==97) jjstateSet[jjnewStateCnt++]=17;
                        break;
                        case 19:
                        if (curChar==112) jjstateSet[jjnewStateCnt++]=18;
                        break;
                        case 20:
                        if (curChar==111) jjstateSet[jjnewStateCnt++]=19;
                        break;
                        case 21:
                        if (curChar==110) jjstateSet[jjnewStateCnt++]=20;
                        break;
                        case 24:
                        if (curChar==91) jjCheckNAdd(23);
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            else {
                int hiByte=(int)(curChar>>8);
                int i1=hiByte>>6;
                long l1=1L<<(hiByte&077);
                int i2=(curChar&0xff)>>6;
                long l2=1L<<(curChar&077);
                do {
                    switch(jjstateSet[--i]) {
                        case 0:
                        if (jjCanMove_0(hiByte,i1,i2,l1,l2)&&kind>117) kind=117;
                        break;
                        default:
                        break;
                    }
                }
                while (i!=startsAt);
            }
            if (kind!=0x7fffffff) {
                jjmatchedKind=kind;
                jjmatchedPos=curPos;
                kind=0x7fffffff;
            }
            ++curPos;
            if ((i=jjnewStateCnt)==(startsAt=25-(jjnewStateCnt=startsAt))) return curPos;
            try {
                curChar=input_stream.readChar();
            }
            catch(java.io.IOException e) {
                return curPos;
            }
        }
    }

    static final int[] jjnextStates={4,5,11,20,7,9,10,8,9,10,14,15,18,19,15,17,18,19,23,25,26,24,25,26,30,31,34,35,31,33,34,35,4,5,27,36,13,18,19,29,34,35,25,26,27,22,23,19,8,10,11,3,5,6,13,16,4,0,5,1,3,5,2,3,14,15};
}
