/* Generated by: FreeCC 0.9.3. Token.java */
package ftl;

import ftl.ast.*;
/**
 * Describes the input token stream.
 */
public class Token implements Node,FTLConstants {
    private Node parent;
    private String inputSource="";
    private java.util.Map<String,Object>attributes;
    /**
     * An integer that describes the kind of this token.  This numbering
     * system is determined by JavaCCParser, and a table of these numbers is
     * stored in the file ...Constants.java.
     */
    int kind;
    /**
     * beginLine and beginColumn describe the position of the first character
     * of this token; endLine and endColumn describe the position of the
     * last character of this token.
     */
    int beginLine,beginColumn,endLine,endColumn;
    /**
     * The string image of the token.
     */
    String image;
    /**
     * A reference to the next regular (non-special) token from the input
     * stream.  If this is the last token from the input stream, or if the
     * token manager has not read tokens beyond this one, this field is
     * set to null.  This is true only if this token is also a regular
     * token.  Otherwise, see below for a description of the contents of
     * this field.
     */
    Token next;
    /**
     * This field is used to access special tokens that occur prior to this
     * token, but after the immediately preceding regular (non-special) token.
     * If there are no such special tokens, this field is set to null.
     * When there are more than one such special token, this field refers
     * to the last of these special tokens, which in turn refers to the next
     * previous special token through its specialToken field, and so on
     * until the first special token (whose specialToken field is null).
     * The next fields of special tokens refer to other special tokens that
     * immediately follow it (without an intervening regular token).  If there
     * is no such token, this field is null.
     */
    Token specialToken;
    private boolean unparsed;
    /**
     * No-argument constructor
     */
    public Token() {
    }

    /**
     * Constructs a new token for the specified Image.
     */
    public Token(int kind) {
        this(kind,null);
    }

    /**
     * Constructs a new token for the specified Image and Kind.
     */
    public Token(int kind,String image) {
        this.kind=kind;
        this.image=image;
    }

    public int getId() {
        return kind;
    }

    public String getNormalizedText() {
        return image;
    }

    public String getRawText() {
        return image;
    }

    public String toString() {
        return getNormalizedText();
    }

    public Object getAttribute(String name) {
        return attributes==null?null:
        attributes.get(name);
    }

    public void setAttribute(String name,Object value) {
        if (attributes==null) {
            attributes=new java.util.HashMap<String,Object>();
        }
        attributes.put(name,value);
    }

    public boolean hasAttribute(String name) {
        return attributes==null?false:
        attributes.containsKey(name);
    }

    public java.util.Set<String>getAttributeNames() {
        if (attributes==null) return java.util.Collections.emptySet();
        return attributes.keySet();
    }

    public static Token newToken(int ofKind,String image) {
        switch(ofKind) {
            case EXP_WHITE_SPACE:
            return new EXP_WHITE_SPACE(ofKind,image);
            case OPEN_PAREN:
            return new OPEN_PAREN(ofKind,image);
            case CLOSE_PAREN:
            return new CLOSE_PAREN(ofKind,image);
            case OPEN_BRACKET:
            return new OPEN_BRACKET(ofKind,image);
            case CLOSE_BRACKET:
            return new CLOSE_BRACKET(ofKind,image);
            case OPEN_BRACE:
            return new OPEN_BRACE(ofKind,image);
            case CLOSE_BRACE:
            return new CLOSE_BRACE(ofKind,image);
            case EQUALS:
            return new EQUALS(ofKind,image);
            case DOT:
            return new DOT(ofKind,image);
            case PLUS:
            return new PLUS(ofKind,image);
            case MINUS:
            return new MINUS(ofKind,image);
            case TIMES:
            return new TIMES(ofKind,image);
            case DIVIDE:
            return new DIVIDE(ofKind,image);
            case PERCENT:
            return new PERCENT(ofKind,image);
            case OR:
            return new OR(ofKind,image);
            case AND:
            return new AND(ofKind,image);
            case LT:
            return new LT(ofKind,image);
            case GT:
            return new GT(ofKind,image);
            case COMMA:
            return new COMMA(ofKind,image);
            case COLON:
            return new COLON(ofKind,image);
            case SEMICOLON:
            return new SEMICOLON(ofKind,image);
            case EXCLAM:
            return new EXCLAM(ofKind,image);
            case BUILT_IN:
            return new BUILT_IN(ofKind,image);
            case DOUBLE_EQUALS:
            return new DOUBLE_EQUALS(ofKind,image);
            case NOT_EQUALS:
            return new NOT_EQUALS(ofKind,image);
            case EXISTS_OPERATOR:
            return new EXISTS_OPERATOR(ofKind,image);
            case LTE:
            return new LTE(ofKind,image);
            case GTE:
            return new GTE(ofKind,image);
            case OR2:
            return new OR2(ofKind,image);
            case AND2:
            return new AND2(ofKind,image);
            case DOT_DOT:
            return new DOT_DOT(ofKind,image);
            case ALT_GT:
            return new ALT_GT(ofKind,image);
            case ALT_LT:
            return new ALT_LT(ofKind,image);
            case AS:
            return new AS(ofKind,image);
            case IN:
            return new IN(ofKind,image);
            case ALT_GTE:
            return new ALT_GTE(ofKind,image);
            case ALT_LTE:
            return new ALT_LTE(ofKind,image);
            case ELLIPSIS:
            return new ELLIPSIS(ofKind,image);
            case NULL:
            return new NULL(ofKind,image);
            case TRUE:
            return new TRUE(ofKind,image);
            case FALSE:
            return new FALSE(ofKind,image);
            case USING:
            return new USING(ofKind,image);
            case INTEGER:
            return new INTEGER(ofKind,image);
            case DECIMAL:
            return new DECIMAL(ofKind,image);
            case IDENTIFIER:
            return new IDENTIFIER(ofKind,image);
            case STRING_LITERAL:
            return new STRING_LITERAL(ofKind,image);
            case RAW_STRING:
            return new RAW_STRING(ofKind,image);
            case FTL_DIRECTIVE_OPEN:
            return new FTL_DIRECTIVE_OPEN(ofKind,image);
            case USER_DIRECTIVE_OPEN:
            return new USER_DIRECTIVE_OPEN(ofKind,image);
            case INTERPOLATE:
            return new INTERPOLATE(ofKind,image);
            case NUMERICAL_INTERPOLATE:
            return new NUMERICAL_INTERPOLATE(ofKind,image);
            case WHITESPACE:
            return new WHITESPACE(ofKind,image);
            case SPECIAL_CHAR:
            return new SPECIAL_CHAR(ofKind,image);
            case PRINTABLE_CHARS:
            return new PRINTABLE_CHARS(ofKind,image);
            case END_DIRECTIVE:
            return new END_DIRECTIVE(ofKind,image);
            case END_USER_DIRECTIVE:
            return new END_USER_DIRECTIVE(ofKind,image);
            case TRIM:
            return new TRIM(ofKind,image);
            case COMMENT:
            return new COMMENT(ofKind,image);
            case LTRIM:
            return new LTRIM(ofKind,image);
            case RTRIM:
            return new RTRIM(ofKind,image);
            case NOTRIM:
            return new NOTRIM(ofKind,image);
            case IF:
            return new IF(ofKind,image);
            case FTL:
            return new FTL(ofKind,image);
            case SET:
            return new SET(ofKind,image);
            case VAR:
            return new VAR(ofKind,image);
            case LIST:
            return new LIST(ofKind,image);
            case ELSE:
            return new ELSE(ofKind,image);
            case STOP:
            return new STOP(ofKind,image);
            case CASE:
            return new CASE(ofKind,image);
            case MACRO:
            return new MACRO(ofKind,image);
            case LOCAL:
            return new LOCAL(ofKind,image);
            case FLUSH:
            return new FLUSH(ofKind,image);
            case BREAK:
            return new BREAK(ofKind,image);
            case EMBED:
            return new EMBED(ofKind,image);
            case NESTED:
            return new NESTED(ofKind,image);
            case VISIT:
            return new VISIT(ofKind,image);
            case SWITCH:
            return new SWITCH(ofKind,image);
            case IMPORT:
            return new IMPORT(ofKind,image);
            case DEFAUL:
            return new DEFAUL(ofKind,image);
            case RETURN:
            return new RETURN(ofKind,image);
            case GLOBAL:
            return new GLOBAL(ofKind,image);
            case ASSIGN:
            return new ASSIGN(ofKind,image);
            case ELSEIF:
            return new ELSEIF(ofKind,image);
            case ESCAPE:
            return new ESCAPE(ofKind,image);
            case RECURSE:
            return new RECURSE(ofKind,image);
            case FUNCTION:
            return new FUNCTION(ofKind,image);
            case FALLBACK:
            return new FALLBACK(ofKind,image);
            case NOESCAPE:
            return new NOESCAPE(ofKind,image);
            case SETTING:
            return new SETTING(ofKind,image);
            case NOPARSE:
            return new NOPARSE(ofKind,image);
            case _INCLUDE:
            return new _INCLUDE(ofKind,image);
            case ATTEMPT:
            return new ATTEMPT(ofKind,image);
            case FOREACH:
            return new FOREACH(ofKind,image);
            case RECOVER:
            return new RECOVER(ofKind,image);
            case COMPRESS:
            return new COMPRESS(ofKind,image);
            case BLOCKTRIM:
            return new BLOCKTRIM(ofKind,image);
            case BLOCKTRIML:
            return new BLOCKTRIML(ofKind,image);
            case BLOCKTRIMR:
            return new BLOCKTRIMR(ofKind,image);
            case BLOCKNOTRIM:
            return new BLOCKNOTRIM(ofKind,image);
            case BLANK:
            return new BLANK(ofKind,image);
            case CLOSE_TAG:
            return new CLOSE_TAG(ofKind,image);
            case CLOSE_EMPTY_TAG:
            return new CLOSE_EMPTY_TAG(ofKind,image);
            case END_COMMENT:
            return new END_COMMENT(ofKind,image);
            case NOPARSE_END:
            return new NOPARSE_END(ofKind,image);
        }
        return new Token(ofKind,image);
    }

    public void setInputSource(String inputSource) {
        this.inputSource=inputSource;
    }

    public String getInputSource() {
        return inputSource;
    }

    public void setBeginColumn(int beginColumn) {
        this.beginColumn=beginColumn;
    }

    public void setEndColumn(int endColumn) {
        this.endColumn=endColumn;
    }

    public void setBeginLine(int beginLine) {
        this.beginLine=beginLine;
    }

    public void setEndLine(int endLine) {
        this.endLine=endLine;
    }

    public int getBeginLine() {
        return beginLine;
    }

    public int getBeginColumn() {
        return beginColumn;
    }

    public int getEndLine() {
        return endLine;
    }

    public int getEndColumn() {
        return endColumn;
    }

    public int getChildCount() {
        return 0;
    }

    public Node getChild(int i) {
        return null;
    }

    public void setChild(int i,Node n) {
        throw new UnsupportedOperationException();
    }

    public void addChild(Node n) {
        throw new UnsupportedOperationException();
    }

    public void addChild(int i,Node n) {
        throw new UnsupportedOperationException();
    }

    public Node removeChild(int i) {
        throw new UnsupportedOperationException();
    }

    public boolean removeChild(Node n) {
        return false;
    }

    public int indexOf(Node n) {
        return-1;
    }

    public boolean isUnparsed() {
        return unparsed;
    }

    public void setUnparsed(boolean unparsed) {
        this.unparsed=unparsed;
    }

    public void clearChildren() {
    }

    public Node getParent() {
        return parent;
    }

    public void setParent(Node parent) {
        this.parent=parent;
    }

    public void open() {
    }

    public void close() {
    }

}
