/* Generated by: FreeCC 0.9.3. FTLParser.java */
package ftl;

import ftl.ast.*;
import java.io.*;
import java.util.*;
@SuppressWarnings("unused")
public class FTLParser implements FTLConstants {
    static final boolean DUMPTREE=false;
    static public void main(String[] args) throws Exception {
        if (args.length==0) {
            usage();
            System.exit(-1);
        }
        java.util.List<File>files=new java.util.ArrayList<File>();
        for(String arg : args) {
            File file=new File(arg);
            if (file.isDirectory()) {
                for(File f : file.listFiles()) {
                    if (f.getName().endsWith(".ftl")) {
                        files.add(f);
                    }
                }
            }
            else {
                files.add(file);
            }
        }
        for(File f : files) {
            checkFTLFile(f,false);
        }
    }

    static public void checkFTLFile(File inputFile,boolean dumpTree) {
        FTLParser parser=null;
        try {
            FileReader reader=new FileReader(inputFile);
            parser=new FTLParser(reader);
            parser.setInputSource(inputFile.toString());
            parser.Root();
        }
        catch(Exception e) {
            System.err.println("Error parsing "+inputFile);
            e.printStackTrace();
            return;
        }
        System.err.println("File "+inputFile+" parsed successfully.");
        if (dumpTree) {
            Nodes.dump(parser.rootNode(),"---");
        }
    }

    static public void usage() {
        System.err.println("Usage: java ftl.FTLParser <filenames>");
    }

    private boolean buildTree=true;
    private boolean tokensAreNodes=true;
    private boolean specialTokensAreNodes=false;
    private java.util.ArrayList<Node>nodes=new java.util.ArrayList<Node>();
    private java.util.ArrayList<java.lang.Integer>marks=new java.util.ArrayList<java.lang.Integer>();
    private int mark;
    // current mark
    private boolean node_created;
    /** 
     * Determines whether the current node was actually closed and
     * pushed.  This should only be called in the final user action of a
     * node scope.  
     */
    public boolean nodeCreated() {
        return node_created;
    }

    /** 
	 * Returns the root node of the AST.  It only makes sense to call
	 * this after a successful parse. 
	 */
    public Node rootNode() {
        return nodes.get(0);
    }

    /**
     * push a node onto the top of the node stack
     */
    public void pushNode(Node n) {
        nodes.add(n);
    }

    /** 
     * Returns the node on the top of the stack, and remove it from the
     * stack.  
     */
    public Node popNode() {
        return nodes.remove(nodes.size()-1);
    }

    /** 
     * Returns the node currently on the top of the stack. 
     */
    public Node peekNode() {
        return nodes.get(nodes.size()-1);
    }

    /**
     * Puts the node on the top of the stack. However, unlike pushNode()
     * it replaces the node that is currently on the top of the stack.
     * This is effectively equivalent to popNode() followed by pushNode(n)
     */
    public void pokeNode(Node n) {
        pokeNode(n,false);
    }

    /**
     * Puts the node on the top of the stack. If clearNodeScope is true,
     * it removes all the nodes in the current node scope and pushes
     * n onto the top. Otherwise, it simply replaces the node at the
     * top of the stack with n.
     */
    public void pokeNode(Node n,boolean clearNodeScope) {
        if (clearNodeScope) {
            clearNodeScope();
            nodes.add(n);
        }
        else {
            nodes.set(nodes.size()-1,n);
        }
    }

    /** Returns the number of children on the stack in the current node
	 * scope. 
	 */
    public int nodeArity() {
        return nodes.size()-mark;
    }

    public void clearNodeScope() {
        while (nodes.size()>mark) {
            popNode();
        }
    }

    public void openNodeScope(Node n) {
        marks.add(mark);
        mark=nodes.size();
        n.open();
    }

    /* A definite node is constructed from a specified number of
	 * children.  That number of nodes are popped from the stack and
	 * made the children of the definite node.  Then the definite node
	 * is pushed on to the stack. */
    public void closeNodeScope(Node n,int num) {
        mark=marks.remove(marks.size()-1);
        java.util.ArrayList<Node>nodes=new java.util.ArrayList<Node>();
        for(int i=0; 
        i<num; 
        i++) {
            nodes.add(popNode());
        }
        java.util.Collections.reverse(nodes);
        for(Node child : nodes) {
            if (specialTokensAreNodes&&(child instanceof Token)) {
                Token token=(Token) child;
                Token specialToken=token;
                while (specialToken!=null) {
                    specialToken=specialToken.specialToken;
                }
                while (specialToken!=null&&specialToken!=token) {
                    n.addChild(specialToken);
                    specialToken=specialToken.next;
                }
            }
            n.addChild(child);
        }
        n.close();
        pushNode(n);
        node_created=true;
    }

    /** 
	 * A conditional node is constructed if its condition is true.  All
	 * the nodes that have been pushed since the node was opened are
	 * made children of the conditional node, which is then pushed
	 * on to the stack.  If the condition is false the node is not
	 * constructed and they are left on the stack. 
	 */
    public void closeNodeScope(Node n,boolean condition) {
        if (condition) {
            int a=nodeArity();
            mark=marks.remove(marks.size()-1);
            java.util.ArrayList<Node>nodes=new java.util.ArrayList<Node>();
            while (a-->0) {
                nodes.add(popNode());
            }
            java.util.Collections.reverse(nodes);
            for(Node child : nodes) {
                if (specialTokensAreNodes&&(child instanceof Token)) {
                    Token token=(Token) child;
                    Token specialToken=token;
                    while (specialToken.specialToken!=null) {
                        specialToken=specialToken.specialToken;
                    }
                    while (specialToken!=null&&specialToken!=token) {
                        n.addChild(specialToken);
                        specialToken=specialToken.next;
                    }
                }
                n.addChild(child);
            }
            n.close();
            pushNode(n);
            node_created=true;
        }
        else {
            mark=marks.remove(marks.size()-1);
            node_created=false;
        }
    }

    public boolean getBuildTree() {
        return buildTree;
    }

    public void setBuildTree(boolean buildTree) {
        this.buildTree=buildTree;
    }

    private boolean isSpecialToken(Node n) {
        if (n instanceof Token) {
            Token t=(Token) n;
            return t.next!=null&&t.next.specialToken==t;
        }
        return false;
    }

    /**
     * @deprecated
     * Kludge so that existing jjtree-based code that uses
     * parser.jjtree.foo can work without change.
     */
    FTLParser jjtree=this;
    /** Generated Lexer. */
    public FTLLexer token_source;
    SimpleCharStream jj_input_stream;
    public void setInputSource(String inputSource) {
        token_source.setInputSource(inputSource);
    }

    String getInputSource() {
        return token_source.getInputSource();
    }

    Token current_token;
    /** Next token. */
    private Token jj_nt;
    private int jj_ntk;
    private Token jj_scanpos,jj_lastpos;
    private int jj_la;
    /** Whether we are looking ahead. */
    private boolean jj_lookingAhead=false;
    private boolean jj_semLA;
    private int jj_gen;
    final private int[] jj_la1=new int[86];
    static private int[] jj_la1_0;
    static private int[] jj_la1_1;
    static private int[] jj_la1_2;
    static private int[] jj_la1_3;
    static {
        jj_la1_init_0();
        jj_la1_init_1();
        jj_la1_init_2();
        jj_la1_init_3();
    }
    private static void jj_la1_init_0() {
        jj_la1_0=new int[]{0x200000,0x200000,0x400000,0x400000,0xc0004000,0xc0004000,0x1800000,0x1800000,0x0,0x30000,0x1c0000,0x1c0000,0x10039500,0x30000,0x10000000,0x20008500,0x9500,0x40000,0x10039500,0x12039500,0x2000000,0x10039500,0x0,0x2000000,0x10039500,0x0,0x0,0x10039500,0x2000000,0x2000000,0x12039500,0x2000000,0x0,0x8000000,0x0,0x2000000,0x2000000,0x0,0x0,0x4000,0x4000,0x2000000,0x2000000,0x4000,0x4000,0x2000000,0x2000000,0x4000,0x0,0x0,0x0,0x8000000,0x0,0x12039500,0x2000000,0x0,0x10039500,0x12039500,0x2000000,0x0,0x0,0x0,0x0,0x0,0x100,0x0,0x200,0x4000,0x4000,0x2000000,0x2000000,0x4000,0x4000,0x0,0x0,0x0,0x0,0x10039500,0x0,0x8000000,0x0,0x0,0x0,0x0,0x0,0x0};
    }

    private static void jj_la1_init_1() {
        jj_la1_1=new int[]{0x8,0x8,0x10,0x10,0x0,0x0,0xcc6,0xcc6,0x20,0x0,0x0,0x0,0xcee000,0x0,0x0,0x1,0xcee000,0x80000,0xcee000,0xcee000,0x0,0xcee000,0xc00000,0x0,0xcee000,0x60000,0xc000,0xcee000,0x80000,0x0,0xcee000,0x0,0xc80000,0x0,0x0,0xc80000,0x0,0x200,0x200,0x200,0x0,0xc80000,0x0,0x0,0x0,0xc80000,0x0,0x0,0x0,0x0,0x0,0x0,0x80000,0xcee000,0x0,0x10000,0xcee000,0xcee000,0x0,0x10000,0x0,0x10000000,0x0,0x0,0x0,0x80000,0x0,0x1000,0x1000,0x80000,0x0,0x1000,0x1000,0x0,0x70000000,0x70000000,0x0,0xcee000,0x80000,0x0,0x0,0x7f000000,0x80000,0x0,0x0,0x10000000};
    }

    private static void jj_la1_init_2() {
        jj_la1_2=new int[]{0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x60081000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0};
    }

    private static void jj_la1_init_3() {
        jj_la1_3=new int[]{0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x20000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x10000,0x10000,0xf000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x70000,0x0,0x10000,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x60000,0x0,0x0,0x10000,0x0,0x0,0x0,0x60000,0x0,0x0,0x10000,0x60000,0x0};
    }

    final private JJCalls[] jj_2_rtns=new JJCalls[41];
    private boolean jj_rescan=false;
    private int jj_gc=0;
    public FTLParser(java.io.Reader stream) {
        jj_input_stream=new SimpleCharStream(stream,1,1);
        token_source=new FTLLexer(jj_input_stream);
        current_token=new Token();
        jj_ntk=-1;
        for(int i=0; 
        i<86; 
        i++) jj_la1[i]=-1; 
        for(int i=0; 
        i<jj_2_rtns.length; 
        i++) jj_2_rtns[i]=new JJCalls(); 
    }

    /** Constructor with generated Token Manager. */
    public FTLParser(FTLLexer tm) {
        token_source=tm;
        current_token=new Token();
        jj_ntk=-1;
        for(int i=0; 
        i<86; 
        i++) jj_la1[i]=-1; 
        for(int i=0; 
        i<jj_2_rtns.length; 
        i++) jj_2_rtns[i]=new JJCalls(); 
    }

    private Token jj_consume_token(int kind) throws ParseException {
        Token oldToken=current_token;
        if (current_token.next!=null) current_token=current_token.next;
        else current_token=current_token.next=token_source.getNextToken();
        jj_ntk=-1;
        if (current_token.kind==kind) {
            jj_gen++;
            if (++jj_gc>100) {
                jj_gc=0;
                for(int i=0; 
                i<jj_2_rtns.length; 
                i++) {
                    JJCalls c=jj_2_rtns[i];
                    while (c!=null) {
                        if (c.gen<jj_gen) c.first=null;
                        c=c.next;
                    }
                }
            }
            if (buildTree&&tokensAreNodes) {
                pushNode(current_token);
            }
            return current_token;
        }
        current_token=oldToken;
        jj_kind=kind;
        throw generateParseException();
    }

    @SuppressWarnings("serial")
    static private final class LookaheadSuccess extends java.lang.Error {
    }
    final private LookaheadSuccess jj_ls=new LookaheadSuccess();
    private boolean jj_scan_token(int kind) {
        if (jj_scanpos==jj_lastpos) {
            jj_la--;
            if (jj_scanpos.next==null) {
                jj_lastpos=jj_scanpos=jj_scanpos.next=token_source.getNextToken();
            }
            else {
                jj_lastpos=jj_scanpos=jj_scanpos.next;
            }
        }
        else {
            jj_scanpos=jj_scanpos.next;
        }
        if (jj_rescan) {
            int i=0;
            Token tok=current_token;
            while (tok!=null&&tok!=jj_scanpos) {
                i++;
                tok=tok.next;
            }
            if (tok!=null) jj_add_error_token(kind,i);
        }
        if (jj_scanpos.kind!=kind) return true;
        if (jj_la==0&&jj_scanpos==jj_lastpos) throw jj_ls;
        return false;
    }

    /** Get the next Token. */
    final public Token getNextToken() {
        if (current_token.next!=null) current_token=current_token.next;
        else current_token=current_token.next=token_source.getNextToken();
        jj_ntk=-1;
        jj_gen++;
        return current_token;
    }

    /** Get the specific Token. */
    final public Token getToken(int index) {
        Token t=jj_lookingAhead?jj_scanpos:
        current_token;
        for(int i=0; 
        i<index; 
        i++) {
            if (t.next!=null) t=t.next;
            else t=t.next=token_source.getNextToken();
        }
        return t;
    }

    private int jj_ntk() {
        if ((jj_nt=current_token.next)==null) return(jj_ntk=(current_token.next=token_source.getNextToken()).kind);
        else return(jj_ntk=jj_nt.kind);
    }

    private java.util.ArrayList<int[]>jj_expentries=new java.util.ArrayList<int[]>();
    private int[] jj_expentry;
    private int jj_kind=-1;
    private int[] jj_lasttokens=new int[100];
    private int jj_endpos;
    private void jj_add_error_token(int kind,int pos) {
        if (pos>=100) return;
        if (pos==jj_endpos+1) {
            jj_lasttokens[jj_endpos++]=kind;
        }
        else if (jj_endpos!=0) {
            jj_expentry=new int[jj_endpos];
            for(int i=0; 
            i<jj_endpos; 
            i++) {
                jj_expentry[i]=jj_lasttokens[i];
            }
            jj_entries_loop:
            for(java.util.Iterator<int[]>it=jj_expentries.iterator(); 
            it.hasNext(); 
            ) {
                int[] oldentry=(int[])(it.next());
                if (oldentry.length==jj_expentry.length) {
                    for(int i=0; 
                    i<jj_expentry.length; 
                    i++) {
                        if (oldentry[i]!=jj_expentry[i]) {
                            continue jj_entries_loop;
                        }
                    }
                    jj_expentries.add(jj_expentry);
                    break jj_entries_loop;
                }
            }
            if (pos!=0) jj_lasttokens[(jj_endpos=pos)-1]=kind;
        }
    }

    public ParseException generateParseException() {
        jj_expentries.clear();
        boolean[] la1tokens=new boolean[119];
        if (jj_kind>=0) {
            la1tokens[jj_kind]=true;
            jj_kind=-1;
        }
        for(int i=0; 
        i<86; 
        i++) {
            if (jj_la1[i]==jj_gen) {
                for(int j=0; 
                j<32; 
                j++) {
                    if ((jj_la1_0[i]&(1<<j))!=0) {
                        la1tokens[0+j]=true;
                    }
                    if ((jj_la1_1[i]&(1<<j))!=0) {
                        la1tokens[32+j]=true;
                    }
                    if ((jj_la1_2[i]&(1<<j))!=0) {
                        la1tokens[64+j]=true;
                    }
                    if ((jj_la1_3[i]&(1<<j))!=0) {
                        la1tokens[96+j]=true;
                    }
                }
            }
        }
        for(int i=0; 
        i<119; 
        i++) {
            if (la1tokens[i]) {
                jj_expentry=new int[1];
                jj_expentry[0]=i;
                jj_expentries.add(jj_expentry);
            }
        }
        jj_endpos=0;
        jj_rescan_token();
        jj_add_error_token(0,0);
        int[][] exptokseq=new int[jj_expentries.size()][];
        for(int i=0; 
        i<jj_expentries.size(); 
        i++) {
            exptokseq[i]=(int[]) jj_expentries.get(i);
        }
        return new ParseException(current_token,exptokseq,tokenImage);
    }

    /** Enable tracing. */
    final public void enable_tracing() {
    }

    /** Disable tracing. */
    final public void disable_tracing() {
    }

    private void jj_rescan_token() {
        jj_rescan=true;
        for(int i=0; 
        i<41; 
        i++) {
            try {
                JJCalls p=jj_2_rtns[i];
                do {
                    if (p.gen>jj_gen) {
                        jj_la=p.arg;
                        jj_lastpos=jj_scanpos=p.first;
                        switch(i) {
                            case 0:
                            jj_3_1();
                            break;
                            case 1:
                            jj_3_2();
                            break;
                            case 2:
                            jj_3_3();
                            break;
                            case 3:
                            jj_3_4();
                            break;
                            case 4:
                            jj_3_5();
                            break;
                            case 5:
                            jj_3_6();
                            break;
                            case 6:
                            jj_3_7();
                            break;
                            case 7:
                            jj_3_8();
                            break;
                            case 8:
                            jj_3_9();
                            break;
                            case 9:
                            jj_3_10();
                            break;
                            case 10:
                            jj_3_11();
                            break;
                            case 11:
                            jj_3_12();
                            break;
                            case 12:
                            jj_3_13();
                            break;
                            case 13:
                            jj_3_14();
                            break;
                            case 14:
                            jj_3_15();
                            break;
                            case 15:
                            jj_3_16();
                            break;
                            case 16:
                            jj_3_17();
                            break;
                            case 17:
                            jj_3_18();
                            break;
                            case 18:
                            jj_3_19();
                            break;
                            case 19:
                            jj_3_20();
                            break;
                            case 20:
                            jj_3_21();
                            break;
                            case 21:
                            jj_3_22();
                            break;
                            case 22:
                            jj_3_23();
                            break;
                            case 23:
                            jj_3_24();
                            break;
                            case 24:
                            jj_3_25();
                            break;
                            case 25:
                            jj_3_26();
                            break;
                            case 26:
                            jj_3_27();
                            break;
                            case 27:
                            jj_3_28();
                            break;
                            case 28:
                            jj_3_29();
                            break;
                            case 29:
                            jj_3_30();
                            break;
                            case 30:
                            jj_3_31();
                            break;
                            case 31:
                            jj_3_32();
                            break;
                            case 32:
                            jj_3_33();
                            break;
                            case 33:
                            jj_3_34();
                            break;
                            case 34:
                            jj_3_35();
                            break;
                            case 35:
                            jj_3_36();
                            break;
                            case 36:
                            jj_3_37();
                            break;
                            case 37:
                            jj_3_38();
                            break;
                            case 38:
                            jj_3_39();
                            break;
                            case 39:
                            jj_3_40();
                            break;
                            case 40:
                            jj_3_41();
                            break;
                        }
                    }
                    p=p.next;
                }
                while (p!=null);
            }
            catch(LookaheadSuccess ls) {
            }
        }
        jj_rescan=false;
    }

    private void jj_save(int index,int xla) {
        JJCalls p=jj_2_rtns[index];
        while (p.gen>jj_gen) {
            if (p.next==null) {
                p=p.next=new JJCalls();
                break;
            }
            p=p.next;
        }
        p.gen=jj_gen+xla-jj_la;
        p.first=current_token;
        p.arg=xla;
    }

    static final class JJCalls {
        int gen;
        Token first;
        int arg;
        JJCalls next;
    }
    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 240
    final public Node Input() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 243
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 243
        Expression();
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 244
        jj_consume_token(0);
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 245
        if (true) return rootNode();
        throw new Error("Missing return statement in function");
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 250
    final public void Expression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 252
        Expression node1=null;
        if (buildTree) {
            node1=new Expression();
            Token jjtStartToken=getToken(1);
            node1.setBeginLine(jjtStartToken.beginLine);
            node1.setBeginColumn(jjtStartToken.beginColumn);
            node1.setInputSource(this.getInputSource());
            openNodeScope(node1);
        }
        boolean hitException1=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 252
            OrExpression();
        }
        catch(Exception e1) {
            hitException1=false;
            if (e1 instanceof ParseException) throw(ParseException) e1;
            if (e1 instanceof RuntimeException) throw(RuntimeException) e1;
            throw new RuntimeException(e1);
        }
        finally {
            if (buildTree) {
                if (!hitException1) {
                    closeNodeScope(node1,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node1.setEndLine(jjtEndToken.endLine);
                    node1.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 255
    final public void OrExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 257
        OrExpression node2=null;
        if (buildTree) {
            node2=new OrExpression();
            Token jjtStartToken=getToken(1);
            node2.setBeginLine(jjtStartToken.beginLine);
            node2.setBeginColumn(jjtStartToken.beginColumn);
            node2.setInputSource(this.getInputSource());
            openNodeScope(node2);
        }
        boolean hitException2=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 257
            AndExpression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 260
            label_1:
            while (true) {
                int int1=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (!(int1==OR||int1==OR2)) {
                    jj_la1[0]=jj_gen;
                    break label_1;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 259
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 259
                switch((jj_ntk==-1)?jj_ntk():
                jj_ntk) {
                    case OR:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 259
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 259
                    jj_consume_token(OR);
                    break;
                    case OR2:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 259
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 259
                    jj_consume_token(OR2);
                    break;
                    default:
                    jj_la1[1]=jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 259
                AndExpression();
            }
        }
        catch(Exception e2) {
            hitException2=false;
            if (e2 instanceof ParseException) throw(ParseException) e2;
            if (e2 instanceof RuntimeException) throw(RuntimeException) e2;
            throw new RuntimeException(e2);
        }
        finally {
            if (buildTree) {
                if (!hitException2) {
                    closeNodeScope(node2,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node2.setEndLine(jjtEndToken.endLine);
                    node2.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 263
    final public void AndExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 265
        AndExpression node3=null;
        if (buildTree) {
            node3=new AndExpression();
            Token jjtStartToken=getToken(1);
            node3.setBeginLine(jjtStartToken.beginLine);
            node3.setBeginColumn(jjtStartToken.beginColumn);
            node3.setInputSource(this.getInputSource());
            openNodeScope(node3);
        }
        boolean hitException3=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 265
            EqualityExpression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 268
            label_2:
            while (true) {
                int int2=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (!(int2==AND||int2==AND2)) {
                    jj_la1[2]=jj_gen;
                    break label_2;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 267
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 267
                switch((jj_ntk==-1)?jj_ntk():
                jj_ntk) {
                    case AND:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 267
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 267
                    jj_consume_token(AND);
                    break;
                    case AND2:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 267
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 267
                    jj_consume_token(AND2);
                    break;
                    default:
                    jj_la1[3]=jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 267
                EqualityExpression();
            }
        }
        catch(Exception e3) {
            hitException3=false;
            if (e3 instanceof ParseException) throw(ParseException) e3;
            if (e3 instanceof RuntimeException) throw(RuntimeException) e3;
            throw new RuntimeException(e3);
        }
        finally {
            if (buildTree) {
                if (!hitException3) {
                    closeNodeScope(node3,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node3.setEndLine(jjtEndToken.endLine);
                    node3.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 271
    final public void EqualityExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 273
        EqualityExpression node4=null;
        if (buildTree) {
            node4=new EqualityExpression();
            Token jjtStartToken=getToken(1);
            node4.setBeginLine(jjtStartToken.beginLine);
            node4.setBeginColumn(jjtStartToken.beginColumn);
            node4.setInputSource(this.getInputSource());
            openNodeScope(node4);
        }
        boolean hitException4=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 273
            RelationalExpression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 274
            int int3=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int3==EQUALS||int3==DOUBLE_EQUALS||int3==NOT_EQUALS) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 275
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 275
                switch((jj_ntk==-1)?jj_ntk():
                jj_ntk) {
                    case EQUALS:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 275
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 275
                    jj_consume_token(EQUALS);
                    break;
                    case DOUBLE_EQUALS:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 275
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 275
                    jj_consume_token(DOUBLE_EQUALS);
                    break;
                    case NOT_EQUALS:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 275
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 275
                    jj_consume_token(NOT_EQUALS);
                    break;
                    default:
                    jj_la1[4]=jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 276
                RelationalExpression();
            }
            else {
                jj_la1[5]=jj_gen;
            }
        }
        catch(Exception e4) {
            hitException4=false;
            if (e4 instanceof ParseException) throw(ParseException) e4;
            if (e4 instanceof RuntimeException) throw(RuntimeException) e4;
            throw new RuntimeException(e4);
        }
        finally {
            if (buildTree) {
                if (!hitException4) {
                    closeNodeScope(node4,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node4.setEndLine(jjtEndToken.endLine);
                    node4.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 280
    final public void RelationalExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 282
        RelationalExpression node5=null;
        if (buildTree) {
            node5=new RelationalExpression();
            Token jjtStartToken=getToken(1);
            node5.setBeginLine(jjtStartToken.beginLine);
            node5.setBeginColumn(jjtStartToken.beginColumn);
            node5.setInputSource(this.getInputSource());
            openNodeScope(node5);
        }
        boolean hitException5=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 282
            RangeExpression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 283
            int int4=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int4==LT||int4==GT||int4==LTE||int4==GTE||int4==ALT_GT||int4==ALT_LT||int4==ALT_GTE||int4==ALT_LTE) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                switch((jj_ntk==-1)?jj_ntk():
                jj_ntk) {
                    case GT:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    jj_consume_token(GT);
                    break;
                    case GTE:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    jj_consume_token(GTE);
                    break;
                    case LT:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    jj_consume_token(LT);
                    break;
                    case LTE:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    jj_consume_token(LTE);
                    break;
                    case ALT_GT:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    jj_consume_token(ALT_GT);
                    break;
                    case ALT_GTE:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    jj_consume_token(ALT_GTE);
                    break;
                    case ALT_LTE:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    jj_consume_token(ALT_LTE);
                    break;
                    case ALT_LT:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 284
                    jj_consume_token(ALT_LT);
                    break;
                    default:
                    jj_la1[6]=jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 285
                RangeExpression();
            }
            else {
                jj_la1[7]=jj_gen;
            }
        }
        catch(Exception e5) {
            hitException5=false;
            if (e5 instanceof ParseException) throw(ParseException) e5;
            if (e5 instanceof RuntimeException) throw(RuntimeException) e5;
            throw new RuntimeException(e5);
        }
        finally {
            if (buildTree) {
                if (!hitException5) {
                    closeNodeScope(node5,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node5.setEndLine(jjtEndToken.endLine);
                    node5.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 289
    final public void RangeExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 291
        RangeExpression node6=null;
        if (buildTree) {
            node6=new RangeExpression();
            Token jjtStartToken=getToken(1);
            node6.setBeginLine(jjtStartToken.beginLine);
            node6.setBeginColumn(jjtStartToken.beginColumn);
            node6.setInputSource(this.getInputSource());
            openNodeScope(node6);
        }
        boolean hitException6=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 291
            AdditiveExpression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 292
            int int5=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int5==DOT_DOT) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 293
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 293
                jj_consume_token(DOT_DOT);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 294
                if (jj_2_1(2147483647)) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 295
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 296
                    AdditiveExpression();
                }
            }
            else {
                jj_la1[8]=jj_gen;
            }
        }
        catch(Exception e6) {
            hitException6=false;
            if (e6 instanceof ParseException) throw(ParseException) e6;
            if (e6 instanceof RuntimeException) throw(RuntimeException) e6;
            throw new RuntimeException(e6);
        }
        finally {
            if (buildTree) {
                if (!hitException6) {
                    closeNodeScope(node6,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node6.setEndLine(jjtEndToken.endLine);
                    node6.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 301
    final public void AdditiveExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 303
        AdditiveExpression node7=null;
        if (buildTree) {
            node7=new AdditiveExpression();
            Token jjtStartToken=getToken(1);
            node7.setBeginLine(jjtStartToken.beginLine);
            node7.setBeginColumn(jjtStartToken.beginColumn);
            node7.setInputSource(this.getInputSource());
            openNodeScope(node7);
        }
        boolean hitException7=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 303
            MultiplicativeExpression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 308
            label_3:
            while (true) {
                if (!(jj_2_2(2147483647))) {
                    break label_3;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 305
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 306
                switch((jj_ntk==-1)?jj_ntk():
                jj_ntk) {
                    case PLUS:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 306
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 306
                    jj_consume_token(PLUS);
                    break;
                    case MINUS:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 306
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 306
                    jj_consume_token(MINUS);
                    break;
                    default:
                    jj_la1[9]=jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 307
                MultiplicativeExpression();
            }
        }
        catch(Exception e7) {
            hitException7=false;
            if (e7 instanceof ParseException) throw(ParseException) e7;
            if (e7 instanceof RuntimeException) throw(RuntimeException) e7;
            throw new RuntimeException(e7);
        }
        finally {
            if (buildTree) {
                if (!hitException7) {
                    closeNodeScope(node7,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node7.setEndLine(jjtEndToken.endLine);
                    node7.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 311
    final public void MultiplicativeExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 313
        MultiplicativeExpression node8=null;
        if (buildTree) {
            node8=new MultiplicativeExpression();
            Token jjtStartToken=getToken(1);
            node8.setBeginLine(jjtStartToken.beginLine);
            node8.setBeginColumn(jjtStartToken.beginColumn);
            node8.setInputSource(this.getInputSource());
            openNodeScope(node8);
        }
        boolean hitException8=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 313
            UnaryExpression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 317
            label_4:
            while (true) {
                int int6=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (!(int6==TIMES||int6==DIVIDE||int6==PERCENT)) {
                    jj_la1[10]=jj_gen;
                    break label_4;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 315
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 315
                switch((jj_ntk==-1)?jj_ntk():
                jj_ntk) {
                    case TIMES:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 315
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 315
                    jj_consume_token(TIMES);
                    break;
                    case DIVIDE:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 315
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 315
                    jj_consume_token(DIVIDE);
                    break;
                    case PERCENT:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 315
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 315
                    jj_consume_token(PERCENT);
                    break;
                    default:
                    jj_la1[11]=jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 316
                UnaryExpression();
            }
        }
        catch(Exception e8) {
            hitException8=false;
            if (e8 instanceof ParseException) throw(ParseException) e8;
            if (e8 instanceof RuntimeException) throw(RuntimeException) e8;
            throw new RuntimeException(e8);
        }
        finally {
            if (buildTree) {
                if (!hitException8) {
                    closeNodeScope(node8,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node8.setEndLine(jjtEndToken.endLine);
                    node8.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 321
    final public void UnaryExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 323
        switch((jj_ntk==-1)?jj_ntk():
        jj_ntk) {
            case PLUS:
            case MINUS:
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 323
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 323
            UnaryPlusMinusExpression();
            break;
            case EXCLAM:
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 325
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 325
            NotExpression();
            break;
            case OPEN_PAREN:
            case OPEN_BRACKET:
            case OPEN_BRACE:
            case DOT:
            case NULL:
            case TRUE:
            case FALSE:
            case INTEGER:
            case DECIMAL:
            case IDENTIFIER:
            case STRING_LITERAL:
            case RAW_STRING:
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 327
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 327
            DefaultToExpression();
            break;
            default:
            jj_la1[12]=jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 330
    final public void UnaryPlusMinusExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 332
        UnaryPlusMinusExpression node9=null;
        if (buildTree) {
            node9=new UnaryPlusMinusExpression();
            Token jjtStartToken=getToken(1);
            node9.setBeginLine(jjtStartToken.beginLine);
            node9.setBeginColumn(jjtStartToken.beginColumn);
            node9.setInputSource(this.getInputSource());
            openNodeScope(node9);
        }
        boolean hitException9=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 332
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case PLUS:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 332
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 332
                jj_consume_token(PLUS);
                break;
                case MINUS:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 332
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 332
                jj_consume_token(MINUS);
                break;
                default:
                jj_la1[13]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 332
            DefaultToExpression();
        }
        catch(Exception e9) {
            hitException9=false;
            if (e9 instanceof ParseException) throw(ParseException) e9;
            if (e9 instanceof RuntimeException) throw(RuntimeException) e9;
            throw new RuntimeException(e9);
        }
        finally {
            if (buildTree) {
                if (!hitException9) {
                    closeNodeScope(node9,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node9.setEndLine(jjtEndToken.endLine);
                    node9.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 335
    final public void NotExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 337
        NotExpression node10=null;
        if (buildTree) {
            node10=new NotExpression();
            Token jjtStartToken=getToken(1);
            node10.setBeginLine(jjtStartToken.beginLine);
            node10.setBeginColumn(jjtStartToken.beginColumn);
            node10.setInputSource(this.getInputSource());
            openNodeScope(node10);
        }
        boolean hitException10=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 337
            jj_consume_token(EXCLAM);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 338
            DefaultToExpression();
        }
        catch(Exception e10) {
            hitException10=false;
            if (e10 instanceof ParseException) throw(ParseException) e10;
            if (e10 instanceof RuntimeException) throw(RuntimeException) e10;
            throw new RuntimeException(e10);
        }
        finally {
            if (buildTree) {
                if (!hitException10) {
                    closeNodeScope(node10,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node10.setEndLine(jjtEndToken.endLine);
                    node10.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 341
    final public void BuiltinVariable() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 343
        BuiltinVariable node11=null;
        if (buildTree) {
            node11=new BuiltinVariable();
            Token jjtStartToken=getToken(1);
            node11.setBeginLine(jjtStartToken.beginLine);
            node11.setBeginColumn(jjtStartToken.beginColumn);
            node11.setInputSource(this.getInputSource());
            openNodeScope(node11);
        }
        boolean hitException11=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 343
            jj_consume_token(DOT);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 343
            jj_consume_token(IDENTIFIER);
        }
        catch(Exception e11) {
            hitException11=false;
            if (e11 instanceof ParseException) throw(ParseException) e11;
            if (e11 instanceof RuntimeException) throw(RuntimeException) e11;
            throw new RuntimeException(e11);
        }
        finally {
            if (buildTree) {
                if (!hitException11) {
                    closeNodeScope(node11,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node11.setEndLine(jjtEndToken.endLine);
                    node11.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 346
    final public void DefaultToExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 348
        DefaultToExpression node12=null;
        if (buildTree) {
            node12=new DefaultToExpression();
            Token jjtStartToken=getToken(1);
            node12.setBeginLine(jjtStartToken.beginLine);
            node12.setBeginColumn(jjtStartToken.beginColumn);
            node12.setInputSource(this.getInputSource());
            openNodeScope(node12);
        }
        boolean hitException12=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 348
            PrimaryExpression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 352
            label_5:
            while (true) {
                if (!(jj_2_3(2147483647)&&(getToken(2).kind!=IDENTIFIER||getToken(3).kind!=EQUALS))) {
                    break label_5;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 350
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 351
                jj_consume_token(EXCLAM);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 351
                PrimaryExpression();
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 353
            int int7=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int7==EXCLAM) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 354
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 355
                jj_consume_token(EXCLAM);
            }
            else {
                jj_la1[14]=jj_gen;
            }
        }
        catch(Exception e12) {
            hitException12=false;
            if (e12 instanceof ParseException) throw(ParseException) e12;
            if (e12 instanceof RuntimeException) throw(RuntimeException) e12;
            throw new RuntimeException(e12);
        }
        finally {
            if (buildTree) {
                if (!hitException12) {
                    closeNodeScope(node12,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node12.setEndLine(jjtEndToken.endLine);
                    node12.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 359
    final public void PrimaryExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 361
        PrimaryExpression node13=null;
        if (buildTree) {
            node13=new PrimaryExpression();
            Token jjtStartToken=getToken(1);
            node13.setBeginLine(jjtStartToken.beginLine);
            node13.setBeginColumn(jjtStartToken.beginColumn);
            node13.setInputSource(this.getInputSource());
            openNodeScope(node13);
        }
        boolean hitException13=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 361
            BaseExpression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 375
            label_6:
            while (true) {
                if (!(jj_2_4(2147483647))) {
                    break label_6;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 363
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 365
                switch((jj_ntk==-1)?jj_ntk():
                jj_ntk) {
                    case DOT:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 365
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 365
                    DotKey();
                    break;
                    case OPEN_BRACKET:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 367
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 367
                    DynamicKey();
                    break;
                    case OPEN_PAREN:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 369
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 369
                    MethodInvoke();
                    break;
                    case BUILT_IN:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 371
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 371
                    BuiltIn();
                    break;
                    case EXISTS_OPERATOR:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 373
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 373
                    Exists();
                    break;
                    default:
                    jj_la1[15]=jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                }
            }
        }
        catch(Exception e13) {
            hitException13=false;
            if (e13 instanceof ParseException) throw(ParseException) e13;
            if (e13 instanceof RuntimeException) throw(RuntimeException) e13;
            throw new RuntimeException(e13);
        }
        finally {
            if (buildTree) {
                if (!hitException13) {
                    closeNodeScope(node13,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node13.setEndLine(jjtEndToken.endLine);
                    node13.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 378
    final public void BaseExpression() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 380
        BaseExpression node14=null;
        if (buildTree) {
            node14=new BaseExpression();
            Token jjtStartToken=getToken(1);
            node14.setBeginLine(jjtStartToken.beginLine);
            node14.setBeginColumn(jjtStartToken.beginColumn);
            node14.setInputSource(this.getInputSource());
            openNodeScope(node14);
        }
        boolean hitException14=false;
        try {
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case IDENTIFIER:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 380
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 380
                jj_consume_token(IDENTIFIER);
                break;
                case INTEGER:
                case DECIMAL:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 382
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 382
                NumberLiteral();
                break;
                case OPEN_BRACE:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 384
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 384
                HashLiteral();
                break;
                case STRING_LITERAL:
                case RAW_STRING:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 386
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 386
                StringLiteral();
                break;
                case TRUE:
                case FALSE:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 388
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 388
                BooleanLiteral();
                break;
                case NULL:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 390
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 390
                NullLiteral();
                break;
                case OPEN_BRACKET:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 392
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 392
                ListLiteral();
                break;
                case OPEN_PAREN:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 394
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 394
                Parenthesis();
                break;
                case DOT:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 396
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 396
                BuiltinVariable();
                break;
                default:
                jj_la1[16]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
        }
        catch(Exception e14) {
            hitException14=false;
            if (e14 instanceof ParseException) throw(ParseException) e14;
            if (e14 instanceof RuntimeException) throw(RuntimeException) e14;
            throw new RuntimeException(e14);
        }
        finally {
            if (buildTree) {
                if (!hitException14) {
                    closeNodeScope(node14,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node14.setEndLine(jjtEndToken.endLine);
                    node14.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 400
    final public void DotKey() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 402
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 402
        jj_consume_token(DOT);
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 403
        switch((jj_ntk==-1)?jj_ntk():
        jj_ntk) {
            case IDENTIFIER:
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 403
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 403
            jj_consume_token(IDENTIFIER);
            break;
            case TIMES:
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 403
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 403
            jj_consume_token(TIMES);
            break;
            default:
            jj_la1[17]=jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 406
    final public void DynamicKey() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 408
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 408
        jj_consume_token(OPEN_BRACKET);
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 408
        Expression();
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 408
        jj_consume_token(CLOSE_BRACKET);
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 412
    final public void MethodInvoke() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 414
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 414
        jj_consume_token(OPEN_PAREN);
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 414
        int int8=(jj_ntk==-1)?jj_ntk():
        jj_ntk;
        if (int8==OPEN_PAREN||int8==OPEN_BRACKET||int8==OPEN_BRACE||int8==DOT||int8==PLUS||int8==MINUS||int8==EXCLAM||int8==NULL||int8==TRUE||int8==FALSE||int8==INTEGER||int8==DECIMAL||int8==IDENTIFIER||int8==STRING_LITERAL||int8==RAW_STRING) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 414
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 414
            ArgsList();
        }
        else {
            jj_la1[18]=jj_gen;
        }
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 414
        jj_consume_token(CLOSE_PAREN);
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 417
    final public void BuiltIn() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 419
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 419
        jj_consume_token(BUILT_IN);
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 419
        jj_consume_token(IDENTIFIER);
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 422
    final public void Exists() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 424
        Exists node15=null;
        if (buildTree) {
            node15=new Exists();
            Token jjtStartToken=getToken(1);
            node15.setBeginLine(jjtStartToken.beginLine);
            node15.setBeginColumn(jjtStartToken.beginColumn);
            node15.setInputSource(this.getInputSource());
            openNodeScope(node15);
        }
        boolean hitException15=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 424
            jj_consume_token(EXISTS_OPERATOR);
        }
        catch(Exception e15) {
            hitException15=false;
            if (e15 instanceof ParseException) throw(ParseException) e15;
            if (e15 instanceof RuntimeException) throw(RuntimeException) e15;
            throw new RuntimeException(e15);
        }
        finally {
            if (buildTree) {
                if (!hitException15) {
                    closeNodeScope(node15,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node15.setEndLine(jjtEndToken.endLine);
                    node15.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 427
    final public void ListLiteral() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 429
        ListLiteral node16=null;
        if (buildTree) {
            node16=new ListLiteral();
            Token jjtStartToken=getToken(1);
            node16.setBeginLine(jjtStartToken.beginLine);
            node16.setBeginColumn(jjtStartToken.beginColumn);
            node16.setInputSource(this.getInputSource());
            openNodeScope(node16);
        }
        boolean hitException16=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 429
            jj_consume_token(OPEN_BRACKET);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 430
            int int11=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int11==OPEN_PAREN||int11==OPEN_BRACKET||int11==OPEN_BRACE||int11==DOT||int11==PLUS||int11==MINUS||int11==EXCLAM||int11==NULL||int11==TRUE||int11==FALSE||int11==INTEGER||int11==DECIMAL||int11==IDENTIFIER||int11==STRING_LITERAL||int11==RAW_STRING) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 430
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 430
                Expression();
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 430
                label_7:
                while (true) {
                    int int9=(jj_ntk==-1)?jj_ntk():
                    jj_ntk;
                    if (!(int9==OPEN_PAREN||int9==OPEN_BRACKET||int9==OPEN_BRACE||int9==DOT||int9==PLUS||int9==MINUS||int9==COMMA||int9==EXCLAM||int9==NULL||int9==TRUE||int9==FALSE||int9==INTEGER||int9==DECIMAL||int9==IDENTIFIER||int9==STRING_LITERAL||int9==RAW_STRING)) {
                        jj_la1[19]=jj_gen;
                        break label_7;
                    }
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 430
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 430
                    int int10=(jj_ntk==-1)?jj_ntk():
                    jj_ntk;
                    if (int10==COMMA) {
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 430
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 430
                        jj_consume_token(COMMA);
                    }
                    else {
                        jj_la1[20]=jj_gen;
                    }
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 430
                    Expression();
                }
            }
            else {
                jj_la1[21]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 431
            jj_consume_token(CLOSE_BRACKET);
        }
        catch(Exception e16) {
            hitException16=false;
            if (e16 instanceof ParseException) throw(ParseException) e16;
            if (e16 instanceof RuntimeException) throw(RuntimeException) e16;
            throw new RuntimeException(e16);
        }
        finally {
            if (buildTree) {
                if (!hitException16) {
                    closeNodeScope(node16,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node16.setEndLine(jjtEndToken.endLine);
                    node16.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 434
    final public void StringLiteral() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 436
        StringLiteral node17=null;
        if (buildTree) {
            node17=new StringLiteral();
            Token jjtStartToken=getToken(1);
            node17.setBeginLine(jjtStartToken.beginLine);
            node17.setBeginColumn(jjtStartToken.beginColumn);
            node17.setInputSource(this.getInputSource());
            openNodeScope(node17);
        }
        boolean hitException17=false;
        try {
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case STRING_LITERAL:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 436
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 436
                jj_consume_token(STRING_LITERAL);
                break;
                case RAW_STRING:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 436
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 436
                jj_consume_token(RAW_STRING);
                break;
                default:
                jj_la1[22]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
        }
        catch(Exception e17) {
            hitException17=false;
            if (e17 instanceof ParseException) throw(ParseException) e17;
            if (e17 instanceof RuntimeException) throw(RuntimeException) e17;
            throw new RuntimeException(e17);
        }
        finally {
            if (buildTree) {
                if (!hitException17) {
                    closeNodeScope(node17,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node17.setEndLine(jjtEndToken.endLine);
                    node17.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 440
    final public void HashLiteral() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 442
        HashLiteral node18=null;
        if (buildTree) {
            node18=new HashLiteral();
            Token jjtStartToken=getToken(1);
            node18.setBeginLine(jjtStartToken.beginLine);
            node18.setBeginColumn(jjtStartToken.beginColumn);
            node18.setInputSource(this.getInputSource());
            openNodeScope(node18);
        }
        boolean hitException18=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 442
            jj_consume_token(OPEN_BRACE);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 443
            int int13=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int13==OPEN_PAREN||int13==OPEN_BRACKET||int13==OPEN_BRACE||int13==DOT||int13==PLUS||int13==MINUS||int13==EXCLAM||int13==NULL||int13==TRUE||int13==FALSE||int13==INTEGER||int13==DECIMAL||int13==IDENTIFIER||int13==STRING_LITERAL||int13==RAW_STRING) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 444
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 444
                Expression();
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 444
                jj_consume_token(COLON);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 444
                Expression();
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 445
                label_8:
                while (true) {
                    int int12=(jj_ntk==-1)?jj_ntk():
                    jj_ntk;
                    if (!(int12==COMMA)) {
                        jj_la1[23]=jj_gen;
                        break label_8;
                    }
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 445
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 445
                    jj_consume_token(COMMA);
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 445
                    Expression();
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 445
                    jj_consume_token(COLON);
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 445
                    Expression();
                }
            }
            else {
                jj_la1[24]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 447
            jj_consume_token(CLOSE_BRACE);
        }
        catch(Exception e18) {
            hitException18=false;
            if (e18 instanceof ParseException) throw(ParseException) e18;
            if (e18 instanceof RuntimeException) throw(RuntimeException) e18;
            throw new RuntimeException(e18);
        }
        finally {
            if (buildTree) {
                if (!hitException18) {
                    closeNodeScope(node18,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node18.setEndLine(jjtEndToken.endLine);
                    node18.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 450
    final public void NumberLiteral() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 452
        NumberLiteral node19=null;
        if (buildTree) {
            node19=new NumberLiteral();
            Token jjtStartToken=getToken(1);
            node19.setBeginLine(jjtStartToken.beginLine);
            node19.setBeginColumn(jjtStartToken.beginColumn);
            node19.setInputSource(this.getInputSource());
            openNodeScope(node19);
        }
        boolean hitException19=false;
        try {
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case INTEGER:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 452
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 452
                jj_consume_token(INTEGER);
                break;
                case DECIMAL:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 452
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 452
                jj_consume_token(DECIMAL);
                break;
                default:
                jj_la1[25]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
        }
        catch(Exception e19) {
            hitException19=false;
            if (e19 instanceof ParseException) throw(ParseException) e19;
            if (e19 instanceof RuntimeException) throw(RuntimeException) e19;
            throw new RuntimeException(e19);
        }
        finally {
            if (buildTree) {
                if (!hitException19) {
                    closeNodeScope(node19,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node19.setEndLine(jjtEndToken.endLine);
                    node19.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 455
    final public void BooleanLiteral() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 457
        BooleanLiteral node20=null;
        if (buildTree) {
            node20=new BooleanLiteral();
            Token jjtStartToken=getToken(1);
            node20.setBeginLine(jjtStartToken.beginLine);
            node20.setBeginColumn(jjtStartToken.beginColumn);
            node20.setInputSource(this.getInputSource());
            openNodeScope(node20);
        }
        boolean hitException20=false;
        try {
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case TRUE:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 457
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 457
                jj_consume_token(TRUE);
                break;
                case FALSE:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 457
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 457
                jj_consume_token(FALSE);
                break;
                default:
                jj_la1[26]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
        }
        catch(Exception e20) {
            hitException20=false;
            if (e20 instanceof ParseException) throw(ParseException) e20;
            if (e20 instanceof RuntimeException) throw(RuntimeException) e20;
            throw new RuntimeException(e20);
        }
        finally {
            if (buildTree) {
                if (!hitException20) {
                    closeNodeScope(node20,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node20.setEndLine(jjtEndToken.endLine);
                    node20.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 460
    final public void NullLiteral() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 462
        NullLiteral node21=null;
        if (buildTree) {
            node21=new NullLiteral();
            Token jjtStartToken=getToken(1);
            node21.setBeginLine(jjtStartToken.beginLine);
            node21.setBeginColumn(jjtStartToken.beginColumn);
            node21.setInputSource(this.getInputSource());
            openNodeScope(node21);
        }
        boolean hitException21=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 462
            jj_consume_token(NULL);
        }
        catch(Exception e21) {
            hitException21=false;
            if (e21 instanceof ParseException) throw(ParseException) e21;
            if (e21 instanceof RuntimeException) throw(RuntimeException) e21;
            throw new RuntimeException(e21);
        }
        finally {
            if (buildTree) {
                if (!hitException21) {
                    closeNodeScope(node21,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node21.setEndLine(jjtEndToken.endLine);
                    node21.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 465
    final public void Parenthesis() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 467
        Parenthesis node22=null;
        if (buildTree) {
            node22=new Parenthesis();
            Token jjtStartToken=getToken(1);
            node22.setBeginLine(jjtStartToken.beginLine);
            node22.setBeginColumn(jjtStartToken.beginColumn);
            node22.setInputSource(this.getInputSource());
            openNodeScope(node22);
        }
        boolean hitException22=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 467
            jj_consume_token(OPEN_PAREN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 467
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 467
            jj_consume_token(CLOSE_PAREN);
        }
        catch(Exception e22) {
            hitException22=false;
            if (e22 instanceof ParseException) throw(ParseException) e22;
            if (e22 instanceof RuntimeException) throw(RuntimeException) e22;
            throw new RuntimeException(e22);
        }
        finally {
            if (buildTree) {
                if (!hitException22) {
                    closeNodeScope(node22,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node22.setEndLine(jjtEndToken.endLine);
                    node22.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 470
    final public void ArgsList() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 472
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 473
        if (jj_2_5(2147483647)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 473
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 474
            NamedArgsList();
        }
        else {
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case OPEN_PAREN:
                case OPEN_BRACKET:
                case OPEN_BRACE:
                case DOT:
                case PLUS:
                case MINUS:
                case EXCLAM:
                case NULL:
                case TRUE:
                case FALSE:
                case INTEGER:
                case DECIMAL:
                case IDENTIFIER:
                case STRING_LITERAL:
                case RAW_STRING:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 476
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 476
                PositionalArgsList();
                break;
                default:
                jj_la1[27]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 480
    final public void NamedArgsList() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 482
        NamedArgsList node23=null;
        if (buildTree) {
            node23=new NamedArgsList();
            Token jjtStartToken=getToken(1);
            node23.setBeginLine(jjtStartToken.beginLine);
            node23.setBeginColumn(jjtStartToken.beginColumn);
            node23.setInputSource(this.getInputSource());
            openNodeScope(node23);
        }
        boolean hitException23=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 482
            jj_consume_token(IDENTIFIER);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 483
            jj_consume_token(EQUALS);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 484
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 490
            label_9:
            while (true) {
                int int14=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (!(int14==COMMA||int14==IDENTIFIER)) {
                    jj_la1[28]=jj_gen;
                    break label_9;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 486
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 486
                int int15=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int15==COMMA) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 486
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 486
                    jj_consume_token(COMMA);
                }
                else {
                    jj_la1[29]=jj_gen;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 487
                jj_consume_token(IDENTIFIER);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 488
                jj_consume_token(EQUALS);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 489
                Expression();
            }
        }
        catch(Exception e23) {
            hitException23=false;
            if (e23 instanceof ParseException) throw(ParseException) e23;
            if (e23 instanceof RuntimeException) throw(RuntimeException) e23;
            throw new RuntimeException(e23);
        }
        finally {
            if (buildTree) {
                if (!hitException23) {
                    closeNodeScope(node23,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node23.setEndLine(jjtEndToken.endLine);
                    node23.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 493
    final public void PositionalArgsList() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 495
        PositionalArgsList node24=null;
        if (buildTree) {
            node24=new PositionalArgsList();
            Token jjtStartToken=getToken(1);
            node24.setBeginLine(jjtStartToken.beginLine);
            node24.setBeginColumn(jjtStartToken.beginColumn);
            node24.setInputSource(this.getInputSource());
            openNodeScope(node24);
        }
        boolean hitException24=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 495
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 499
            label_10:
            while (true) {
                int int16=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (!(int16==OPEN_PAREN||int16==OPEN_BRACKET||int16==OPEN_BRACE||int16==DOT||int16==PLUS||int16==MINUS||int16==COMMA||int16==EXCLAM||int16==NULL||int16==TRUE||int16==FALSE||int16==INTEGER||int16==DECIMAL||int16==IDENTIFIER||int16==STRING_LITERAL||int16==RAW_STRING)) {
                    jj_la1[30]=jj_gen;
                    break label_10;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 497
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 497
                int int17=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int17==COMMA) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 497
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 497
                    jj_consume_token(COMMA);
                }
                else {
                    jj_la1[31]=jj_gen;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FEL.freecc, line 498
                Expression();
            }
        }
        catch(Exception e24) {
            hitException24=false;
            if (e24 instanceof ParseException) throw(ParseException) e24;
            if (e24 instanceof RuntimeException) throw(RuntimeException) e24;
            throw new RuntimeException(e24);
        }
        finally {
            if (buildTree) {
                if (!hitException24) {
                    closeNodeScope(node24,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node24.setEndLine(jjtEndToken.endLine);
                    node24.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 408
    final public void IdentifierOrStringLiteral() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 410
        IdentifierOrStringLiteral node25=null;
        if (buildTree) {
            node25=new IdentifierOrStringLiteral();
            Token jjtStartToken=getToken(1);
            node25.setBeginLine(jjtStartToken.beginLine);
            node25.setBeginColumn(jjtStartToken.beginColumn);
            node25.setInputSource(this.getInputSource());
            openNodeScope(node25);
        }
        boolean hitException25=false;
        try {
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case IDENTIFIER:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 410
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 410
                jj_consume_token(IDENTIFIER);
                break;
                case STRING_LITERAL:
                case RAW_STRING:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 412
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 412
                StringLiteral();
                break;
                default:
                jj_la1[32]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
        }
        catch(Exception e25) {
            hitException25=false;
            if (e25 instanceof ParseException) throw(ParseException) e25;
            if (e25 instanceof RuntimeException) throw(RuntimeException) e25;
            throw new RuntimeException(e25);
        }
        finally {
            if (buildTree) {
                if (!hitException25) {
                    closeNodeScope(node25,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node25.setEndLine(jjtEndToken.endLine);
                    node25.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 416
    final public void Interpolation() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 418
        Interpolation node26=null;
        if (buildTree) {
            node26=new Interpolation();
            Token jjtStartToken=getToken(1);
            node26.setBeginLine(jjtStartToken.beginLine);
            node26.setBeginColumn(jjtStartToken.beginColumn);
            node26.setInputSource(this.getInputSource());
            openNodeScope(node26);
        }
        boolean hitException26=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 418
            jj_consume_token(INTERPOLATE);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 418
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 418
            jj_consume_token(CLOSE_BRACE);
        }
        catch(Exception e26) {
            hitException26=false;
            if (e26 instanceof ParseException) throw(ParseException) e26;
            if (e26 instanceof RuntimeException) throw(RuntimeException) e26;
            throw new RuntimeException(e26);
        }
        finally {
            if (buildTree) {
                if (!hitException26) {
                    closeNodeScope(node26,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node26.setEndLine(jjtEndToken.endLine);
                    node26.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 421
    final public void NumericalInterpolation() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 423
        NumericalInterpolation node27=null;
        if (buildTree) {
            node27=new NumericalInterpolation();
            Token jjtStartToken=getToken(1);
            node27.setBeginLine(jjtStartToken.beginLine);
            node27.setBeginColumn(jjtStartToken.beginColumn);
            node27.setInputSource(this.getInputSource());
            openNodeScope(node27);
        }
        boolean hitException27=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 423
            jj_consume_token(NUMERICAL_INTERPOLATE);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 423
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 423
            int int18=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int18==SEMICOLON) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 423
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 423
                jj_consume_token(SEMICOLON);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 423
                jj_consume_token(IDENTIFIER);
            }
            else {
                jj_la1[33]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 423
            jj_consume_token(CLOSE_BRACE);
        }
        catch(Exception e27) {
            hitException27=false;
            if (e27 instanceof ParseException) throw(ParseException) e27;
            if (e27 instanceof RuntimeException) throw(RuntimeException) e27;
            throw new RuntimeException(e27);
        }
        finally {
            if (buildTree) {
                if (!hitException27) {
                    closeNodeScope(node27,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node27.setEndLine(jjtEndToken.endLine);
                    node27.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 427
    final public void Assignment() throws ParseException {
        Token t;
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 432
        Assignment node28=null;
        if (buildTree) {
            node28=new Assignment();
            Token jjtStartToken=getToken(1);
            node28.setBeginLine(jjtStartToken.beginLine);
            node28.setBeginColumn(jjtStartToken.beginColumn);
            node28.setInputSource(this.getInputSource());
            openNodeScope(node28);
        }
        boolean hitException28=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 432
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 434
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case SET:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 434
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 434
                t=jj_consume_token(SET);
                break;
                case ASSIGN:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 435
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 435
                t=jj_consume_token(ASSIGN);
                break;
                case LOCAL:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 436
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 436
                t=jj_consume_token(LOCAL);
                break;
                case GLOBAL:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 437
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 437
                t=jj_consume_token(GLOBAL);
                break;
                default:
                jj_la1[34]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 439
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 440
            IdentifierOrStringLiteral();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 442
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case EQUALS:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 442
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 443
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 443
                jj_consume_token(EQUALS);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 443
                Expression();
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 444
                label_11:
                while (true) {
                    int int19=(jj_ntk==-1)?jj_ntk():
                    jj_ntk;
                    if (!(int19==COMMA||int19==IDENTIFIER||int19==STRING_LITERAL||int19==RAW_STRING)) {
                        jj_la1[35]=jj_gen;
                        break label_11;
                    }
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 444
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 444
                    int int20=(jj_ntk==-1)?jj_ntk():
                    jj_ntk;
                    if (int20==COMMA) {
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 444
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 444
                        jj_consume_token(COMMA);
                    }
                    else {
                        jj_la1[36]=jj_gen;
                    }
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 444
                    IdentifierOrStringLiteral();
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 444
                    jj_consume_token(EQUALS);
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 444
                    Expression();
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 445
                int int21=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int21==IN) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 445
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 445
                    jj_consume_token(IN);
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 445
                    Expression();
                }
                else {
                    jj_la1[37]=jj_gen;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 446
                LooseTagEnd();
                break;
                case IN:
                case CLOSE_TAG:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 449
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 450
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 450
                int int22=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int22==IN) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 450
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 450
                    jj_consume_token(IN);
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 450
                    Expression();
                }
                else {
                    jj_la1[38]=jj_gen;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 451
                jj_consume_token(CLOSE_TAG);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 452
                Block();
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 453
                DirectiveEnd(t.image);
                break;
                default:
                jj_la1[39]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
        }
        catch(Exception e28) {
            hitException28=false;
            if (e28 instanceof ParseException) throw(ParseException) e28;
            if (e28 instanceof RuntimeException) throw(RuntimeException) e28;
            throw new RuntimeException(e28);
        }
        finally {
            if (buildTree) {
                if (!hitException28) {
                    closeNodeScope(node28,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node28.setEndLine(jjtEndToken.endLine);
                    node28.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 458
    final public void Var() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 460
        VarInstruction node29=null;
        if (buildTree) {
            node29=new VarInstruction();
            Token jjtStartToken=getToken(1);
            node29.setBeginLine(jjtStartToken.beginLine);
            node29.setBeginColumn(jjtStartToken.beginColumn);
            node29.setInputSource(this.getInputSource());
            openNodeScope(node29);
        }
        boolean hitException29=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 460
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 460
            jj_consume_token(VAR);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 460
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 461
            IdentifierOrStringLiteral();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 461
            int int23=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int23==EQUALS) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 461
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 461
                jj_consume_token(EQUALS);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 461
                Expression();
            }
            else {
                jj_la1[40]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 462
            label_12:
            while (true) {
                int int24=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (!(int24==COMMA||int24==IDENTIFIER||int24==STRING_LITERAL||int24==RAW_STRING)) {
                    jj_la1[41]=jj_gen;
                    break label_12;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 462
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 462
                int int25=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int25==COMMA) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 462
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 462
                    jj_consume_token(COMMA);
                }
                else {
                    jj_la1[42]=jj_gen;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 462
                IdentifierOrStringLiteral();
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 462
                int int26=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int26==EQUALS) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 462
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 462
                    jj_consume_token(EQUALS);
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 462
                    Expression();
                }
                else {
                    jj_la1[43]=jj_gen;
                }
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 463
            LooseTagEnd();
        }
        catch(Exception e29) {
            hitException29=false;
            if (e29 instanceof ParseException) throw(ParseException) e29;
            if (e29 instanceof RuntimeException) throw(RuntimeException) e29;
            throw new RuntimeException(e29);
        }
        finally {
            if (buildTree) {
                if (!hitException29) {
                    closeNodeScope(node29,true);
                    Token jjtEndToken=getToken(0);
                    node29.setEndLine(jjtEndToken.endLine);
                    node29.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 466
    final public void Setting() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 468
        SettingInstruction node30=null;
        if (buildTree) {
            node30=new SettingInstruction();
            Token jjtStartToken=getToken(1);
            node30.setBeginLine(jjtStartToken.beginLine);
            node30.setBeginColumn(jjtStartToken.beginColumn);
            node30.setInputSource(this.getInputSource());
            openNodeScope(node30);
        }
        boolean hitException30=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 468
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 468
            jj_consume_token(SETTING);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 468
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 469
            jj_consume_token(IDENTIFIER);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 469
            int int27=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int27==EQUALS) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 469
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 469
                jj_consume_token(EQUALS);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 469
                Expression();
            }
            else {
                jj_la1[44]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 470
            label_13:
            while (true) {
                int int28=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (!(int28==COMMA||int28==IDENTIFIER||int28==STRING_LITERAL||int28==RAW_STRING)) {
                    jj_la1[45]=jj_gen;
                    break label_13;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 470
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 470
                int int29=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int29==COMMA) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 470
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 470
                    jj_consume_token(COMMA);
                }
                else {
                    jj_la1[46]=jj_gen;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 470
                IdentifierOrStringLiteral();
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 470
                int int30=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int30==EQUALS) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 470
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 470
                    jj_consume_token(EQUALS);
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 470
                    Expression();
                }
                else {
                    jj_la1[47]=jj_gen;
                }
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 471
            LooseTagEnd();
        }
        catch(Exception e30) {
            hitException30=false;
            if (e30 instanceof ParseException) throw(ParseException) e30;
            if (e30 instanceof RuntimeException) throw(RuntimeException) e30;
            throw new RuntimeException(e30);
        }
        finally {
            if (buildTree) {
                if (!hitException30) {
                    closeNodeScope(node30,true);
                    Token jjtEndToken=getToken(0);
                    node30.setEndLine(jjtEndToken.endLine);
                    node30.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 474
    final public void Attempt() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 476
        AttemptRecover node31=null;
        if (buildTree) {
            node31=new AttemptRecover();
            Token jjtStartToken=getToken(1);
            node31.setBeginLine(jjtStartToken.beginLine);
            node31.setBeginColumn(jjtStartToken.beginColumn);
            node31.setInputSource(this.getInputSource());
            openNodeScope(node31);
        }
        boolean hitException31=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 476
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 476
            jj_consume_token(ATTEMPT);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 476
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 477
            Block();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 478
            Recover();
        }
        catch(Exception e31) {
            hitException31=false;
            if (e31 instanceof ParseException) throw(ParseException) e31;
            if (e31 instanceof RuntimeException) throw(RuntimeException) e31;
            throw new RuntimeException(e31);
        }
        finally {
            if (buildTree) {
                if (!hitException31) {
                    closeNodeScope(node31,true);
                    Token jjtEndToken=getToken(0);
                    node31.setEndLine(jjtEndToken.endLine);
                    node31.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 481
    final public void Comment() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 483
        CommentBlock node32=null;
        if (buildTree) {
            node32=new CommentBlock();
            Token jjtStartToken=getToken(1);
            node32.setBeginLine(jjtStartToken.beginLine);
            node32.setBeginColumn(jjtStartToken.beginColumn);
            node32.setInputSource(this.getInputSource());
            openNodeScope(node32);
        }
        boolean hitException32=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 483
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 483
            jj_consume_token(COMMENT);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 484
            jj_consume_token(END_COMMENT);
        }
        catch(Exception e32) {
            hitException32=false;
            if (e32 instanceof ParseException) throw(ParseException) e32;
            if (e32 instanceof RuntimeException) throw(RuntimeException) e32;
            throw new RuntimeException(e32);
        }
        finally {
            if (buildTree) {
                if (!hitException32) {
                    closeNodeScope(node32,true);
                    Token jjtEndToken=getToken(0);
                    node32.setEndLine(jjtEndToken.endLine);
                    node32.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 487
    final public void NoParse() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 489
        NoParseBlock node33=null;
        if (buildTree) {
            node33=new NoParseBlock();
            Token jjtStartToken=getToken(1);
            node33.setBeginLine(jjtStartToken.beginLine);
            node33.setBeginColumn(jjtStartToken.beginColumn);
            node33.setInputSource(this.getInputSource());
            openNodeScope(node33);
        }
        boolean hitException33=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 489
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 489
            jj_consume_token(NOPARSE);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 490
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 490
            token_source.SwitchTo(NO_PARSE);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 491
            jj_consume_token(NOPARSE_END);
        }
        catch(Exception e33) {
            hitException33=false;
            if (e33 instanceof ParseException) throw(ParseException) e33;
            if (e33 instanceof RuntimeException) throw(RuntimeException) e33;
            throw new RuntimeException(e33);
        }
        finally {
            if (buildTree) {
                if (!hitException33) {
                    closeNodeScope(node33,true);
                    Token jjtEndToken=getToken(0);
                    node33.setEndLine(jjtEndToken.endLine);
                    node33.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 496
    final public void Trim() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 498
        TrimInstruction node34=null;
        if (buildTree) {
            node34=new TrimInstruction();
            Token jjtStartToken=getToken(1);
            node34.setBeginLine(jjtStartToken.beginLine);
            node34.setBeginColumn(jjtStartToken.beginColumn);
            node34.setInputSource(this.getInputSource());
            openNodeScope(node34);
        }
        boolean hitException34=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 498
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 498
            jj_consume_token(TRIM);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 499
            LooseTagEnd();
        }
        catch(Exception e34) {
            hitException34=false;
            if (e34 instanceof ParseException) throw(ParseException) e34;
            if (e34 instanceof RuntimeException) throw(RuntimeException) e34;
            throw new RuntimeException(e34);
        }
        finally {
            if (buildTree) {
                if (!hitException34) {
                    closeNodeScope(node34,true);
                    Token jjtEndToken=getToken(0);
                    node34.setEndLine(jjtEndToken.endLine);
                    node34.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 503
    final public void NoTrim() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 505
        TrimInstruction node35=null;
        if (buildTree) {
            node35=new TrimInstruction();
            Token jjtStartToken=getToken(1);
            node35.setBeginLine(jjtStartToken.beginLine);
            node35.setBeginColumn(jjtStartToken.beginColumn);
            node35.setInputSource(this.getInputSource());
            openNodeScope(node35);
        }
        boolean hitException35=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 505
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 505
            jj_consume_token(NOTRIM);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 506
            LooseTagEnd();
        }
        catch(Exception e35) {
            hitException35=false;
            if (e35 instanceof ParseException) throw(ParseException) e35;
            if (e35 instanceof RuntimeException) throw(RuntimeException) e35;
            throw new RuntimeException(e35);
        }
        finally {
            if (buildTree) {
                if (!hitException35) {
                    closeNodeScope(node35,true);
                    Token jjtEndToken=getToken(0);
                    node35.setEndLine(jjtEndToken.endLine);
                    node35.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 510
    final public void RightTrim() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 512
        TrimInstruction node36=null;
        if (buildTree) {
            node36=new TrimInstruction();
            Token jjtStartToken=getToken(1);
            node36.setBeginLine(jjtStartToken.beginLine);
            node36.setBeginColumn(jjtStartToken.beginColumn);
            node36.setInputSource(this.getInputSource());
            openNodeScope(node36);
        }
        boolean hitException36=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 512
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 512
            jj_consume_token(RTRIM);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 513
            LooseTagEnd();
        }
        catch(Exception e36) {
            hitException36=false;
            if (e36 instanceof ParseException) throw(ParseException) e36;
            if (e36 instanceof RuntimeException) throw(RuntimeException) e36;
            throw new RuntimeException(e36);
        }
        finally {
            if (buildTree) {
                if (!hitException36) {
                    closeNodeScope(node36,true);
                    Token jjtEndToken=getToken(0);
                    node36.setEndLine(jjtEndToken.endLine);
                    node36.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 517
    final public void LeftTrim() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 519
        TrimInstruction node37=null;
        if (buildTree) {
            node37=new TrimInstruction();
            Token jjtStartToken=getToken(1);
            node37.setBeginLine(jjtStartToken.beginLine);
            node37.setBeginColumn(jjtStartToken.beginColumn);
            node37.setInputSource(this.getInputSource());
            openNodeScope(node37);
        }
        boolean hitException37=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 519
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 519
            jj_consume_token(LTRIM);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 520
            LooseTagEnd();
        }
        catch(Exception e37) {
            hitException37=false;
            if (e37 instanceof ParseException) throw(ParseException) e37;
            if (e37 instanceof RuntimeException) throw(RuntimeException) e37;
            throw new RuntimeException(e37);
        }
        finally {
            if (buildTree) {
                if (!hitException37) {
                    closeNodeScope(node37,true);
                    Token jjtEndToken=getToken(0);
                    node37.setEndLine(jjtEndToken.endLine);
                    node37.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 523
    final public void Break() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 525
        BreakInstruction node38=null;
        if (buildTree) {
            node38=new BreakInstruction();
            Token jjtStartToken=getToken(1);
            node38.setBeginLine(jjtStartToken.beginLine);
            node38.setBeginColumn(jjtStartToken.beginColumn);
            node38.setInputSource(this.getInputSource());
            openNodeScope(node38);
        }
        boolean hitException38=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 525
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 526
            jj_consume_token(BREAK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 527
            LooseTagEnd();
        }
        catch(Exception e38) {
            hitException38=false;
            if (e38 instanceof ParseException) throw(ParseException) e38;
            if (e38 instanceof RuntimeException) throw(RuntimeException) e38;
            throw new RuntimeException(e38);
        }
        finally {
            if (buildTree) {
                if (!hitException38) {
                    closeNodeScope(node38,true);
                    Token jjtEndToken=getToken(0);
                    node38.setEndLine(jjtEndToken.endLine);
                    node38.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 530
    final public void Flush() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 532
        FlushInstruction node39=null;
        if (buildTree) {
            node39=new FlushInstruction();
            Token jjtStartToken=getToken(1);
            node39.setBeginLine(jjtStartToken.beginLine);
            node39.setBeginColumn(jjtStartToken.beginColumn);
            node39.setInputSource(this.getInputSource());
            openNodeScope(node39);
        }
        boolean hitException39=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 532
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 532
            jj_consume_token(FLUSH);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 532
            LooseTagEnd();
        }
        catch(Exception e39) {
            hitException39=false;
            if (e39 instanceof ParseException) throw(ParseException) e39;
            if (e39 instanceof RuntimeException) throw(RuntimeException) e39;
            throw new RuntimeException(e39);
        }
        finally {
            if (buildTree) {
                if (!hitException39) {
                    closeNodeScope(node39,true);
                    Token jjtEndToken=getToken(0);
                    node39.setEndLine(jjtEndToken.endLine);
                    node39.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 535
    final public void Return() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 537
        ReturnInstruction node40=null;
        if (buildTree) {
            node40=new ReturnInstruction();
            Token jjtStartToken=getToken(1);
            node40.setBeginLine(jjtStartToken.beginLine);
            node40.setBeginColumn(jjtStartToken.beginColumn);
            node40.setInputSource(this.getInputSource());
            openNodeScope(node40);
        }
        boolean hitException40=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 537
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 537
            jj_consume_token(RETURN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 538
            int int31=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int31==BLANK) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 538
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 538
                jj_consume_token(BLANK);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 538
                Expression();
            }
            else {
                jj_la1[48]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 539
            LooseTagEnd();
        }
        catch(Exception e40) {
            hitException40=false;
            if (e40 instanceof ParseException) throw(ParseException) e40;
            if (e40 instanceof RuntimeException) throw(RuntimeException) e40;
            throw new RuntimeException(e40);
        }
        finally {
            if (buildTree) {
                if (!hitException40) {
                    closeNodeScope(node40,true);
                    Token jjtEndToken=getToken(0);
                    node40.setEndLine(jjtEndToken.endLine);
                    node40.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 542
    final public void Stop() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 544
        StopInstruction node41=null;
        if (buildTree) {
            node41=new StopInstruction();
            Token jjtStartToken=getToken(1);
            node41.setBeginLine(jjtStartToken.beginLine);
            node41.setBeginColumn(jjtStartToken.beginColumn);
            node41.setInputSource(this.getInputSource());
            openNodeScope(node41);
        }
        boolean hitException41=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 544
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 544
            jj_consume_token(STOP);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 545
            int int32=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int32==BLANK) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 545
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 545
                jj_consume_token(BLANK);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 545
                Expression();
            }
            else {
                jj_la1[49]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 546
            LooseTagEnd();
        }
        catch(Exception e41) {
            hitException41=false;
            if (e41 instanceof ParseException) throw(ParseException) e41;
            if (e41 instanceof RuntimeException) throw(RuntimeException) e41;
            throw new RuntimeException(e41);
        }
        finally {
            if (buildTree) {
                if (!hitException41) {
                    closeNodeScope(node41,true);
                    Token jjtEndToken=getToken(0);
                    node41.setEndLine(jjtEndToken.endLine);
                    node41.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 550
    final public void Compress() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 552
        CompressBlock node42=null;
        if (buildTree) {
            node42=new CompressBlock();
            Token jjtStartToken=getToken(1);
            node42.setBeginLine(jjtStartToken.beginLine);
            node42.setBeginColumn(jjtStartToken.beginColumn);
            node42.setInputSource(this.getInputSource());
            openNodeScope(node42);
        }
        boolean hitException42=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 552
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 552
            jj_consume_token(COMPRESS);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 552
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 553
            Block();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 554
            DirectiveEnd("compress");
        }
        catch(Exception e42) {
            hitException42=false;
            if (e42 instanceof ParseException) throw(ParseException) e42;
            if (e42 instanceof RuntimeException) throw(RuntimeException) e42;
            throw new RuntimeException(e42);
        }
        finally {
            if (buildTree) {
                if (!hitException42) {
                    closeNodeScope(node42,true);
                    Token jjtEndToken=getToken(0);
                    node42.setEndLine(jjtEndToken.endLine);
                    node42.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 557
    final public void TrimBlock() throws ParseException {
        String closeTag;
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 562
        TrimBlock node43=null;
        if (buildTree) {
            node43=new TrimBlock();
            Token jjtStartToken=getToken(1);
            node43.setBeginLine(jjtStartToken.beginLine);
            node43.setBeginColumn(jjtStartToken.beginColumn);
            node43.setInputSource(this.getInputSource());
            openNodeScope(node43);
        }
        boolean hitException43=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 562
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 564
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case BLOCKTRIM:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 564
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 564
                jj_consume_token(BLOCKTRIM);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 564
                closeTag="t_lines";
                break;
                case BLOCKTRIML:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 566
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 566
                jj_consume_token(BLOCKTRIML);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 566
                closeTag="lt_lines";
                break;
                case BLOCKTRIMR:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 568
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 568
                jj_consume_token(BLOCKTRIMR);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 568
                closeTag="rt_lines";
                break;
                case BLOCKNOTRIM:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 570
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 570
                jj_consume_token(BLOCKNOTRIM);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 570
                closeTag="nt_lines";
                break;
                default:
                jj_la1[50]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 572
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 573
            Block();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 574
            DirectiveEnd(closeTag);
        }
        catch(Exception e43) {
            hitException43=false;
            if (e43 instanceof ParseException) throw(ParseException) e43;
            if (e43 instanceof RuntimeException) throw(RuntimeException) e43;
            throw new RuntimeException(e43);
        }
        finally {
            if (buildTree) {
                if (!hitException43) {
                    closeNodeScope(node43,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node43.setEndLine(jjtEndToken.endLine);
                    node43.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 577
    final public void NoEscapeBlock() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 579
        NoEscapeBlock node44=null;
        if (buildTree) {
            node44=new NoEscapeBlock();
            Token jjtStartToken=getToken(1);
            node44.setBeginLine(jjtStartToken.beginLine);
            node44.setBeginColumn(jjtStartToken.beginColumn);
            node44.setInputSource(this.getInputSource());
            openNodeScope(node44);
        }
        boolean hitException44=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 579
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 579
            jj_consume_token(NOESCAPE);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 579
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 580
            Block();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 581
            DirectiveEnd("noescape");
        }
        catch(Exception e44) {
            hitException44=false;
            if (e44 instanceof ParseException) throw(ParseException) e44;
            if (e44 instanceof RuntimeException) throw(RuntimeException) e44;
            throw new RuntimeException(e44);
        }
        finally {
            if (buildTree) {
                if (!hitException44) {
                    closeNodeScope(node44,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node44.setEndLine(jjtEndToken.endLine);
                    node44.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 584
    final public void EscapeBlock() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 586
        EscapeBlock node45=null;
        if (buildTree) {
            node45=new EscapeBlock();
            Token jjtStartToken=getToken(1);
            node45.setBeginLine(jjtStartToken.beginLine);
            node45.setBeginColumn(jjtStartToken.beginColumn);
            node45.setInputSource(this.getInputSource());
            openNodeScope(node45);
        }
        boolean hitException45=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 586
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 587
            jj_consume_token(ESCAPE);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 588
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 589
            jj_consume_token(IDENTIFIER);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 590
            jj_consume_token(AS);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 591
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 592
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 593
            Block();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 594
            DirectiveEnd("escape");
        }
        catch(Exception e45) {
            hitException45=false;
            if (e45 instanceof ParseException) throw(ParseException) e45;
            if (e45 instanceof RuntimeException) throw(RuntimeException) e45;
            throw new RuntimeException(e45);
        }
        finally {
            if (buildTree) {
                if (!hitException45) {
                    closeNodeScope(node45,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node45.setEndLine(jjtEndToken.endLine);
                    node45.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 597
    final public void Include() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 599
        IncludeInstruction node46=null;
        if (buildTree) {
            node46=new IncludeInstruction();
            Token jjtStartToken=getToken(1);
            node46.setBeginLine(jjtStartToken.beginLine);
            node46.setBeginColumn(jjtStartToken.beginColumn);
            node46.setInputSource(this.getInputSource());
            openNodeScope(node46);
        }
        boolean hitException46=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 599
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 599
            jj_consume_token(_INCLUDE);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 599
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 600
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 601
            int int33=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int33==SEMICOLON) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 601
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 601
                jj_consume_token(SEMICOLON);
            }
            else {
                jj_la1[51]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 602
            label_14:
            while (true) {
                int int34=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (!(int34==IDENTIFIER)) {
                    jj_la1[52]=jj_gen;
                    break label_14;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 602
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 602
                jj_consume_token(IDENTIFIER);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 602
                jj_consume_token(EQUALS);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 602
                Expression();
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 603
            LooseTagEnd();
        }
        catch(Exception e46) {
            hitException46=false;
            if (e46 instanceof ParseException) throw(ParseException) e46;
            if (e46 instanceof RuntimeException) throw(RuntimeException) e46;
            throw new RuntimeException(e46);
        }
        finally {
            if (buildTree) {
                if (!hitException46) {
                    closeNodeScope(node46,true);
                    Token jjtEndToken=getToken(0);
                    node46.setEndLine(jjtEndToken.endLine);
                    node46.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 606
    final public void Embed() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 608
        EmbedInstruction node47=null;
        if (buildTree) {
            node47=new EmbedInstruction();
            Token jjtStartToken=getToken(1);
            node47.setBeginLine(jjtStartToken.beginLine);
            node47.setBeginColumn(jjtStartToken.beginColumn);
            node47.setInputSource(this.getInputSource());
            openNodeScope(node47);
        }
        boolean hitException47=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 608
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 608
            jj_consume_token(EMBED);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 608
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 609
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 610
            LooseTagEnd();
        }
        catch(Exception e47) {
            hitException47=false;
            if (e47 instanceof ParseException) throw(ParseException) e47;
            if (e47 instanceof RuntimeException) throw(RuntimeException) e47;
            throw new RuntimeException(e47);
        }
        finally {
            if (buildTree) {
                if (!hitException47) {
                    closeNodeScope(node47,true);
                    Token jjtEndToken=getToken(0);
                    node47.setEndLine(jjtEndToken.endLine);
                    node47.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 613
    final public void Import() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 615
        ImportInstruction node48=null;
        if (buildTree) {
            node48=new ImportInstruction();
            Token jjtStartToken=getToken(1);
            node48.setBeginLine(jjtStartToken.beginLine);
            node48.setBeginColumn(jjtStartToken.beginColumn);
            node48.setInputSource(this.getInputSource());
            openNodeScope(node48);
        }
        boolean hitException48=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 615
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 615
            jj_consume_token(IMPORT);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 615
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 616
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 617
            jj_consume_token(AS);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 618
            jj_consume_token(IDENTIFIER);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 619
            LooseTagEnd();
        }
        catch(Exception e48) {
            hitException48=false;
            if (e48 instanceof ParseException) throw(ParseException) e48;
            if (e48 instanceof RuntimeException) throw(RuntimeException) e48;
            throw new RuntimeException(e48);
        }
        finally {
            if (buildTree) {
                if (!hitException48) {
                    closeNodeScope(node48,true);
                    Token jjtEndToken=getToken(0);
                    node48.setEndLine(jjtEndToken.endLine);
                    node48.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 622
    final public void Visit() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 624
        VisitInstruction node49=null;
        if (buildTree) {
            node49=new VisitInstruction();
            Token jjtStartToken=getToken(1);
            node49.setBeginLine(jjtStartToken.beginLine);
            node49.setBeginColumn(jjtStartToken.beginColumn);
            node49.setInputSource(this.getInputSource());
            openNodeScope(node49);
        }
        boolean hitException49=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 624
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 625
            jj_consume_token(VISIT);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 626
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 627
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 628
            int int37=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int37==USING) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 629
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 629
                jj_consume_token(USING);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 630
                Expression();
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 634
                label_15:
                while (true) {
                    int int35=(jj_ntk==-1)?jj_ntk():
                    jj_ntk;
                    if (!(int35==OPEN_PAREN||int35==OPEN_BRACKET||int35==OPEN_BRACE||int35==DOT||int35==PLUS||int35==MINUS||int35==COMMA||int35==EXCLAM||int35==NULL||int35==TRUE||int35==FALSE||int35==INTEGER||int35==DECIMAL||int35==IDENTIFIER||int35==STRING_LITERAL||int35==RAW_STRING)) {
                        jj_la1[53]=jj_gen;
                        break label_15;
                    }
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 632
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 632
                    int int36=(jj_ntk==-1)?jj_ntk():
                    jj_ntk;
                    if (int36==COMMA) {
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 632
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 632
                        jj_consume_token(COMMA);
                    }
                    else {
                        jj_la1[54]=jj_gen;
                    }
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 633
                    Expression();
                }
            }
            else {
                jj_la1[55]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 636
            LooseTagEnd();
        }
        catch(Exception e49) {
            hitException49=false;
            if (e49 instanceof ParseException) throw(ParseException) e49;
            if (e49 instanceof RuntimeException) throw(RuntimeException) e49;
            throw new RuntimeException(e49);
        }
        finally {
            if (buildTree) {
                if (!hitException49) {
                    closeNodeScope(node49,true);
                    Token jjtEndToken=getToken(0);
                    node49.setEndLine(jjtEndToken.endLine);
                    node49.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 639
    final public void Recurse() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 641
        RecurseInstruction node50=null;
        if (buildTree) {
            node50=new RecurseInstruction();
            Token jjtStartToken=getToken(1);
            node50.setBeginLine(jjtStartToken.beginLine);
            node50.setBeginColumn(jjtStartToken.beginColumn);
            node50.setInputSource(this.getInputSource());
            openNodeScope(node50);
        }
        boolean hitException50=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 641
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 641
            jj_consume_token(RECURSE);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 643
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case CLOSE_TAG:
                case CLOSE_EMPTY_TAG:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 643
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 643
                LooseTagEnd();
                break;
                case BLANK:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 645
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 646
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 646
                jj_consume_token(BLANK);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 647
                int int38=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int38==OPEN_PAREN||int38==OPEN_BRACKET||int38==OPEN_BRACE||int38==DOT||int38==PLUS||int38==MINUS||int38==EXCLAM||int38==NULL||int38==TRUE||int38==FALSE||int38==INTEGER||int38==DECIMAL||int38==IDENTIFIER||int38==STRING_LITERAL||int38==RAW_STRING) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 647
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 647
                    Expression();
                }
                else {
                    jj_la1[56]=jj_gen;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 648
                int int41=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int41==USING) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 648
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 648
                    jj_consume_token(USING);
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 649
                    Expression();
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 650
                    label_16:
                    while (true) {
                        int int39=(jj_ntk==-1)?jj_ntk():
                        jj_ntk;
                        if (!(int39==OPEN_PAREN||int39==OPEN_BRACKET||int39==OPEN_BRACE||int39==DOT||int39==PLUS||int39==MINUS||int39==COMMA||int39==EXCLAM||int39==NULL||int39==TRUE||int39==FALSE||int39==INTEGER||int39==DECIMAL||int39==IDENTIFIER||int39==STRING_LITERAL||int39==RAW_STRING)) {
                            jj_la1[57]=jj_gen;
                            break label_16;
                        }
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 650
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 650
                        int int40=(jj_ntk==-1)?jj_ntk():
                        jj_ntk;
                        if (int40==COMMA) {
                            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 650
                            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 650
                            jj_consume_token(COMMA);
                        }
                        else {
                            jj_la1[58]=jj_gen;
                        }
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 650
                        Expression();
                    }
                }
                else {
                    jj_la1[59]=jj_gen;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 652
                LooseTagEnd();
                break;
                default:
                jj_la1[60]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
        }
        catch(Exception e50) {
            hitException50=false;
            if (e50 instanceof ParseException) throw(ParseException) e50;
            if (e50 instanceof RuntimeException) throw(RuntimeException) e50;
            throw new RuntimeException(e50);
        }
        finally {
            if (buildTree) {
                if (!hitException50) {
                    closeNodeScope(node50,true);
                    Token jjtEndToken=getToken(0);
                    node50.setEndLine(jjtEndToken.endLine);
                    node50.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 657
    final public void FallBack() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 659
        FallBackInstruction node51=null;
        if (buildTree) {
            node51=new FallBackInstruction();
            Token jjtStartToken=getToken(1);
            node51.setBeginLine(jjtStartToken.beginLine);
            node51.setBeginColumn(jjtStartToken.beginColumn);
            node51.setInputSource(this.getInputSource());
            openNodeScope(node51);
        }
        boolean hitException51=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 659
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 660
            jj_consume_token(FALLBACK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 661
            LooseTagEnd();
        }
        catch(Exception e51) {
            hitException51=false;
            if (e51 instanceof ParseException) throw(ParseException) e51;
            if (e51 instanceof RuntimeException) throw(RuntimeException) e51;
            throw new RuntimeException(e51);
        }
        finally {
            if (buildTree) {
                if (!hitException51) {
                    closeNodeScope(node51,true);
                    Token jjtEndToken=getToken(0);
                    node51.setEndLine(jjtEndToken.endLine);
                    node51.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 664
    final public void If() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 666
        IfStatement node52=null;
        if (buildTree) {
            node52=new IfStatement();
            Token jjtStartToken=getToken(1);
            node52.setBeginLine(jjtStartToken.beginLine);
            node52.setBeginColumn(jjtStartToken.beginColumn);
            node52.setInputSource(this.getInputSource());
            openNodeScope(node52);
        }
        boolean hitException52=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 666
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 666
            jj_consume_token(IF);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 666
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 667
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 668
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 669
            Block();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 673
            label_17:
            while (true) {
                if (!(jj_2_6(2))) {
                    break label_17;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 671
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 672
                ElseIf();
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 674
            if (jj_2_7(2)) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 675
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 676
                Else();
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 678
            DirectiveEnd("if");
        }
        catch(Exception e52) {
            hitException52=false;
            if (e52 instanceof ParseException) throw(ParseException) e52;
            if (e52 instanceof RuntimeException) throw(RuntimeException) e52;
            throw new RuntimeException(e52);
        }
        finally {
            if (buildTree) {
                if (!hitException52) {
                    closeNodeScope(node52,true);
                    Token jjtEndToken=getToken(0);
                    node52.setEndLine(jjtEndToken.endLine);
                    node52.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 681
    final public void ElseIf() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 683
        ElseIfBlock node53=null;
        if (buildTree) {
            node53=new ElseIfBlock();
            Token jjtStartToken=getToken(1);
            node53.setBeginLine(jjtStartToken.beginLine);
            node53.setBeginColumn(jjtStartToken.beginColumn);
            node53.setInputSource(this.getInputSource());
            openNodeScope(node53);
        }
        boolean hitException53=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 683
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 683
            jj_consume_token(ELSEIF);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 683
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 684
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 685
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 686
            Block();
        }
        catch(Exception e53) {
            hitException53=false;
            if (e53 instanceof ParseException) throw(ParseException) e53;
            if (e53 instanceof RuntimeException) throw(RuntimeException) e53;
            throw new RuntimeException(e53);
        }
        finally {
            if (buildTree) {
                if (!hitException53) {
                    closeNodeScope(node53,true);
                    Token jjtEndToken=getToken(0);
                    node53.setEndLine(jjtEndToken.endLine);
                    node53.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 689
    final public void Else() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 691
        ElseBlock node54=null;
        if (buildTree) {
            node54=new ElseBlock();
            Token jjtStartToken=getToken(1);
            node54.setBeginLine(jjtStartToken.beginLine);
            node54.setBeginColumn(jjtStartToken.beginColumn);
            node54.setInputSource(this.getInputSource());
            openNodeScope(node54);
        }
        boolean hitException54=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 691
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 691
            jj_consume_token(ELSE);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 691
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 692
            Block();
        }
        catch(Exception e54) {
            hitException54=false;
            if (e54 instanceof ParseException) throw(ParseException) e54;
            if (e54 instanceof RuntimeException) throw(RuntimeException) e54;
            throw new RuntimeException(e54);
        }
        finally {
            if (buildTree) {
                if (!hitException54) {
                    closeNodeScope(node54,true);
                    Token jjtEndToken=getToken(0);
                    node54.setEndLine(jjtEndToken.endLine);
                    node54.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 695
    final public void Switch() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 697
        SwitchInstruction node55=null;
        if (buildTree) {
            node55=new SwitchInstruction();
            Token jjtStartToken=getToken(1);
            node55.setBeginLine(jjtStartToken.beginLine);
            node55.setBeginColumn(jjtStartToken.beginColumn);
            node55.setInputSource(this.getInputSource());
            openNodeScope(node55);
        }
        boolean hitException55=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 697
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 697
            jj_consume_token(SWITCH);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 697
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 698
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 699
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 700
            int int42=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int42==WHITESPACE) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 700
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 700
                jj_consume_token(WHITESPACE);
            }
            else {
                jj_la1[61]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 704
            label_18:
            while (true) {
                if (!(jj_2_8(2))) {
                    break label_18;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 702
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 703
                Case();
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 705
            if (jj_2_9(2)) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 706
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 707
                Default();
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 709
            DirectiveEnd("switch");
        }
        catch(Exception e55) {
            hitException55=false;
            if (e55 instanceof ParseException) throw(ParseException) e55;
            if (e55 instanceof RuntimeException) throw(RuntimeException) e55;
            throw new RuntimeException(e55);
        }
        finally {
            if (buildTree) {
                if (!hitException55) {
                    closeNodeScope(node55,true);
                    Token jjtEndToken=getToken(0);
                    node55.setEndLine(jjtEndToken.endLine);
                    node55.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 712
    final public void Case() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 714
        CaseInstruction node56=null;
        if (buildTree) {
            node56=new CaseInstruction();
            Token jjtStartToken=getToken(1);
            node56.setBeginLine(jjtStartToken.beginLine);
            node56.setBeginColumn(jjtStartToken.beginColumn);
            node56.setInputSource(this.getInputSource());
            openNodeScope(node56);
        }
        boolean hitException56=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 714
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 714
            jj_consume_token(CASE);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 714
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 715
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 716
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 717
            Block();
        }
        catch(Exception e56) {
            hitException56=false;
            if (e56 instanceof ParseException) throw(ParseException) e56;
            if (e56 instanceof RuntimeException) throw(RuntimeException) e56;
            throw new RuntimeException(e56);
        }
        finally {
            if (buildTree) {
                if (!hitException56) {
                    closeNodeScope(node56,true);
                    Token jjtEndToken=getToken(0);
                    node56.setEndLine(jjtEndToken.endLine);
                    node56.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 720
    final public void Default() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 722
        DefaultInstruction node57=null;
        if (buildTree) {
            node57=new DefaultInstruction();
            Token jjtStartToken=getToken(1);
            node57.setBeginLine(jjtStartToken.beginLine);
            node57.setBeginColumn(jjtStartToken.beginColumn);
            node57.setInputSource(this.getInputSource());
            openNodeScope(node57);
        }
        boolean hitException57=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 722
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 722
            jj_consume_token(DEFAUL);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 722
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 723
            Block();
        }
        catch(Exception e57) {
            hitException57=false;
            if (e57 instanceof ParseException) throw(ParseException) e57;
            if (e57 instanceof RuntimeException) throw(RuntimeException) e57;
            throw new RuntimeException(e57);
        }
        finally {
            if (buildTree) {
                if (!hitException57) {
                    closeNodeScope(node57,true);
                    Token jjtEndToken=getToken(0);
                    node57.setEndLine(jjtEndToken.endLine);
                    node57.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 726
    final public void List() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 728
        ListInstruction node58=null;
        if (buildTree) {
            node58=new ListInstruction();
            Token jjtStartToken=getToken(1);
            node58.setBeginLine(jjtStartToken.beginLine);
            node58.setBeginColumn(jjtStartToken.beginColumn);
            node58.setInputSource(this.getInputSource());
            openNodeScope(node58);
        }
        boolean hitException58=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 728
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 728
            jj_consume_token(LIST);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 728
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 729
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 730
            jj_consume_token(AS);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 731
            jj_consume_token(IDENTIFIER);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 732
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 733
            Block();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 734
            DirectiveEnd("list");
        }
        catch(Exception e58) {
            hitException58=false;
            if (e58 instanceof ParseException) throw(ParseException) e58;
            if (e58 instanceof RuntimeException) throw(RuntimeException) e58;
            throw new RuntimeException(e58);
        }
        finally {
            if (buildTree) {
                if (!hitException58) {
                    closeNodeScope(node58,true);
                    Token jjtEndToken=getToken(0);
                    node58.setEndLine(jjtEndToken.endLine);
                    node58.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 737
    final public void ForEach() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 739
        ForEachInstruction node59=null;
        if (buildTree) {
            node59=new ForEachInstruction();
            Token jjtStartToken=getToken(1);
            node59.setBeginLine(jjtStartToken.beginLine);
            node59.setBeginColumn(jjtStartToken.beginColumn);
            node59.setInputSource(this.getInputSource());
            openNodeScope(node59);
        }
        boolean hitException59=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 739
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 739
            jj_consume_token(FOREACH);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 739
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 740
            jj_consume_token(IDENTIFIER);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 741
            jj_consume_token(IN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 742
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 743
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 744
            Block();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 745
            DirectiveEnd("foreach");
        }
        catch(Exception e59) {
            hitException59=false;
            if (e59 instanceof ParseException) throw(ParseException) e59;
            if (e59 instanceof RuntimeException) throw(RuntimeException) e59;
            throw new RuntimeException(e59);
        }
        finally {
            if (buildTree) {
                if (!hitException59) {
                    closeNodeScope(node59,true);
                    Token jjtEndToken=getToken(0);
                    node59.setEndLine(jjtEndToken.endLine);
                    node59.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 748
    final public void Nested() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 750
        NestedInstruction node60=null;
        if (buildTree) {
            node60=new NestedInstruction();
            Token jjtStartToken=getToken(1);
            node60.setBeginLine(jjtStartToken.beginLine);
            node60.setBeginColumn(jjtStartToken.beginColumn);
            node60.setInputSource(this.getInputSource());
            openNodeScope(node60);
        }
        boolean hitException60=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 750
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 750
            jj_consume_token(NESTED);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 751
            int int43=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int43==BLANK) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 751
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 751
                jj_consume_token(BLANK);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 751
                PositionalArgsList();
            }
            else {
                jj_la1[62]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 752
            LooseTagEnd();
        }
        catch(Exception e60) {
            hitException60=false;
            if (e60 instanceof ParseException) throw(ParseException) e60;
            if (e60 instanceof RuntimeException) throw(RuntimeException) e60;
            throw new RuntimeException(e60);
        }
        finally {
            if (buildTree) {
                if (!hitException60) {
                    closeNodeScope(node60,true);
                    Token jjtEndToken=getToken(0);
                    node60.setEndLine(jjtEndToken.endLine);
                    node60.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 755
    final public void MacroDefinition() throws ParseException {
        Token t;
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 760
        MacroDefinition node61=null;
        if (buildTree) {
            node61=new MacroDefinition();
            Token jjtStartToken=getToken(1);
            node61.setBeginLine(jjtStartToken.beginLine);
            node61.setBeginColumn(jjtStartToken.beginColumn);
            node61.setInputSource(this.getInputSource());
            openNodeScope(node61);
        }
        boolean hitException61=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 760
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 762
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case MACRO:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 762
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 762
                t=jj_consume_token(MACRO);
                break;
                case FUNCTION:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 764
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 764
                t=jj_consume_token(FUNCTION);
                break;
                default:
                jj_la1[63]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 766
            jj_consume_token(BLANK);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 767
            IdentifierOrStringLiteral();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 768
            int int44=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int44==OPEN_PAREN) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 768
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 768
                jj_consume_token(OPEN_PAREN);
            }
            else {
                jj_la1[64]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 769
            int int45=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int45==IDENTIFIER) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 769
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 769
                ParameterList();
            }
            else {
                jj_la1[65]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 770
            int int46=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int46==CLOSE_PAREN) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 770
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 770
                jj_consume_token(CLOSE_PAREN);
            }
            else {
                jj_la1[66]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 771
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 772
            Block();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 773
            DirectiveEnd(t.image);
        }
        catch(Exception e61) {
            hitException61=false;
            if (e61 instanceof ParseException) throw(ParseException) e61;
            if (e61 instanceof RuntimeException) throw(RuntimeException) e61;
            throw new RuntimeException(e61);
        }
        finally {
            if (buildTree) {
                if (!hitException61) {
                    closeNodeScope(node61,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node61.setEndLine(jjtEndToken.endLine);
                    node61.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 776
    final public void ParameterList() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 781
        ParameterList node62=null;
        if (buildTree) {
            node62=new ParameterList();
            Token jjtStartToken=getToken(1);
            node62.setBeginLine(jjtStartToken.beginLine);
            node62.setBeginColumn(jjtStartToken.beginColumn);
            node62.setInputSource(this.getInputSource());
            openNodeScope(node62);
        }
        boolean hitException62=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 781
            jj_consume_token(IDENTIFIER);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 782
            int int47=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int47==EQUALS||int47==ELLIPSIS) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 782
                switch((jj_ntk==-1)?jj_ntk():
                jj_ntk) {
                    case EQUALS:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 782
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 782
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 782
                    jj_consume_token(EQUALS);
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 782
                    Expression();
                    break;
                    case ELLIPSIS:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 782
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 782
                    jj_consume_token(ELLIPSIS);
                    break;
                    default:
                    jj_la1[67]=jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                }
            }
            else {
                jj_la1[68]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 791
            label_19:
            while (true) {
                int int48=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (!(int48==COMMA||int48==IDENTIFIER)) {
                    jj_la1[69]=jj_gen;
                    break label_19;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 784
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 784
                int int49=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int49==COMMA) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 784
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 784
                    jj_consume_token(COMMA);
                }
                else {
                    jj_la1[70]=jj_gen;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 785
                jj_consume_token(IDENTIFIER);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 786
                int int50=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int50==EQUALS||int50==ELLIPSIS) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 787
                    switch((jj_ntk==-1)?jj_ntk():
                    jj_ntk) {
                        case EQUALS:
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 787
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 787
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 787
                        jj_consume_token(EQUALS);
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 787
                        Expression();
                        break;
                        case ELLIPSIS:
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 789
                        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 789
                        jj_consume_token(ELLIPSIS);
                        break;
                        default:
                        jj_la1[71]=jj_gen;
                        jj_consume_token(-1);
                        throw new ParseException();
                    }
                }
                else {
                    jj_la1[72]=jj_gen;
                }
            }
        }
        catch(Exception e62) {
            hitException62=false;
            if (e62 instanceof ParseException) throw(ParseException) e62;
            if (e62 instanceof RuntimeException) throw(RuntimeException) e62;
            throw new RuntimeException(e62);
        }
        finally {
            if (buildTree) {
                if (!hitException62) {
                    closeNodeScope(node62,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node62.setEndLine(jjtEndToken.endLine);
                    node62.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 795
    final public void LooseTagEnd() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 797
        LooseTagEnd node63=null;
        if (buildTree) {
            node63=new LooseTagEnd();
            Token jjtStartToken=getToken(1);
            node63.setBeginLine(jjtStartToken.beginLine);
            node63.setBeginColumn(jjtStartToken.beginColumn);
            node63.setInputSource(this.getInputSource());
            openNodeScope(node63);
        }
        boolean hitException63=false;
        try {
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case CLOSE_TAG:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 797
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 797
                jj_consume_token(CLOSE_TAG);
                break;
                case CLOSE_EMPTY_TAG:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 799
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 799
                jj_consume_token(CLOSE_EMPTY_TAG);
                break;
                default:
                jj_la1[73]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
        }
        catch(Exception e63) {
            hitException63=false;
            if (e63 instanceof ParseException) throw(ParseException) e63;
            if (e63 instanceof RuntimeException) throw(RuntimeException) e63;
            throw new RuntimeException(e63);
        }
        finally {
            if (buildTree) {
                if (!hitException63) {
                    closeNodeScope(node63,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node63.setEndLine(jjtEndToken.endLine);
                    node63.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 802
    final public void DirectiveEnd(String name) throws ParseException {
        Token t;
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 807
        DirectiveEnd node64=null;
        if (buildTree) {
            node64=new DirectiveEnd();
            Token jjtStartToken=getToken(1);
            node64.setBeginLine(jjtStartToken.beginLine);
            node64.setBeginColumn(jjtStartToken.beginColumn);
            node64.setInputSource(this.getInputSource());
            openNodeScope(node64);
        }
        boolean hitException64=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 807
            t=jj_consume_token(END_DIRECTIVE);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 808
            String tag=t.image;
            tag=tag.substring(3);
            tag=tag.substring(0,tag.length()-1).trim();
            if (tag.length()!=0&&!name.equals(tag)) {
                if (true) throw new ParseException("Expecting closing tag for "+name);
            }
        }
        catch(Exception e64) {
            hitException64=false;
            if (e64 instanceof ParseException) throw(ParseException) e64;
            if (e64 instanceof RuntimeException) throw(RuntimeException) e64;
            throw new RuntimeException(e64);
        }
        finally {
            if (buildTree) {
                if (!hitException64) {
                    closeNodeScope(node64,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node64.setEndLine(jjtEndToken.endLine);
                    node64.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 818
    final public void Text() throws ParseException {
        Token t;
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 823
        Text node65=null;
        if (buildTree) {
            node65=new Text();
            Token jjtStartToken=getToken(1);
            node65.setBeginLine(jjtStartToken.beginLine);
            node65.setBeginColumn(jjtStartToken.beginColumn);
            node65.setInputSource(this.getInputSource());
            openNodeScope(node65);
        }
        boolean hitException65=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 828
            label_20:
            while (true) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 824
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 825
                switch((jj_ntk==-1)?jj_ntk():
                jj_ntk) {
                    case PRINTABLE_CHARS:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 825
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 825
                    t=jj_consume_token(PRINTABLE_CHARS);
                    break;
                    case WHITESPACE:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 826
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 826
                    t=jj_consume_token(WHITESPACE);
                    break;
                    case SPECIAL_CHAR:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 827
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 827
                    t=jj_consume_token(SPECIAL_CHAR);
                    break;
                    default:
                    jj_la1[74]=jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                }
                int int51=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (!(int51==WHITESPACE||int51==SPECIAL_CHAR||int51==PRINTABLE_CHARS)) {
                    jj_la1[75]=jj_gen;
                    break label_20;
                }
            }
        }
        catch(Exception e65) {
            hitException65=false;
            if (e65 instanceof ParseException) throw(ParseException) e65;
            if (e65 instanceof RuntimeException) throw(RuntimeException) e65;
            throw new RuntimeException(e65);
        }
        finally {
            if (buildTree) {
                if (!hitException65) {
                    closeNodeScope(node65,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node65.setEndLine(jjtEndToken.endLine);
                    node65.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 832
    final public void Recover() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 834
        RecoverBlock node66=null;
        if (buildTree) {
            node66=new RecoverBlock();
            Token jjtStartToken=getToken(1);
            node66.setBeginLine(jjtStartToken.beginLine);
            node66.setBeginColumn(jjtStartToken.beginColumn);
            node66.setInputSource(this.getInputSource());
            openNodeScope(node66);
        }
        boolean hitException66=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 834
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 834
            jj_consume_token(RECOVER);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 834
            jj_consume_token(CLOSE_TAG);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 835
            Block();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 836
            DirectiveEnd("attempt");
        }
        catch(Exception e66) {
            hitException66=false;
            if (e66 instanceof ParseException) throw(ParseException) e66;
            if (e66 instanceof RuntimeException) throw(RuntimeException) e66;
            throw new RuntimeException(e66);
        }
        finally {
            if (buildTree) {
                if (!hitException66) {
                    closeNodeScope(node66,true);
                    Token jjtEndToken=getToken(0);
                    node66.setEndLine(jjtEndToken.endLine);
                    node66.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 839
    final public void TopLevelDirective() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 841
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 842
        if (jj_2_10(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 842
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 842
            Assignment();
        }
        else if (jj_2_11(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 843
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 843
            Attempt();
        }
        else if (jj_2_12(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 844
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 844
            Comment();
        }
        else if (jj_2_13(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 845
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 845
            Compress();
        }
        else if (jj_2_14(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 846
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 846
            Embed();
        }
        else if (jj_2_15(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 847
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 847
            ForEach();
        }
        else if (jj_2_16(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 848
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 848
            If();
        }
        else if (jj_2_17(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 849
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 849
            List();
        }
        else if (jj_2_18(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 850
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 850
            Include();
        }
        else if (jj_2_19(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 851
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 851
            Import();
        }
        else if (jj_2_20(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 852
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 852
            MacroDefinition();
        }
        else if (jj_2_21(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 853
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 853
            NoParse();
        }
        else if (jj_2_22(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 854
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 854
            Switch();
        }
        else if (jj_2_23(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 855
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 855
            Setting();
        }
        else if (jj_2_24(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 856
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 856
            Var();
        }
        else if (jj_2_25(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 857
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 857
            Break();
        }
        else if (jj_2_26(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 858
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 858
            Return();
        }
        else if (jj_2_27(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 859
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 859
            Stop();
        }
        else if (jj_2_28(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 860
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 860
            Flush();
        }
        else if (jj_2_29(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 861
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 861
            Trim();
        }
        else if (jj_2_30(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 862
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 862
            NoTrim();
        }
        else if (jj_2_31(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 863
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 863
            LeftTrim();
        }
        else if (jj_2_32(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 864
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 864
            RightTrim();
        }
        else if (jj_2_33(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 865
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 865
            TrimBlock();
        }
        else if (jj_2_34(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 866
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 866
            Nested();
        }
        else if (jj_2_35(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 867
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 867
            EscapeBlock();
        }
        else if (jj_2_36(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 868
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 868
            NoEscapeBlock();
        }
        else if (jj_2_37(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 869
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 869
            Visit();
        }
        else if (jj_2_38(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 870
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 870
            Recurse();
        }
        else if (jj_2_39(2)) {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 871
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 871
            FallBack();
        }
        else {
            jj_consume_token(-1);
            throw new ParseException();
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 875
    final public void UserDirective() throws ParseException {
        Token startToken;
        token_source.noWhitespaceInExpression=true;
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 881
        UserDirective node67=null;
        if (buildTree) {
            node67=new UserDirective();
            Token jjtStartToken=getToken(1);
            node67.setBeginLine(jjtStartToken.beginLine);
            node67.setBeginColumn(jjtStartToken.beginColumn);
            node67.setInputSource(this.getInputSource());
            openNodeScope(node67);
        }
        boolean hitException67=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 881
            startToken=jj_consume_token(USER_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 882
            Expression();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 883
            token_source.noWhitespaceInExpression=false;
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 884
            int int52=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int52==BLANK) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 884
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 884
                jj_consume_token(BLANK);
            }
            else {
                jj_la1[76]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 885
            int int53=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int53==OPEN_PAREN||int53==OPEN_BRACKET||int53==OPEN_BRACE||int53==DOT||int53==PLUS||int53==MINUS||int53==EXCLAM||int53==NULL||int53==TRUE||int53==FALSE||int53==INTEGER||int53==DECIMAL||int53==IDENTIFIER||int53==STRING_LITERAL||int53==RAW_STRING) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 885
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 885
                ArgsList();
            }
            else {
                jj_la1[77]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 886
            int int55=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int55==SEMICOLON) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 886
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 886
                jj_consume_token(SEMICOLON);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 886
                int int54=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int54==IDENTIFIER) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 886
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 886
                    ParameterList();
                }
                else {
                    jj_la1[78]=jj_gen;
                }
            }
            else {
                jj_la1[79]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 888
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case CLOSE_EMPTY_TAG:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 888
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 888
                jj_consume_token(CLOSE_EMPTY_TAG);
                break;
                case CLOSE_TAG:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 890
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 891
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 891
                jj_consume_token(CLOSE_TAG);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 892
                Block();
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 893
                EndUserDirective(startToken);
                break;
                default:
                jj_la1[80]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
        }
        catch(Exception e67) {
            hitException67=false;
            if (e67 instanceof ParseException) throw(ParseException) e67;
            if (e67 instanceof RuntimeException) throw(RuntimeException) e67;
            throw new RuntimeException(e67);
        }
        finally {
            if (buildTree) {
                if (!hitException67) {
                    closeNodeScope(node67,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node67.setEndLine(jjtEndToken.endLine);
                    node67.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 898
    final public void EndUserDirective(Token startToken) throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 900
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 900
        jj_consume_token(END_USER_DIRECTIVE);
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 903
    final public void Block() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 905
        Block node68=null;
        if (buildTree) {
            node68=new Block();
            Token jjtStartToken=getToken(1);
            node68.setBeginLine(jjtStartToken.beginLine);
            node68.setBeginColumn(jjtStartToken.beginColumn);
            node68.setInputSource(this.getInputSource());
            openNodeScope(node68);
        }
        boolean hitException68=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 918
            label_21:
            while (true) {
                if (!(jj_2_40(2))) {
                    break label_21;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 906
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 908
                switch((jj_ntk==-1)?jj_ntk():
                jj_ntk) {
                    case WHITESPACE:
                    case SPECIAL_CHAR:
                    case PRINTABLE_CHARS:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 908
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 908
                    Text();
                    break;
                    case INTERPOLATE:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 910
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 910
                    Interpolation();
                    break;
                    case NUMERICAL_INTERPOLATE:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 912
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 912
                    NumericalInterpolation();
                    break;
                    case USER_DIRECTIVE_OPEN:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 914
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 914
                    UserDirective();
                    break;
                    case FTL_DIRECTIVE_OPEN:
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 916
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 916
                    TopLevelDirective();
                    break;
                    default:
                    jj_la1[81]=jj_gen;
                    jj_consume_token(-1);
                    throw new ParseException();
                }
            }
        }
        catch(Exception e68) {
            hitException68=false;
            if (e68 instanceof ParseException) throw(ParseException) e68;
            if (e68 instanceof RuntimeException) throw(RuntimeException) e68;
            throw new RuntimeException(e68);
        }
        finally {
            if (buildTree) {
                if (!hitException68) {
                    closeNodeScope(node68,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node68.setEndLine(jjtEndToken.endLine);
                    node68.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 921
    final public void FTLHeader() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 923
        FTLHeader node69=null;
        if (buildTree) {
            node69=new FTLHeader();
            Token jjtStartToken=getToken(1);
            node69.setBeginLine(jjtStartToken.beginLine);
            node69.setBeginColumn(jjtStartToken.beginColumn);
            node69.setInputSource(this.getInputSource());
            openNodeScope(node69);
        }
        boolean hitException69=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 923
            jj_consume_token(FTL_DIRECTIVE_OPEN);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 923
            jj_consume_token(FTL);
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 924
            int int57=(jj_ntk==-1)?jj_ntk():
            jj_ntk;
            if (int57==BLANK) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 925
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 925
                jj_consume_token(BLANK);
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 930
                label_22:
                while (true) {
                    int int56=(jj_ntk==-1)?jj_ntk():
                    jj_ntk;
                    if (!(int56==IDENTIFIER)) {
                        jj_la1[82]=jj_gen;
                        break label_22;
                    }
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 927
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 927
                    jj_consume_token(IDENTIFIER);
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 928
                    jj_consume_token(EQUALS);
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 929
                    Expression();
                }
            }
            else {
                jj_la1[83]=jj_gen;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 932
            switch((jj_ntk==-1)?jj_ntk():
            jj_ntk) {
                case CLOSE_TAG:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 932
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 932
                jj_consume_token(CLOSE_TAG);
                break;
                case CLOSE_EMPTY_TAG:
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 932
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 932
                jj_consume_token(CLOSE_EMPTY_TAG);
                break;
                default:
                jj_la1[84]=jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
            }
        }
        catch(Exception e69) {
            hitException69=false;
            if (e69 instanceof ParseException) throw(ParseException) e69;
            if (e69 instanceof RuntimeException) throw(RuntimeException) e69;
            throw new RuntimeException(e69);
        }
        finally {
            if (buildTree) {
                if (!hitException69) {
                    closeNodeScope(node69,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node69.setEndLine(jjtEndToken.endLine);
                    node69.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 937
    final public void Root() throws ParseException {
        // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 939
        Root node70=null;
        if (buildTree) {
            node70=new Root();
            Token jjtStartToken=getToken(1);
            node70.setBeginLine(jjtStartToken.beginLine);
            node70.setBeginColumn(jjtStartToken.beginColumn);
            node70.setInputSource(this.getInputSource());
            openNodeScope(node70);
        }
        boolean hitException70=false;
        try {
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 939
            if (jj_2_41(2147483647)) {
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 940
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 941
                int int58=(jj_ntk==-1)?jj_ntk():
                jj_ntk;
                if (int58==WHITESPACE) {
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 941
                    // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 941
                    jj_consume_token(WHITESPACE);
                }
                else {
                    jj_la1[85]=jj_gen;
                }
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 942
                FTLHeader();
                // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 942
                token_source.rightAfterHeader=true;
            }
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 944
            Block();
            // /home/revusky/tmp/freecc-0.9.3/examples/freemarker/FTL.freecc, line 945
            jj_consume_token(0);
        }
        catch(Exception e70) {
            hitException70=false;
            if (e70 instanceof ParseException) throw(ParseException) e70;
            if (e70 instanceof RuntimeException) throw(RuntimeException) e70;
            throw new RuntimeException(e70);
        }
        finally {
            if (buildTree) {
                if (!hitException70) {
                    closeNodeScope(node70,nodeArity()>1);
                    Token jjtEndToken=getToken(0);
                    node70.setEndLine(jjtEndToken.endLine);
                    node70.setEndColumn(jjtEndToken.endColumn);
                }
                else {
                    clearNodeScope();
                    mark=marks.remove(marks.size()-1);
                }
            }
        }
    }

    private boolean jj_2_1(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_1();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(0,xla);
        }
    }

    private boolean jj_2_2(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_2();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(1,xla);
        }
    }

    private boolean jj_2_3(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_3();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(2,xla);
        }
    }

    private boolean jj_2_4(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_4();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(3,xla);
        }
    }

    private boolean jj_2_5(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_5();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(4,xla);
        }
    }

    private boolean jj_2_6(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_6();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(5,xla);
        }
    }

    private boolean jj_2_7(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_7();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(6,xla);
        }
    }

    private boolean jj_2_8(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_8();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(7,xla);
        }
    }

    private boolean jj_2_9(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_9();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(8,xla);
        }
    }

    private boolean jj_2_10(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_10();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(9,xla);
        }
    }

    private boolean jj_2_11(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_11();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(10,xla);
        }
    }

    private boolean jj_2_12(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_12();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(11,xla);
        }
    }

    private boolean jj_2_13(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_13();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(12,xla);
        }
    }

    private boolean jj_2_14(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_14();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(13,xla);
        }
    }

    private boolean jj_2_15(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_15();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(14,xla);
        }
    }

    private boolean jj_2_16(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_16();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(15,xla);
        }
    }

    private boolean jj_2_17(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_17();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(16,xla);
        }
    }

    private boolean jj_2_18(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_18();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(17,xla);
        }
    }

    private boolean jj_2_19(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_19();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(18,xla);
        }
    }

    private boolean jj_2_20(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_20();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(19,xla);
        }
    }

    private boolean jj_2_21(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_21();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(20,xla);
        }
    }

    private boolean jj_2_22(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_22();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(21,xla);
        }
    }

    private boolean jj_2_23(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_23();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(22,xla);
        }
    }

    private boolean jj_2_24(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_24();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(23,xla);
        }
    }

    private boolean jj_2_25(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_25();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(24,xla);
        }
    }

    private boolean jj_2_26(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_26();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(25,xla);
        }
    }

    private boolean jj_2_27(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_27();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(26,xla);
        }
    }

    private boolean jj_2_28(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_28();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(27,xla);
        }
    }

    private boolean jj_2_29(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_29();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(28,xla);
        }
    }

    private boolean jj_2_30(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_30();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(29,xla);
        }
    }

    private boolean jj_2_31(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_31();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(30,xla);
        }
    }

    private boolean jj_2_32(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_32();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(31,xla);
        }
    }

    private boolean jj_2_33(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_33();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(32,xla);
        }
    }

    private boolean jj_2_34(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_34();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(33,xla);
        }
    }

    private boolean jj_2_35(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_35();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(34,xla);
        }
    }

    private boolean jj_2_36(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_36();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(35,xla);
        }
    }

    private boolean jj_2_37(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_37();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(36,xla);
        }
    }

    private boolean jj_2_38(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_38();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(37,xla);
        }
    }

    private boolean jj_2_39(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_39();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(38,xla);
        }
    }

    private boolean jj_2_40(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_40();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(39,xla);
        }
    }

    private boolean jj_2_41(int xla) {
        jj_la=xla;
        jj_lastpos=jj_scanpos=current_token;
        try {
            return!jj_3_41();
        }
        catch(LookaheadSuccess ls) {
            return true;
        }
        finally {
            jj_save(40,xla);
        }
    }

    private boolean jj_3_1() {
        if (jj_3R_23()) return true;
        return false;
    }

    private boolean jj_3_2() {
        Token token59=jj_scanpos;
        if (jj_scan_token(16)) {
            jj_scanpos=token59;
            if (jj_scan_token(17)) return true;
        }
        return false;
    }

    private boolean jj_3_3() {
        if (jj_scan_token(EXCLAM)) return true;
        if (jj_3R_24()) return true;
        return false;
    }

    private boolean jj_3_4() {
        Token token60=jj_scanpos;
        if (jj_scan_token(15)) {
            jj_scanpos=token60;
            if (jj_scan_token(10)) {
                jj_scanpos=token60;
                if (jj_scan_token(8)) {
                    jj_scanpos=token60;
                    if (jj_scan_token(29)) {
                        jj_scanpos=token60;
                        if (jj_scan_token(32)) return true;
                    }
                }
            }
        }
        return false;
    }

    private boolean jj_3_5() {
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(EQUALS)) return true;
        return false;
    }

    private boolean jj_3_6() {
        if (jj_3R_25()) return true;
        return false;
    }

    private boolean jj_3_7() {
        if (jj_3R_26()) return true;
        return false;
    }

    private boolean jj_3_8() {
        if (jj_3R_27()) return true;
        return false;
    }

    private boolean jj_3_9() {
        if (jj_3R_28()) return true;
        return false;
    }

    private boolean jj_3_10() {
        if (jj_3R_29()) return true;
        return false;
    }

    private boolean jj_3_11() {
        if (jj_3R_30()) return true;
        return false;
    }

    private boolean jj_3_12() {
        if (jj_3R_31()) return true;
        return false;
    }

    private boolean jj_3_13() {
        if (jj_3R_32()) return true;
        return false;
    }

    private boolean jj_3_14() {
        if (jj_3R_33()) return true;
        return false;
    }

    private boolean jj_3_15() {
        if (jj_3R_34()) return true;
        return false;
    }

    private boolean jj_3_16() {
        if (jj_3R_35()) return true;
        return false;
    }

    private boolean jj_3_17() {
        if (jj_3R_36()) return true;
        return false;
    }

    private boolean jj_3_18() {
        if (jj_3R_37()) return true;
        return false;
    }

    private boolean jj_3_19() {
        if (jj_3R_38()) return true;
        return false;
    }

    private boolean jj_3_20() {
        if (jj_3R_39()) return true;
        return false;
    }

    private boolean jj_3_21() {
        if (jj_3R_40()) return true;
        return false;
    }

    private boolean jj_3_22() {
        if (jj_3R_41()) return true;
        return false;
    }

    private boolean jj_3_23() {
        if (jj_3R_42()) return true;
        return false;
    }

    private boolean jj_3_24() {
        if (jj_3R_43()) return true;
        return false;
    }

    private boolean jj_3_25() {
        if (jj_3R_44()) return true;
        return false;
    }

    private boolean jj_3_26() {
        if (jj_3R_45()) return true;
        return false;
    }

    private boolean jj_3_27() {
        if (jj_3R_46()) return true;
        return false;
    }

    private boolean jj_3_28() {
        if (jj_3R_47()) return true;
        return false;
    }

    private boolean jj_3_29() {
        if (jj_3R_48()) return true;
        return false;
    }

    private boolean jj_3_30() {
        if (jj_3R_49()) return true;
        return false;
    }

    private boolean jj_3_31() {
        if (jj_3R_50()) return true;
        return false;
    }

    private boolean jj_3_32() {
        if (jj_3R_51()) return true;
        return false;
    }

    private boolean jj_3_33() {
        if (jj_3R_52()) return true;
        return false;
    }

    private boolean jj_3_34() {
        if (jj_3R_53()) return true;
        return false;
    }

    private boolean jj_3_35() {
        if (jj_3R_54()) return true;
        return false;
    }

    private boolean jj_3_36() {
        if (jj_3R_55()) return true;
        return false;
    }

    private boolean jj_3_37() {
        if (jj_3R_56()) return true;
        return false;
    }

    private boolean jj_3_38() {
        if (jj_3R_57()) return true;
        return false;
    }

    private boolean jj_3_39() {
        if (jj_3R_58()) return true;
        return false;
    }

    private boolean jj_3_40() {
        Token token61=jj_scanpos;
        if (jj_3R_59()) {
            jj_scanpos=token61;
            if (jj_3R_60()) {
                jj_scanpos=token61;
                if (jj_3R_61()) {
                    jj_scanpos=token61;
                    if (jj_3R_62()) {
                        jj_scanpos=token61;
                        if (jj_3R_63()) return true;
                    }
                }
            }
        }
        return false;
    }

    private boolean jj_3_41() {
        Token token62=jj_scanpos;
        if (jj_scan_token(60)) jj_scanpos=token62;
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(FTL)) return true;
        return false;
    }

    private boolean jj_3R_23() {
        if (jj_3R_64()) return true;
        while (true) {
            Token token63=jj_scanpos;
            if (jj_3R_65()) {
                jj_scanpos=token63;
                break;
            }
        }
        return false;
    }

    private boolean jj_3R_24() {
        Token token64=jj_scanpos;
        if (jj_scan_token(51)) {
            jj_scanpos=token64;
            if (jj_3R_66()) {
                jj_scanpos=token64;
                if (jj_3R_67()) {
                    jj_scanpos=token64;
                    if (jj_3R_68()) {
                        jj_scanpos=token64;
                        if (jj_3R_69()) {
                            jj_scanpos=token64;
                            if (jj_scan_token(45)) {
                                jj_scanpos=token64;
                                if (jj_3R_70()) {
                                    jj_scanpos=token64;
                                    if (jj_3R_71()) {
                                        jj_scanpos=token64;
                                        if (jj_3R_72()) return true;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return false;
    }

    private boolean jj_3R_25() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(ELSEIF)) return true;
        return false;
    }

    private boolean jj_3R_26() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(ELSE)) return true;
        return false;
    }

    private boolean jj_3R_27() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(CASE)) return true;
        return false;
    }

    private boolean jj_3R_28() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(DEFAUL)) return true;
        return false;
    }

    private boolean jj_3R_29() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        Token token65=jj_scanpos;
        if (jj_scan_token(76)) {
            jj_scanpos=token65;
            if (jj_scan_token(94)) {
                jj_scanpos=token65;
                if (jj_scan_token(83)) {
                    jj_scanpos=token65;
                    if (jj_scan_token(93)) return true;
                }
            }
        }
        return false;
    }

    private boolean jj_3R_30() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(ATTEMPT)) return true;
        return false;
    }

    private boolean jj_3R_31() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(COMMENT)) return true;
        return false;
    }

    private boolean jj_3R_32() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(COMPRESS)) return true;
        return false;
    }

    private boolean jj_3R_33() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(EMBED)) return true;
        return false;
    }

    private boolean jj_3R_34() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(FOREACH)) return true;
        return false;
    }

    private boolean jj_3R_35() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(IF)) return true;
        return false;
    }

    private boolean jj_3R_36() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(LIST)) return true;
        return false;
    }

    private boolean jj_3R_37() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(_INCLUDE)) return true;
        return false;
    }

    private boolean jj_3R_38() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(IMPORT)) return true;
        return false;
    }

    private boolean jj_3R_39() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        Token token66=jj_scanpos;
        if (jj_scan_token(82)) {
            jj_scanpos=token66;
            if (jj_scan_token(98)) return true;
        }
        return false;
    }

    private boolean jj_3R_40() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(NOPARSE)) return true;
        return false;
    }

    private boolean jj_3R_41() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(SWITCH)) return true;
        return false;
    }

    private boolean jj_3R_42() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(SETTING)) return true;
        return false;
    }

    private boolean jj_3R_43() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(VAR)) return true;
        return false;
    }

    private boolean jj_3R_44() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(BREAK)) return true;
        return false;
    }

    private boolean jj_3R_45() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(RETURN)) return true;
        return false;
    }

    private boolean jj_3R_46() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(STOP)) return true;
        return false;
    }

    private boolean jj_3R_47() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(FLUSH)) return true;
        return false;
    }

    private boolean jj_3R_48() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(TRIM)) return true;
        return false;
    }

    private boolean jj_3R_49() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(NOTRIM)) return true;
        return false;
    }

    private boolean jj_3R_50() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(LTRIM)) return true;
        return false;
    }

    private boolean jj_3R_51() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(RTRIM)) return true;
        return false;
    }

    private boolean jj_3R_52() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        Token token67=jj_scanpos;
        if (jj_3R_73()) {
            jj_scanpos=token67;
            if (jj_3R_74()) {
                jj_scanpos=token67;
                if (jj_3R_75()) {
                    jj_scanpos=token67;
                    if (jj_3R_76()) return true;
                }
            }
        }
        return false;
    }

    private boolean jj_3R_53() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(NESTED)) return true;
        return false;
    }

    private boolean jj_3R_54() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(ESCAPE)) return true;
        return false;
    }

    private boolean jj_3R_55() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(NOESCAPE)) return true;
        return false;
    }

    private boolean jj_3R_56() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(VISIT)) return true;
        return false;
    }

    private boolean jj_3R_57() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(RECURSE)) return true;
        return false;
    }

    private boolean jj_3R_58() {
        if (jj_scan_token(FTL_DIRECTIVE_OPEN)) return true;
        if (jj_scan_token(FALLBACK)) return true;
        return false;
    }

    private boolean jj_3R_59() {
        if (jj_3R_77()) return true;
        return false;
    }

    private boolean jj_3R_60() {
        if (jj_3R_78()) return true;
        return false;
    }

    private boolean jj_3R_61() {
        if (jj_3R_79()) return true;
        return false;
    }

    private boolean jj_3R_62() {
        if (jj_3R_80()) return true;
        return false;
    }

    private boolean jj_3R_63() {
        if (jj_3R_81()) return true;
        return false;
    }

    private boolean jj_3R_64() {
        if (jj_3R_82()) return true;
        while (true) {
            Token token68=jj_scanpos;
            if (jj_3R_83()) {
                jj_scanpos=token68;
                break;
            }
        }
        return false;
    }

    private boolean jj_3R_65() {
        Token token69=jj_scanpos;
        if (jj_scan_token(16)) {
            jj_scanpos=token69;
            if (jj_scan_token(17)) return true;
        }
        if (jj_3R_64()) return true;
        return false;
    }

    private boolean jj_3R_66() {
        if (jj_3R_84()) return true;
        return false;
    }

    private boolean jj_3R_67() {
        if (jj_3R_85()) return true;
        return false;
    }

    private boolean jj_3R_68() {
        if (jj_3R_86()) return true;
        return false;
    }

    private boolean jj_3R_69() {
        if (jj_3R_87()) return true;
        return false;
    }

    private boolean jj_3R_70() {
        if (jj_3R_88()) return true;
        return false;
    }

    private boolean jj_3R_71() {
        if (jj_3R_89()) return true;
        return false;
    }

    private boolean jj_3R_72() {
        if (jj_3R_90()) return true;
        return false;
    }

    private boolean jj_3R_73() {
        if (jj_scan_token(BLOCKTRIM)) return true;
        return false;
    }

    private boolean jj_3R_74() {
        if (jj_scan_token(BLOCKTRIML)) return true;
        return false;
    }

    private boolean jj_3R_75() {
        if (jj_scan_token(BLOCKTRIMR)) return true;
        return false;
    }

    private boolean jj_3R_76() {
        if (jj_scan_token(BLOCKNOTRIM)) return true;
        return false;
    }

    private boolean jj_3R_77() {
        if (jj_3R_91()) return true;
        while (true) {
            Token token70=jj_scanpos;
            if (jj_3R_91()) {
                jj_scanpos=token70;
                break;
            }
        }
        return false;
    }

    private boolean jj_3R_78() {
        if (jj_scan_token(INTERPOLATE)) return true;
        if (jj_3R_92()) return true;
        return false;
    }

    private boolean jj_3R_79() {
        if (jj_scan_token(NUMERICAL_INTERPOLATE)) return true;
        if (jj_3R_92()) return true;
        return false;
    }

    private boolean jj_3R_80() {
        if (jj_scan_token(USER_DIRECTIVE_OPEN)) return true;
        if (jj_3R_92()) return true;
        return false;
    }

    private boolean jj_3R_81() {
        Token token71=jj_scanpos;
        if (jj_3_10()) {
            jj_scanpos=token71;
            if (jj_3_11()) {
                jj_scanpos=token71;
                if (jj_3_12()) {
                    jj_scanpos=token71;
                    if (jj_3_13()) {
                        jj_scanpos=token71;
                        if (jj_3_14()) {
                            jj_scanpos=token71;
                            if (jj_3_15()) {
                                jj_scanpos=token71;
                                if (jj_3_16()) {
                                    jj_scanpos=token71;
                                    if (jj_3_17()) {
                                        jj_scanpos=token71;
                                        if (jj_3_18()) {
                                            jj_scanpos=token71;
                                            if (jj_3_19()) {
                                                jj_scanpos=token71;
                                                if (jj_3_20()) {
                                                    jj_scanpos=token71;
                                                    if (jj_3_21()) {
                                                        jj_scanpos=token71;
                                                        if (jj_3_22()) {
                                                            jj_scanpos=token71;
                                                            if (jj_3_23()) {
                                                                jj_scanpos=token71;
                                                                if (jj_3_24()) {
                                                                    jj_scanpos=token71;
                                                                    if (jj_3_25()) {
                                                                        jj_scanpos=token71;
                                                                        if (jj_3_26()) {
                                                                            jj_scanpos=token71;
                                                                            if (jj_3_27()) {
                                                                                jj_scanpos=token71;
                                                                                if (jj_3_28()) {
                                                                                    jj_scanpos=token71;
                                                                                    if (jj_3_29()) {
                                                                                        jj_scanpos=token71;
                                                                                        if (jj_3_30()) {
                                                                                            jj_scanpos=token71;
                                                                                            if (jj_3_31()) {
                                                                                                jj_scanpos=token71;
                                                                                                if (jj_3_32()) {
                                                                                                    jj_scanpos=token71;
                                                                                                    if (jj_3_33()) {
                                                                                                        jj_scanpos=token71;
                                                                                                        if (jj_3_34()) {
                                                                                                            jj_scanpos=token71;
                                                                                                            if (jj_3_35()) {
                                                                                                                jj_scanpos=token71;
                                                                                                                if (jj_3_36()) {
                                                                                                                    jj_scanpos=token71;
                                                                                                                    if (jj_3_37()) {
                                                                                                                        jj_scanpos=token71;
                                                                                                                        if (jj_3_38()) {
                                                                                                                            jj_scanpos=token71;
                                                                                                                            if (jj_3_39()) return true;
                                                                                                                        }
                                                                                                                    }
                                                                                                                }
                                                                                                            }
                                                                                                        }
                                                                                                    }
                                                                                                }
                                                                                            }
                                                                                        }
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return false;
    }

    private boolean jj_3R_82() {
        Token token72=jj_scanpos;
        if (jj_3R_93()) {
            jj_scanpos=token72;
            if (jj_3R_94()) {
                jj_scanpos=token72;
                if (jj_3R_95()) return true;
            }
        }
        return false;
    }

    private boolean jj_3R_83() {
        Token token73=jj_scanpos;
        if (jj_scan_token(18)) {
            jj_scanpos=token73;
            if (jj_scan_token(19)) {
                jj_scanpos=token73;
                if (jj_scan_token(20)) return true;
            }
        }
        if (jj_3R_82()) return true;
        return false;
    }

    private boolean jj_3R_84() {
        Token token74=jj_scanpos;
        if (jj_scan_token(49)) {
            jj_scanpos=token74;
            if (jj_scan_token(50)) return true;
        }
        return false;
    }

    private boolean jj_3R_85() {
        if (jj_scan_token(OPEN_BRACE)) return true;
        Token token75=jj_scanpos;
        if (jj_3R_96()) jj_scanpos=token75;
        if (jj_scan_token(CLOSE_BRACE)) return true;
        return false;
    }

    private boolean jj_3R_86() {
        Token token76=jj_scanpos;
        if (jj_scan_token(54)) {
            jj_scanpos=token76;
            if (jj_scan_token(55)) return true;
        }
        return false;
    }

    private boolean jj_3R_87() {
        Token token77=jj_scanpos;
        if (jj_scan_token(46)) {
            jj_scanpos=token77;
            if (jj_scan_token(47)) return true;
        }
        return false;
    }

    private boolean jj_3R_88() {
        if (jj_scan_token(OPEN_BRACKET)) return true;
        Token token78=jj_scanpos;
        if (jj_3R_97()) jj_scanpos=token78;
        if (jj_scan_token(CLOSE_BRACKET)) return true;
        return false;
    }

    private boolean jj_3R_89() {
        if (jj_scan_token(OPEN_PAREN)) return true;
        if (jj_3R_92()) return true;
        if (jj_scan_token(CLOSE_PAREN)) return true;
        return false;
    }

    private boolean jj_3R_90() {
        if (jj_scan_token(DOT)) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        return false;
    }

    private boolean jj_3R_91() {
        Token token79=jj_scanpos;
        if (jj_scan_token(62)) {
            jj_scanpos=token79;
            if (jj_scan_token(60)) {
                jj_scanpos=token79;
                if (jj_scan_token(61)) return true;
            }
        }
        return false;
    }

    private boolean jj_3R_92() {
        if (jj_3R_98()) return true;
        return false;
    }

    private boolean jj_3R_93() {
        if (jj_3R_99()) return true;
        return false;
    }

    private boolean jj_3R_94() {
        if (jj_3R_100()) return true;
        return false;
    }

    private boolean jj_3R_95() {
        if (jj_3R_101()) return true;
        return false;
    }

    private boolean jj_3R_96() {
        if (jj_3R_92()) return true;
        if (jj_scan_token(COLON)) return true;
        if (jj_3R_92()) return true;
        while (true) {
            Token token80=jj_scanpos;
            if (jj_3R_102()) {
                jj_scanpos=token80;
                break;
            }
        }
        return false;
    }

    private boolean jj_3R_97() {
        if (jj_3R_92()) return true;
        while (true) {
            Token token81=jj_scanpos;
            if (jj_3R_103()) {
                jj_scanpos=token81;
                break;
            }
        }
        return false;
    }

    private boolean jj_3R_98() {
        if (jj_3R_104()) return true;
        while (true) {
            Token token82=jj_scanpos;
            if (jj_3R_107()) {
                jj_scanpos=token82;
                break;
            }
        }
        return false;
    }

    private boolean jj_3R_99() {
        Token token83=jj_scanpos;
        if (jj_scan_token(16)) {
            jj_scanpos=token83;
            if (jj_scan_token(17)) return true;
        }
        if (jj_3R_101()) return true;
        return false;
    }

    private boolean jj_3R_100() {
        if (jj_scan_token(EXCLAM)) return true;
        if (jj_3R_101()) return true;
        return false;
    }

    private boolean jj_3R_101() {
        if (jj_3R_105()) return true;
        while (true) {
            Token token84=jj_scanpos;
            if (jj_3R_106()) {
                jj_scanpos=token84;
                break;
            }
        }
        Token token85=jj_scanpos;
        if (jj_scan_token(28)) jj_scanpos=token85;
        return false;
    }

    private boolean jj_3R_102() {
        if (jj_scan_token(COMMA)) return true;
        if (jj_3R_92()) return true;
        if (jj_scan_token(COLON)) return true;
        if (jj_3R_92()) return true;
        return false;
    }

    private boolean jj_3R_103() {
        Token token86=jj_scanpos;
        if (jj_scan_token(25)) jj_scanpos=token86;
        if (jj_3R_92()) return true;
        return false;
    }

    private boolean jj_3R_104() {
        if (jj_3R_108()) return true;
        while (true) {
            Token token87=jj_scanpos;
            if (jj_3R_110()) {
                jj_scanpos=token87;
                break;
            }
        }
        return false;
    }

    private boolean jj_3R_105() {
        if (jj_3R_24()) return true;
        while (true) {
            Token token88=jj_scanpos;
            if (jj_3R_109()) {
                jj_scanpos=token88;
                break;
            }
        }
        return false;
    }

    private boolean jj_3R_106() {
        if (jj_scan_token(EXCLAM)) return true;
        if (jj_3R_105()) return true;
        return false;
    }

    private boolean jj_3R_107() {
        Token token89=jj_scanpos;
        if (jj_scan_token(21)) {
            jj_scanpos=token89;
            if (jj_scan_token(35)) return true;
        }
        if (jj_3R_104()) return true;
        return false;
    }

    private boolean jj_3R_108() {
        if (jj_3R_111()) return true;
        Token token90=jj_scanpos;
        if (jj_3R_116()) jj_scanpos=token90;
        return false;
    }

    private boolean jj_3R_109() {
        Token token91=jj_scanpos;
        if (jj_3R_112()) {
            jj_scanpos=token91;
            if (jj_3R_113()) {
                jj_scanpos=token91;
                if (jj_3R_114()) {
                    jj_scanpos=token91;
                    if (jj_3R_115()) {
                        jj_scanpos=token91;
                        if (jj_scan_token(32)) return true;
                    }
                }
            }
        }
        return false;
    }

    private boolean jj_3R_110() {
        Token token92=jj_scanpos;
        if (jj_scan_token(22)) {
            jj_scanpos=token92;
            if (jj_scan_token(36)) return true;
        }
        if (jj_3R_108()) return true;
        return false;
    }

    private boolean jj_3R_111() {
        if (jj_3R_117()) return true;
        Token token93=jj_scanpos;
        if (jj_3R_122()) jj_scanpos=token93;
        return false;
    }

    private boolean jj_3R_112() {
        if (jj_3R_118()) return true;
        return false;
    }

    private boolean jj_3R_113() {
        if (jj_3R_119()) return true;
        return false;
    }

    private boolean jj_3R_114() {
        if (jj_3R_120()) return true;
        return false;
    }

    private boolean jj_3R_115() {
        if (jj_3R_121()) return true;
        return false;
    }

    private boolean jj_3R_116() {
        Token token94=jj_scanpos;
        if (jj_scan_token(14)) {
            jj_scanpos=token94;
            if (jj_scan_token(30)) {
                jj_scanpos=token94;
                if (jj_scan_token(31)) return true;
            }
        }
        if (jj_3R_111()) return true;
        return false;
    }

    private boolean jj_3R_117() {
        if (jj_3R_23()) return true;
        Token token95=jj_scanpos;
        if (jj_3R_124()) jj_scanpos=token95;
        return false;
    }

    private boolean jj_3R_118() {
        if (jj_scan_token(DOT)) return true;
        Token token96=jj_scanpos;
        if (jj_scan_token(51)) {
            jj_scanpos=token96;
            if (jj_scan_token(18)) return true;
        }
        return false;
    }

    private boolean jj_3R_119() {
        if (jj_scan_token(OPEN_BRACKET)) return true;
        if (jj_3R_92()) return true;
        if (jj_scan_token(CLOSE_BRACKET)) return true;
        return false;
    }

    private boolean jj_3R_120() {
        if (jj_scan_token(OPEN_PAREN)) return true;
        Token token97=jj_scanpos;
        if (jj_3R_123()) jj_scanpos=token97;
        if (jj_scan_token(CLOSE_PAREN)) return true;
        return false;
    }

    private boolean jj_3R_121() {
        if (jj_scan_token(BUILT_IN)) return true;
        if (jj_scan_token(IDENTIFIER)) return true;
        return false;
    }

    private boolean jj_3R_122() {
        Token token98=jj_scanpos;
        if (jj_scan_token(24)) {
            jj_scanpos=token98;
            if (jj_scan_token(34)) {
                jj_scanpos=token98;
                if (jj_scan_token(23)) {
                    jj_scanpos=token98;
                    if (jj_scan_token(33)) {
                        jj_scanpos=token98;
                        if (jj_scan_token(38)) {
                            jj_scanpos=token98;
                            if (jj_scan_token(42)) {
                                jj_scanpos=token98;
                                if (jj_scan_token(43)) {
                                    jj_scanpos=token98;
                                    if (jj_scan_token(39)) return true;
                                }
                            }
                        }
                    }
                }
            }
        }
        if (jj_3R_117()) return true;
        return false;
    }

    private boolean jj_3R_123() {
        if (jj_3R_125()) return true;
        return false;
    }

    private boolean jj_3R_124() {
        if (jj_scan_token(DOT_DOT)) return true;
        Token token99=jj_scanpos;
        if (jj_3R_126()) jj_scanpos=token99;
        return false;
    }

    private boolean jj_3R_125() {
        Token token100=jj_scanpos;
        if (jj_3R_127()) {
            jj_scanpos=token100;
            if (jj_3R_128()) return true;
        }
        return false;
    }

    private boolean jj_3R_126() {
        if (jj_3R_23()) return true;
        return false;
    }

    private boolean jj_3R_127() {
        if (jj_3R_129()) return true;
        return false;
    }

    private boolean jj_3R_128() {
        if (jj_3R_130()) return true;
        return false;
    }

    private boolean jj_3R_129() {
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(EQUALS)) return true;
        if (jj_3R_92()) return true;
        while (true) {
            Token token101=jj_scanpos;
            if (jj_3R_131()) {
                jj_scanpos=token101;
                break;
            }
        }
        return false;
    }

    private boolean jj_3R_130() {
        if (jj_3R_92()) return true;
        while (true) {
            Token token102=jj_scanpos;
            if (jj_3R_132()) {
                jj_scanpos=token102;
                break;
            }
        }
        return false;
    }

    private boolean jj_3R_131() {
        Token token103=jj_scanpos;
        if (jj_scan_token(25)) jj_scanpos=token103;
        if (jj_scan_token(IDENTIFIER)) return true;
        if (jj_scan_token(EQUALS)) return true;
        if (jj_3R_92()) return true;
        return false;
    }

    private boolean jj_3R_132() {
        Token token104=jj_scanpos;
        if (jj_scan_token(25)) jj_scanpos=token104;
        if (jj_3R_92()) return true;
        return false;
    }

}
